#!/usr/bin/python
'''ActiveBoards to SMF 1.1 Converter by nneonneo
Version 0.3.0
Members, Topics and Posts
Dec 17 2007
Updated Apr 1 2011'''
import re,sys,random
from time import strptime,strftime,mktime,time,localtime
try:
    from settings import *
except Exception, detail:
    print "Error: Settings file has some error."
    print "Details of the error:"
    sys.excepthook(*sys.exc_info())
    raw_input("Press <enter> to quit.")
    sys.exit(1)
sys.path.append('..')
from common import *

# Don't edit below here [unless you know exactly what you are doing]
members_max_group = 500
topics_max_group = 500
posts_max_group = 200
beg_time=time()

BOARDS = {}
for b in AB_BOARDS:
    BOARDS[str(b)]=AB_BOARDS[b]

re_locked=re.compile(re.escape(' title="Are you sure you want to open this thread?">Open</option>')+"|"+
re.escape('<nobr><i>Closed</i></nobr></div>'))
re_sticky=re.escape(' title="">Un-sticky</option>') # can't see sticky if you can't moderate.

# topics by board [board maps to topic list]
topicslist={}

# members [maps member names to ids]
memberslist={'0':0} # 0 is not a real user; this is the "guest" account

# map old topicids to new ones; format '%i/%s'%(topicid,board):newid
topicmap={}

# page detection
re_pages=re.compile(r'''<select id='itemPageIndex.+?(\d+)</option></select> of \1''')

# thread ID detection
thread_search=re.compile(r'<a href="[^"]*/forum\.spark\?aBID=%i&topicID=(\d+)&p=3[^"]*" class="[^"]*topictitle"[^>]*>.*?</a>[\w\W]*?<td class="topic-views[^>]*>\s*<span class="postdetails">(\d+)</span>'%FORUMID)

# blog post detection
thread_blog_search=re.compile(r'<b>Comments:</b> <a href="[^"]*/forum\.spark\?aBID=%i&topicID=(\d+)&p=3[^"]*">[\w\W]*<b>Views:</b> (\\d+)'%FORUMID)

# member detection
member_search=re.compile(r'<a href="[^"]*/forum\.spark\?aBID=%i&p=20&memberID=(\d+)"'%FORUMID)

# the massive grep list of doom!
# the grep list works by changing certain things to delimited, structured data. The delimiters are "<^>" at the start and "</^>" at the end of a record, and the fields are separated with "<|>".
# first one: detection of the exact forum we're in
repstrings=[
# detect the title of the topic
(r'TOPIC: ([^<]+?)(?:</div>)?\s*</th>\s*</tr>', '<^>TITLE<|>\\1</^>'),
# re hack: replace "unreg" with a registered user, id 0. RE doesn't work right :(
(r'<div class="comment-meta">\s*([^<\s]*)\s*</div>\s*<br>', '<div class="comment-meta"><a href="/forum.spark?aBID=%i&memberID=0&p=20">\\1</a></div><br>'%FORUMID),
# !!! the big one: get the entire post: memberid|membername|date|title|post
(r'<a id="comment-[^"]*"></a>\s*<div class="comment-meta">\s*<a href="[^"]*/forum\.spark\?aBID=%i&memberID=(\d+)&p=20">(.*?)</a>\s*</div>\s*<br>[\w\W]*?<span class="postdetails">Date: ([^<]+?)</span>[\w\W]*?<div class="comment-body postbody">\s*<br>\s*([\w\W]*?)\s*<br><br>\s*</div>\s*(?:</td>\s*</tr>|<table)'%FORUMID,"""<^>POST<|>\\1<|>\\2<|>\\3<|>not_used<|>\\4</^>"""),
# clarify the edit-by information; this gets added as optional extra fields
("""<small><i>-- Edited by *([^<]+?) on [^ ]+ (\\d+).. of ([^<]+?)</i></small></\\^>""","""<|>EDIT<|>\\1<|>\\2 \\3</^>"""),
("""<small><i>-- Edited by *([^<]+?) at *([^<]+?)</i></small></\\^>""","""<|>EDIT<|>\\1<|>\\2</^>"""),
# add a "<^>" tag to the end of the file - acts like the start of a tag
("""\\Z""","""<^>"""),
# and a "</^>" tag to the beginning - like the end of a tag
("""\\A""","""</^>"""),
# delete everything between the tags (blank space) leaving only the tags
("""</\\^>[\\w\\W]*?<\\^>""","""</^><^>"""),
# kill duplicate data from subsequent pages
("""POST<\\|>(.+)\\nTITLE<\\|>.+""","""POST<|>\\1"""),
# convert emotes
("""(?i)<img [^>]*src="[^"]+/([^"]+?)\\...." alt="\\1\\...."[^>]*/>""",""" :\\1: """),
# convert image links
("""(?i)<img [^>]*src="([^"]+?)"[^>]*>""","""[img]\\1[/img]"""),
# destroy any blank lines
("""^\\n""",""""""),
# and remove the blank line at the end.
("""\\n\\Z""",""""""),
# quotes: no author
("""<q>""","[quote]"),
("""</q>""","[/quote]"),
# quotes: author
("""<blockquote><(?:b|strong)>(.+?) wrote:</(?:b|strong)><hr[^>]*><br[^>]*><[pi]>""","[quote author=\\1]"),
("""</[pi]><br[^>]*><hr[^>]*></blockquote><br[^>]*><p>(?:&nbsp;)?</p>""","[/quote]"),
# b,i,u,s,pre,sub,sup,tt.center tags
("<(/?([biusBIUS]|pre|su[bp]|tt|center))>","[\\1]"),
# em, strong -> i, b
("<em>", "[i]"), ("</em>", "[/i]"),
("<strong>", "[b]"), ("</strong>", "[/b]"),
# strike -> [s]
("<(/?s)trike>","[\\1]"),
# marquee -> [move]
("<(/?m)arquee>","[\\1ove]"),
# fix nested URLs [autogen by ProBoards]
("""<a href="([^"]+?)"[^>]*?><a href="\\1"[^>]*?>\\1</a></a>""","""[url]\\1[/url]"""),
# convert URL links - run twice to catch weirdness...
("""<a [^>]*href="([^"]+?)"[^>]*?>(?:<u>)?(.+?)(?:</u>)?</a>""","""[url=\\1]\\2[/url]"""),
("""<a [^>]*href="([^"]+?)"[^>]*?>(?:<u>)?(.+?)(?:</u>)?</a>""","""[url=\\1]\\2[/url]"""),
# hr [horizontal line]
("""<hr[^>]*?>""","[hr]"),
# emails
("""<a href="mailto: ([^"]+?)">(?:<u>)?(.+?)(?:</u>)?</a>""","""[email=\\1]\\2[/email]"""),
# list tags
("<ol>","[list type=decimal]"), # ordered, defaults to 1,2,3
("<ol type='1'>","[list type=decimal]"), # ordered, 1,2,3
("<ol type='a'>","[list type=lower-alpha]"), # ordered, a,b,c
("<ol type='A'>","[list type=upper-alpha]"), # ordered, A,B,C
("<ol type='i'>","[list type=lower-roman]"), # ordered, i,ii,iii
("<ol type='I'>","[list type=upper-roman]"), # ordered, I,II,III
("<ul>","[list]"), # unordered
("</[ou]l>","[/list]"), # closing tags
("<li>","[*]"), # this one is a BIG WTF?? -- AB fails to close their LI tags...maybe it's permissible, but I call hacks.
# colours
('<span style="color: ([^"]+)">',"[color=\\1]"),
('</span>',"[/color]"),
# br fix
('<br>|<BR>', '<br />'),
# youtube (use with http://custom.simplemachines.org/mods/index.php?mod=936 or compatible)
('<object width="(\d+)" height="(\d+)"><param name="movie" value="([^"]+)"></param><embed src="\\3" type="application/x-shockwave-flash" width="\\1" height="\\2"></embed></object>','[youtube=\\1,\\2]\\3[/youtube]'),
# spoiler (use with http://custom.simplemachines.org/mods/index.php?mod=195 or compatible)
(re.escape('<dl id="spoilerdl$" style="border: 1px dotted #000; padding: 5px; margin-left: 20px; margin-right: 20px; margin-bottom: 5px;"><dt id="spoilerdt$" style="font-size: 1.4em">Spoiler<input type="button" style="margin-left: 20px; width: 100px;" id="spoilerreveal$" onclick="document.getElementById(\'spoilee$\').style.display=\'block\';document.getElementById(\'spoilerhide$\').style.display=\'inline\';document.getElementById(\'spoilerreveal$\').style.display = \'none\';" value="Reveal"/><input type="button" id="spoilerhide$" onclick="document.getElementById(\'spoilee$\').style.display=\'none\';document.getElementById(\'spoilerhide$\').style.display=\'none\';document.getElementById(\'spoilerreveal$\').style.display = \'inline\';" style="display: none;margin-left: 20px; width: 100px;" value="Hide"/></dt><dd style="display: none; clear: both; margin-left: 0px; margin-top: 5px; padding-top: 5px; border-top: 1px dotted #000;" id="spoilee$">').replace('\$','\d+')+'(.+?)</dd></dl>',"[spoiler]\\1[/spoiler]"),
]
re_repstrings=[]
for a,b in repstrings: re_repstrings+=[(re.compile(a),b)] # compile all search patterns for increased efficiency; replace patterns aren't normal grep so they can't be compiled

def parsetime(tm,fmt='%H:%M:%S %m/%d %Y'): # glorious time parser, returns the UNIX time-since-epoch-in-seconds thing ;)
    try:
        return mktime(strptime(tm,'%d %B %Y %I:%M:%S %p'))
    except ValueError:
        return mktime(strptime(tm,fmt))

postid=1
topicdata,postdata={},[]
block_size=4096

print "Downloading Memberlist..."
''' This section downloads and processes the memberlist from the "Members" link at the top.'''
membersfound=set()
try:
    statusline="Members ... "
    progressline=statusline+"Downloading - "
    pagedata=download_page(URL+'?aBID=%i&p=22'%FORUMID, progressline, COOKIEDATA)
    pages=re.findall(re_pages,pagedata)
    if pages:
        np=int(pages[0])
        for offset in range(1,np):
            progressline=statusline+"Downloading Page %i of %i - "%(offset+1,np)
            pagedata+=download_page(URL+'?aBID=%i&p=22'%FORUMID+'&page='+str(offset), progressline, COOKIEDATA)
    printline(statusline+"Finding Members")
    membersfound=set(re.findall(member_search,pagedata))
    printline(statusline+"Completed!")
    print # blank line for next board
except Exception:
    do_except('Memberlist',statusline)

''' This section will download each individual member page and process it, extracting
all the visible profile data. Members will then be renumbered according to join date
so that the member order matches the order obtained if they had signed up in SMF.'''

print "Downloading Members..."
out=open('members_smf.sql','w')
out.write('TRUNCATE TABLE `'+table_prefix+'members`;')
PM_data=open('pm_passwords.txt','w')
memberdata=[]
for memberid in membersfound:
    try:
        if memberid=='0': continue
        random.seed(RANDOMNUMBER+hash(memberid)) # creates static member passwords: they will never change.
        statusline="Member %s ... "%memberid
        userdata=download_page(URL+'?aBID=%i&p=20'%FORUMID+'&memberID='+str(memberid), statusline+"Downloading Page 1 - ",COOKIEDATA)
        editdata=download_page(URL+'?aBID=%i&p=21'%FORUMID+'&memberID='+str(memberid), statusline+"Downloading Page 2 - ",COOKIEDATA)
        userdata=re.sub("""<a href="mailto: (.+?)" title="Send mail">[^<]+</a>""","""\\1""",userdata) # e-mails
        p=re.findall('''<tr>
			<td class="gen" width="30%">
				([^<>\\n]+?)			</td>
			<td class="gen">
				(.*?)			</td>
		</tr>''',userdata) # locate all info lines
        p+=re.findall(r'''<input [^>]*name='ei(Email)'[^>]*value="([^"]*)"''', editdata)
        if not p: # oops, no profile lines found
            printline(statusline+"Warning: Member doesn't exist!")
            print
            continue
        """
        Indices of "dat" mapped to SMF smf_members columns
        0:ID_MEMBER
        1:memberName
        2:realName
        3:emailAddress
        4:websiteTitle
        5:websiteUrl
        6:birthdate
        7:gender
        8:location
        9:posts
        10:karmaGood <-- warning, could be negative; I wonder how that's handled?
        11:dateRegistered
        12:ICQ
        13:AIM
        14:YIM
        15:MSN
        16:lastLogin
        17:passwd
        18:avatar
        19:ID_GROUP
        20:ID_POST_GROUP
        """
        dat=[0,'','','','','','0001-01-01',0,'',0,0,0,'','','','',0,'','',0,0]
        dat[1]=str(memberid)
        dat[2]=re.findall('''<h2 style="margin:0;">([^>]*)</h2>''', userdata)[0]
        dat[18]=(re.findall('''			<tr>
				<td style="height:130px;">
					<img [^>]*border="0" src="([^"]+)"  / >				</td>
			</tr>''',userdata) or [''])[0]
        if int(memberid) in ADMINS:
            dat[19]=1
        else:
            dat[19]=0 # where are the groups??

        for t,i in p:
            try:
                t=t.strip(':')
                i=i.strip()
                if t=='Full Name': pass #dat[2]=i # rarely filled in, not used as forum name
                elif t=='Email':
                    if i!='<i>hidden</i>':
                        if i.endswith(' (hidden)'): i=i[:-9]
                        dat[3]=i
                elif t=='Homepage': dat[5],dat[4]=re.findall("""<a href="(.+?)" target=_blank>(.+?)</a>""",i)[0]
                elif t=='Birthday':
                    try:
                        dat[6]=strftime('%Y-%m-%d',localtime(parsetime(i)))
                    except ValueError:
                        dat[6]=i # heh, heh... >:D
                elif t in ['Gender','Sex']: dat[7]={'Undisclosed':0,'Male':1,'M':1,'F':2,'Female':2}.get(i,0)
                elif t=='Location': dat[8]=i
                elif t=='Messages Posted': dat[9]=int(i.replace(',',''))
                elif t=='Karma': dat[10]=int(i.replace(',',''))
                elif t=='Member Since': dat[11]=int(parsetime(i))
                elif t=='ICQ': dat[12]=re.findall("""<a href=".+?">(.+?)</a>""",i)[0]
                elif t=='AIM': dat[13]=re.findall("""<a href=".+?">(.+?)</a>""",i)[0]
                elif t=='YIM': dat[14]=re.findall("""<a href=".+?">(.+?)</a>""",i)[0]
                elif t=='MSN': dat[15]=i
                elif t=='Last Access':
                    if i=='N/A':
                        dat[16] = 0 # "never"
                    elif i=='Online':
                        dat[16] = int(time()) # "now"
                    else:
                        dat[16] = int(parsetime(i))
                elif t=='Age': pass
                elif t=='Status': pass
                elif t=='Private Messaging': pass
                elif t=='Last Known IP': pass # I don't want to convert this; SMF can figure it out when they log in
                elif t=='Country': pass
                elif t=='Country Name': pass
                else:
                    print # blank line; prevent overwrite
                    print "\tUnknown field %s, data %s"%(t,i)
            except ValueError,detail:
                print # blank line to prevent overwrite
                print "\tError:",detail
        printline(statusline+"Processing")
        password=randpw()
        dat[17]=md5hex(password)
        dat[20]=postgroup(dat[9]) # compute post group AFTER we've got the posts
        memberdata+=[dat]
        PM_data.write("%s|%s\n"%(memberid,password))
        printline(statusline+"Completed! User Password: %s"%password)
        print # blank line for next member
    except KeyboardInterrupt: break # abort processing, write out data now
    except Exception:
        do_except('Member ID %s'%memberid,statusline)
memberdata.sort(key=lambda x:x[11]) # sort by date registered
for i,dat in enumerate(memberdata):
    memberdata[i][0]=i+1
    memberslist[dat[1]]=i+1
    memberdata[i][1]=memberdata[i][2]
memberdata=[escape_vars(i) for i in memberdata]
for i in range(0,len(memberdata),members_max_group):
    out.write("INSERT INTO `"+table_prefix+"members` (`ID_MEMBER`,`memberName`,`realName`,`emailAddress`,`websiteTitle`,`websiteUrl`,`birthdate`,`gender`,`location`,`posts`,`karmaGood`,`dateRegistered`,`ICQ`,`AIM`,`YIM`,`MSN`,`lastLogin`,`passwd`,`passwordSalt`,`avatar`,`ID_GROUP`,`ID_POST_GROUP`) VALUES ")
    out.write(',\n'.join(["(%i,'%s','%s','%s','%s','%s','%s',%i,'%s',%i,%i,%i,'%s','%s','%s','%s',%i,'%s','','%s',%i,%i)"%tuple(dat) for dat in memberdata[i:i+members_max_group]]))
    out.write(";\n")
PM_data.close()
out.close()


''' Now that we're done with the members, lets do the boards.
Boards are ID-coded, while topics are coded by another ID.
This section will download each board and gather all the topics within.
At the same time, it will map topics to a renumbering scheme in order of ID.'''
print "Downloading Boards..."
for board in BOARDS:
    try:
        statusline="Board %s ... "%board
        progressline=statusline+"Downloading - "
        pagedata=download_page(URL+'?aBID=%i&p=2'%FORUMID+'&subForumID='+board, progressline, COOKIEDATA)
        pages=re.findall(re_pages,pagedata)
        if pages:
            np=int(pages[0])
            for offset in range(1,np):
                progressline=statusline+"Downloading Extra Page %i of %i - "%(offset,np-1)
                pagedata+=download_page(URL+'?aBID=%i&p=2'%FORUMID+'&subForumID='+board+'&page='+str(offset+1), progressline, COOKIEDATA)
        printline(statusline+"Finding Topics")
        added_topics=re.findall(thread_search,pagedata)
        if not added_topics: # maybe its a blog forum?
            added_topics=re.findall(thread_blog_search,pagedata)
        topicslist[board]=[(int(topic_id),int(views)) for topic_id,views in added_topics]
        printline(statusline+"Completed: %i topic%s"%(len(added_topics),int(len(added_topics)!=1)*'s'))
        print # blank line for next board
    except Exception:
        do_except('Board ID %s'%board, statusline)
topictemp=[]
for board in topicslist:
    topictemp+=[(i,board) for i,_ in topicslist[board]]
topictemp = sorted(set(topictemp), key=lambda x:x[0]) # sort by date [ID] only
for i,(topicid,board) in enumerate(topictemp):
    topicmap['%i/%s'%(topicid,board)]=i+1


''' This section will go through the topic IDs found before and download each topic.
The data is then processed and distilled into posts via the multiple regex's above.'''
print "Downloading Topics and Posts..."
topicseen = set()
for board in topicslist:
    for topicid,viewcount in topicslist[board]:
        if (topicid, board) in topicseen: continue
        topicseen.add((topicid, board))
        try:
            statusline="Topic %i, Board %s ... "%(topicid,board)
            progressline=statusline+"Downloading - "
            pagedata=download_page(URL+'?aBID=%i&p=3'%FORUMID+'&topicID=%i'%topicid, progressline, COOKIEDATA)
            pages=re.findall(re_pages,pagedata)
            if pages:
                np=int(pages[0])
                for offset in range(1,np):
                    progressline=statusline+"Downloading Page %i of %i - "%(offset+1,np) # 2 of 3, 3 of 3
                    pagedata+=download_page(URL+'?aBID=%i&p=3'%FORUMID+'&topicID=%i'%topicid+'&page=%i'%(offset+1), progressline, COOKIEDATA)
            processed_data=pagedata
#           file("%i.txt"%topicid,"w").write(processed_data)
            cn=0
            for search,repl in re_repstrings:
                cn+=1
                printline(statusline+"Processing Step %i of %i"%(cn,len(re_repstrings)))
                processed_data=re.sub(search,repl,processed_data)
#               file("%i_%i.txt"%(topicid,cn),"w").write(processed_data)
            printline(statusline+"Converting Topic")
            forum,title=BOARDS[board],''
            posts=[] # will hold tuples of (time,id,userid,name,edittime,editname,data)
            '''   0    1       2         3         4     5    6    7         8            '''
            '''<^>POST|User ID|User Name|Date/Time|Title|Text|EDIT|Edit Name|Edit Time</^>'''
            ''' 0    1  2      3    4        5        6    7     '''
            '''(time,id,userid,name,edittime,editname,data,title)'''
            for line in processed_data.split('</^><^>'):
                ln=line.strip()
                if not ln: continue
                ln=ln.split('<|>')
                if ln[0]=='TITLE':
                    title=ln[1]
                    continue
                elif ln[0]=='POST':
                    #memberid|membername|date|title|post
                    post=[0,0,0,'',0,'','',title]
                    if len(ln)==9:
                        if ln[6]=='EDIT':
                            post[4]=parsetime(ln[8], "%H:%M, %Y-%m-%d")
                            post[5]=ln[7]
                    post[0]=post[1]=parsetime(ln[3]) # h4xh4xh4x
                    if ln[1]: post[2]=memberslist.get(ln[1],0)
                    post[3]=re.sub('<format_tag color="[^"]+">','',ln[2].replace('</format_tag>','')) # begone, format tags!
                    if not post[3]:
                        post[3]='Anonymous'
                    post[6]=ln[5].strip()
                    #post[7]=ln[4].strip()
                    selflinks=re.findall("%s\\?board=([a-zA-Z0-9]+?)&action=display&thread=(\\d+)"%URL,post[6])
                    for link in selflinks:
                        try: post[6]=post[6].replace("%s?board=%s&action=display&thread=%s"%(URL,link[0],link[1]),"?topic="+str(topicmap['%s/%s'%(link[1],link[0])]))
                        except KeyError: continue
                    '''
                    selflinks=re.findall("%s\\?action=viewprofile&username=([a-zA-Z0-9]+)"%URL,post[6])
                    for link in selflinks:
                        post[6]=post[6].replace("%s?action=viewprofile&username=%s"%(URL,link),"?action=profile;u="+str(memberslist.get(link,0)))
                    '''
                    posts+=[post]
            if not posts:
                printline(statusline+"Error: Topic is empty!")
                print # a blank line, for the next topic
                continue
            posts.sort(key=lambda x:x[0]) # sort by date code only
            # This is for SMF
            ''' `ID_TOPIC` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,`
                `isSticky` tinyint(4) NOT NULL DEFAULT '0',
                `ID_BOARD` smallint(5) unsigned NOT NULL DEFAULT '0',
                `ID_FIRST_MSG` int(10) unsigned NOT NULL DEFAULT '0',
                `ID_LAST_MSG` int(10) unsigned NOT NULL DEFAULT '0',
                `ID_MEMBER_STARTED` mediumint(8) unsigned NOT NULL DEFAULT '0',
                `ID_MEMBER_UPDATED` mediumint(8) unsigned NOT NULL DEFAULT '0',
                `ID_POLL` mediumint(8) unsigned NOT NULL DEFAULT '0',
                `numReplies` int(10) unsigned NOT NULL DEFAULT '0',
                `numViews` int(10) unsigned NOT NULL DEFAULT '0',
                `locked` tinyint(4) NOT NULL DEFAULT '0'
                '''
            topicid=topicmap['%i/%s'%(topicid,board)] # map the topic id so that we get a "real" topic ID, not a date code
            # change this for a different forum
            topicdata[topicid]=[topicid,int(bool(re.findall(re_sticky,pagedata))),forum,posts[0][1],posts[-1][1],posts[0][2],posts[-1][2],len(posts)-1,viewcount,int(bool(re.findall(re_locked,pagedata)))]
            for post in posts:
                ''' `ID_MSG` int(10) unsigned NOT NULL AUTO_INCREMENT,
                    `ID_TOPIC` mediumint(8) unsigned NOT NULL DEFAULT '0',
                    `ID_BOARD` smallint(5) unsigned NOT NULL DEFAULT '0',
                    `posterTime` int(10) unsigned NOT NULL DEFAULT '0',
                    `ID_MEMBER` mediumint(8) unsigned NOT NULL DEFAULT '0',
                    `ID_MSG_MODIFIED` mediumint(8) unsigned NOT NULL DEFAULT '0',
                    `subject` tinytext NOT NULL,
                    `posterName` tinytext NOT NULL,
                    `posterEmail` tinytext NOT NULL,
                    `posterIP` tinytext NOT NULL,
                    `smileysEnabled` tinyint(4) NOT NULL DEFAULT '1',
                    `modifiedTime` int(10) unsigned NOT NULL DEFAULT '0',
                    `modifiedName` tinytext NOT NULL,
                    `body` text NOT NULL,
                    `icon` varchar(16) NOT NULL DEFAULT 'xx'
                    '''
                ''' 0    1  2      3    4        5        6    '''
                '''(time,id,userid,name,edittime,editname,data)'''
                # change this for a different forum
                postdata+=[[post[1],topicid,forum,post[0],post[2],post[1],post[7],post[3],post[4],post[5],post[6]]]
            printline(statusline+"Completed: %i post%s"%(len(posts),int(len(posts)!=1)*'s'))
            print # blank line for next topic
        except KeyboardInterrupt: break # abort processing this board
        except Exception:
            do_except('Topic ID %s in Board %s'%(topicid, board), statusline)
# POST ID RENUMBERING - WITHOUT THIS SMF WILL SORT YOUR POSTS STRANGELY
print "Renumbering Posts"
postdata.sort(key=lambda x:x[3]) # sort by date [4th value; index 3]
postid=1
postmap={}
for i,pd in enumerate(postdata): # i will be index, pd will be the data
    oldid=pd[0] # save old id
    postdata[i][0]=postid # set new ID_MSG
    postdata[i][5]=postid # set new ID_MSG_MODIFIED
    if topicdata[pd[1]][3]==oldid: topicdata[pd[1]][3]=postid # check ID_FIRST_MSG
    if topicdata[pd[1]][4]==oldid: topicdata[pd[1]][4]=postid # check ID_LAST_MSG
    postmap['%i/%i'%(pd[1],oldid)]=postid
    postid+=1
# END RENUMBERING
out=open('topics_posts_smf.sql','w')
out.write('TRUNCATE TABLE `%stopics`;TRUNCATE TABLE `%smessages`;'%(table_prefix,table_prefix))
# change these two for a different forum
topicdata_vals=[escape_vars(i) for i in topicdata.values()]
postdata=[escape_vars(i) for i in postdata]
for i in range(0,len(topicdata_vals),topics_max_group):
    out.write('INSERT INTO `%stopics` (`ID_TOPIC`,`isSticky`,`ID_BOARD`,`ID_FIRST_MSG`,`ID_LAST_MSG`,`ID_MEMBER_STARTED`,`ID_MEMBER_UPDATED`,`ID_POLL`,`numReplies`,`numViews`,`locked`) VALUES '%table_prefix)
    out.write(',\n'.join(["(%i,%i,%i,%i,%i,%i,%i,0,%i,%i,%i)"%tuple(dat) for dat in topicdata_vals[i:i+topics_max_group]]))
    out.write(";\n")
for i in range(0,len(postdata),posts_max_group):
    out.write('INSERT INTO `%smessages` (`ID_MSG`,`ID_TOPIC`,`ID_BOARD`,`posterTime`,`ID_MEMBER`,`ID_MSG_MODIFIED`,`subject`,`posterName`,`posterEmail`,`posterIP`,`smileysEnabled`,`modifiedTime`,`modifiedName`,`body`,`icon`) VALUES '%table_prefix)
    out.write(',\n'.join(["(%i,%i,%i,%i,%i,%i,'%s','%s','','unknown',1,%i,'%s','%s','xx')"%tuple(dat) for dat in postdata[i:i+posts_max_group]]))
    out.write(";\n")
out.close()
print 'Elapsed Conversion Time %.02f seconds' % (time() - beg_time)
print 'Converted',len(postdata),'posts and',len(topicdata),'topics.'
raw_input("Complete! Press <enter> to exit.")
