#!/usr/bin/python

# ---GLOBAL SETTINGS---

# Prefix of your forum tables (default smf_ for SMF, phpbb_ for phpBB)
table_prefix='smf_'

# Is the board a simple board (no subforums)?
# If so, set this to "True".
# "False" means multiple boards (subforums, categories, etc.)
AB_BOARD_IS_SIMPLE = False

if AB_BOARD_IS_SIMPLE:
	# If the board is simple, map the single board onto an SMF board
	# 1 is the ID of the destination board on SMF/phpBB.
	AB_BOARDS={0:1}
else:
	# If the board has multiple subforums, map the boards onto SMF boards.
	# This variable is a "map" of ActiveBoard board subForumIDs to SMF/phpBB board IDs.
	# Format: {1234:1,5678:3} where 1234,5678 are the ActiveBoard IDs and 1,3
	# represent the IDs of the corresponding boards on your new forum.
	AB_BOARDS={1234:1,5678:3}

# PLACE COOKIE DATA HERE.
# Visit the forum, login and type "javascript:document.cookie" (w/o quotes) into the address bar. Copy all the text to COOKIEDATA and put single quotes (') around it.
COOKIEDATA='COOKIE DATA GOES HERE BETWEEN THE QUOTES'

# ForumID value
FORUMID=12345

# URL (probably doesn't need to be changed)
URL='http://www.activeboard.com/forum.spark'

# ---MEMBER SETTINGS---

# A random number, used to seed the password generator. You'll want to keep this a secret! CHANGE THIS.
# Keep this the same across runs, because this ensures that the same passwords
# are assigned to the same people.
RANDOMNUMBER=12345678

# Here, define the postgroup based groups.
def postgroup(posts):
	if posts>=500: return 8 # Hero Member
	if posts>=250: return 7 # Sr. Member
	if posts>=100: return 6 # Full Member
	if posts>=50: return 5 # Jr. Member
	return 4 # Newbie

# Administrators (member ids only please!): e.g. ADMINS=[18983,38821]
ADMINS=[]

# ---PERSONAL MESSAGE SETTINGS---

# Wait time between successive PMs. Admins can set this to zero; everyone else must use
# a non-zero value (default 2 seconds)
waittime=0

# Title for the new automated password messages
msgtitle="Password for New Forums"

# What to say. Place "%s" (without quotes) at the location you want the password to be.
# Use "%%0A" (without quotes) in place of a line break.
msgbody="We've moved! Your password for the new forums at [url]http://yournewforums.com[/url] is %s.%%0A%%0AAfter logging in, please change your password!%%0A%%0A[sm]This is an automated message.[/sm]"

if __name__=='__main__':
	raw_input("This is not meant to be run. Please edit this file and follow the instructions. Press <enter> to close.")