#!/usr/bin/python
'''ChatArea to SMF 1.1 Converter by nneonneo
Version 0.0.1
Members, Topics and Posts
Dec 24 2008
Updated Dec 24 2008

Based off the ActiveBoards converter'''
import re,sys,random
from time import strptime,mktime,time
try:
    from settings import *
except Exception, detail:
    print "Error: Settings file has some error."
    print "Details of the error:"
    sys.excepthook(*sys.exc_info())
    raw_input("Press <enter> to quit.")
    sys.exit(1)
sys.path.append('..')
from common import *

# Don't edit below here [unless you know exactly what you are doing]
members_max_group = 500
topics_max_group = 500
posts_max_group = 200
beg_time=time()

BOARDS = {}
for b in CA_BOARDS:
    BOARDS[str(b)]=CA_BOARDS[b]

re_locked=re.compile('''<ACRONYM title="Click here to close this topic. Administrators, Moderators & Original Poster Only">Open Thread</ACRONYM>|<span class="toolbarlinkslarge">\\s*<b>Topic Closed</b>&nbsp;''')

re_sticky=re.compile('<a href="%s\\.unsticky\\d+">unSticky</a>'%SOCNAME) # can't see sticky if you can't moderate.

# topics by board [board maps to topic list]
topicslist={}

# members [maps member names to ids]
memberslist={'0':0} # 0 is not a real user; this is the "guest" account

# map old topicids to new ones; format '%i/%s'%(topicid,board):newid
topicmap={}

# page detection
re_pages_topics=re_pages_posts=re.compile('''Page 1 of (\\d+): <b>1</b>''')

# thread ID detection
thread_search=re.compile('''(\\[Sticky\\]&nbsp;\\s*|)<a href="%s\\.m(\\d+)">.+?</a>.+\\s*</td>\\s*<td class="[^"]*">\\d+</td>\\s*<td class="[^"]*">(\\d+)</td>'''%SOCNAME)

# member detection
member_search=re.compile('''<tr class="listing">\\s*<td><a href="/%s\\.profile(\\d+)">.+?</a></td><td>(\\d+)</td><td>.+?</td><td>(.+?)</td>'''%SOCNAME)

# the massive grep list of doom!
# the grep list works by changing certain things to delimited, structured data. The delimiters are "<^>" at the start and "</^>" at the end of a record, and the fields are separated with "<|>".
# first one: detection of the exact forum we're in
repstrings=[("""<forum_id=(\\d+)>""","""<^>FORUM<|>\\1</^>"""),
# !!! get the lead post
('<tr><td[^>]*><font[^>]*><a href="'+SOCNAME+'\\.profile(\\d+)"[^>]*>(.+?)</a>[\\w\\W]*?(<p><i><font[^>]*>This message was updated on .+? by .+?</font></i></p>|)<br /><br /></td><td[^>]*><font[^>]*><b>(?:<b>)?(.+?)(?:</b>)?<br /><small>posted on: (.+?)(?:</b><br /><b>IP: .+?)?</b></small></font><hr noshade size=1><font[^>]*>([\\w\\W]*?)(?:</font></td></tr>|<br /><br /><form method="post" action="/post_info.asp">|<br /><br /></font><span class="pollresulttitle">)','<^>POST<|>\\1<|>\\2<|>\\5<|>\\4<|>\\6<^EDIT^>\\3</^>'),
# !!! get replies
('<tr>\\s*<td[^>]*>\\s*<font[^>]*>\\s*<a href="'+SOCNAME+'\\.profile(\\d+)"[^>]*>(.+?)</a>[\\w\\W]*?(<P><i><font[^>]*>This message was updated on .+? by .+?</font></i></p>|)\\s*</td>\\s*<td[^>]*>\\s*<font[^>]*>\\s*<b>\\s*(.+?)\\s*<br />\\s*<small>\\s*replied on: (.+?)(?:<br />IP: .+)?\\s*</small>\\s*</b>\\s*</font>\\s*<hr noshade size=1>\\s*<font[^>]*>\\s*([\\w\\W]*?)\\s*</font>\\s*</td>\\s*</tr>','<^>POST<|>\\1<|>\\2<|>\\5<|>\\4<|>\\6<^EDIT^>\\3</^>'),
# edit info
("""<\\^EDIT\\^></\\^>""","""</^>"""),
("""<\\^EDIT\\^>(?:<[pP]><i><font[^>]*>)?This message was updated on (.*?) by (.*?)</font></i></p></\\^>""","""<|>EDIT<|>\\2<|>\\1</^>"""),
# add a "<^>" tag to the end of the file - acts like the start of a tag
("""\\Z""","""<^>"""),
# and a "</^>" tag to the beginning - like the end of a tag
("""\\A""","""</^>"""),
# delete everything between the tags (blank space) leaving only the tags
("""</\\^>[\\w\\W]*?<\\^>""","""</^><^>"""),
# kill duplicate data from subsequent pages
("""POST<\\|>(.+)\\nTITLE<\\|>.+""","""POST<|>\\1"""),
# destroy any blank lines
("""^\\n""",""""""),
# and remove the blank line at the end.
("""\\n\\Z""",""""""),
# emoticons
]+[('<img src="/images/%s.gif" width=15 height=15 border=0>'%k,v) for k,v in [('smile',':)'),('tongue',':P'),('sad',':('),('wink',';)'),('happy',':D')]]+[
# images
('<img src=([^"][^>]*)>','[img]\\1[/img]'),
# convert URL links
('<a href=([^>]*?) target=_blank>(.*?)</a>','[url=\\1]\\2[/url]'),
# b,i,u,s,pre,center
("<(/?([bius]|pre|center))>","[\\1]"),
# quotes
("<BLOCKQUOTE><font size=1>quote:<hr height=1 noshade>","[quote]"),
("<hr height=1 noshade></font></BLOCKQUOTE>","[/quote]"),
# list tags
("<ol>","[list type=decimal]"), # ordered, 1,2,3
("<ul>","[list]"), # unordered
("</[ou]l>","[/list]"), # closing tags
("<li>","[li]"), # list item
("</li>","[/li]"),
]
re_repstrings=[]
for a,b in repstrings: re_repstrings+=[(re.compile(a),b)] # compile all search patterns for increased efficiency; replace patterns aren't normal grep so they can't be compiled

def parsetime(tm,fmt='%m/%d/%Y %I:%M:%S %p'): # glorious time parser, returns the UNIX time-since-epoch-in-seconds thing ;)
    return mktime(strptime(tm,fmt))

postid=1
topicdata,postdata={},[]
block_size=4096

print "Downloading Memberlist..."
''' This section downloads and processes the memberlist from the "Members" link at the top.'''
membersfound={} # memberid:(posts,joindate)
try:
    statusline="Members ... "
    progressline=statusline+"Downloading - "
    pagedata=download_page(URL+SOCNAME+'/members', progressline, COOKIEDATA)
    printline(statusline+"Finding Members")
    for memberid, posts, joindate in re.findall(member_search,pagedata):
        membersfound[memberid]=(posts,joindate)
    printline(statusline+"Completed!")
    print # blank line for next section
except Exception:
    do_except('Memberlist',statusline)

''' This section will download each individual member page and process it, extracting
all the visible profile data. Members will then be renumbered according to join date
so that the member order matches the order obtained if they had signed up in SMF.'''

print "Downloading Members..."
out=open('members_smf.sql','w')
out.write('TRUNCATE TABLE `'+table_prefix+'members`;')
PM_data=open('pm_passwords.txt','w')
memberdata=[]
for memberid in membersfound:
    try:
        if memberid=='0': continue
        random.seed(RANDOMNUMBER+hash(memberid)) # creates static member passwords: they will never change.
        statusline="Member %s ... "%memberid
        userdata=download_page(URL+SOCNAME+'.profile'+str(memberid), statusline+"Downloading - ",COOKIEDATA)
        p=re.findall('''<div id="[^"]*"><span class="title">([^<>\\n]+?)</span> *<span class="[^"]*">(.*?)</span></div>''',userdata) # locate all info lines
        if not p: # oops, no profile lines found
            printline(statusline+"Warning: Member doesn't exist!")
            print
            continue
        """
        Indices of "dat" mapped to SMF smf_members columns
        0:ID_MEMBER
        1:memberName
        2:realName
        3:emailAddress
        4:websiteTitle
        5:websiteUrl
        6:birthdate
        7:gender
        8:location
        9:posts
        10:karmaGood <-- warning, could be negative; I wonder how that's handled?
        11:dateRegistered
        12:ICQ
        13:AIM
        14:YIM
        15:MSN
        16:lastLogin
        17:passwd
        18:avatar
        19:ID_GROUP
        20:ID_POST_GROUP
        """
        dat=[0,'','','','','','0001-01-01',0,'',0,0,0,'','','','',0,'','',0,0]
        dat[1]=str(memberid)
        dat[2]=re.findall('''<div id="headeruserprofile">\\s*<span class="headertitle1">Viewing User Profile for: (.+?)</span>\\s*</div>''',userdata)[0]
        dat[9], dat[11]=membersfound[memberid] # posts, date joined
        dat[9]=int(dat[9])
        dat[11]=int(parsetime(dat[11]))
        if int(memberid) in ADMINS:
            dat[19]=1
        else:
            dat[19]=0 # where are the groups??

        for t,i in p:
            try:
                t=t.strip(':')
                i=i.strip()
                if i=='None': continue
                if t=='First Name': pass #dat[2]=i # rarely filled in, not used as forum name
                elif t=='Last Name': pass
                elif t=='Email': pass # goes to a e-mail form; e-mail address is always hidden
                elif t=='Favorite Link': dat[5],dat[4]=re.findall("""<a href="(.+?)" target="_blank">(.+?)</a>""",i)[0]
                elif t=='Country': dat[8]=i
                elif t=='Member Since': pass # this is the time when the user joined ChatArea, not when they joined the forum
                elif t=='ICQ': dat[12]=i
                elif t=='AOL': dat[13]=i
                elif t=='Yahoo': dat[14]=i
                elif t=='MSN': dat[15]=i
                elif t=='Last Seen': dat[16]=int(parsetime(i))
                elif t=='Private Message': pass
                else:
                    print # blank line; prevent overwrite
                    print "\tUnknown field %s, data %s"%(t,i)
            except ValueError,detail:
                print # blank line to prevent overwrite
                print "\tError:",detail
        printline(statusline+"Processing")
        password=randpw()
        dat[17]=md5hex(password)
        dat[20]=postgroup(dat[9]) # compute post group AFTER we've got the posts
        memberdata+=[dat]
        PM_data.write("%s|%s\n"%(dat[2],password))
        printline(statusline+"Completed! User Password: %s"%password)
        print # blank line for next member
    except KeyboardInterrupt: break # abort processing, write out data now
    except Exception:
        do_except('Member ID %s'%memberid,statusline)
memberdata.sort(key=lambda x:x[11]) # sort by date registered
for i,dat in enumerate(memberdata):
    memberdata[i][0]=i+1
    memberslist[dat[1]]=i+1
    memberdata[i][1]=memberdata[i][2]
memberdata=[escape_vars(i) for i in memberdata]
for i in range(0,len(memberdata),members_max_group):
    out.write("INSERT INTO `"+table_prefix+"members` (`ID_MEMBER`,`memberName`,`realName`,`emailAddress`,`websiteTitle`,`websiteUrl`,`birthdate`,`gender`,`location`,`posts`,`karmaGood`,`dateRegistered`,`ICQ`,`AIM`,`YIM`,`MSN`,`lastLogin`,`passwd`,`passwordSalt`,`avatar`,`ID_GROUP`,`ID_POST_GROUP`) VALUES ")
    out.write(',\n'.join(["(%i,'%s','%s','%s','%s','%s','%s',%i,'%s',%i,%i,%i,'%s','%s','%s','%s',%i,'%s','','%s',%i,%i)"%tuple(dat) for dat in memberdata[i:i+members_max_group]]))
    out.write(";\n")
PM_data.close()
out.close()


''' Now that we're done with the members, lets do the boards.
Boards are ID-coded, while topics are coded by another ID.
This section will download each board and gather all the topics within.
At the same time, it will map topics to a renumbering scheme in order of ID.'''
print "Downloading Boards..."
for board in BOARDS:
    try:
        statusline="Board %s ... "%board
        progressline=statusline+"Downloading - "
        pagedata=download_page(URL+SOCNAME+'.f'+board, progressline, COOKIEDATA)
        pages=re.findall(re_pages_topics,pagedata)
        if pages:
            np=int(pages[0])
            for offset in range(1,np):
                progressline=statusline+"Downloading Extra Page %i of %i - "%(offset,np-1)
                pagedata+=download_page(URL+SOCNAME+'.f'+board+'-'+str(offset+1), progressline, COOKIEDATA)
        printline(statusline+"Finding Topics")
        added_topics=re.findall(thread_search,pagedata)
        topicslist[board]=[(int(topic_id),int(views),bool(is_sticky)) for is_sticky,topic_id,views in added_topics]
        printline(statusline+"Completed: %i topic%s"%(len(added_topics),int(len(added_topics)!=1)*'s'))
        print # blank line for next board
    except Exception:
        do_except('Board ID %s'%board, statusline)
topictemp=[]
for board in topicslist:
    topictemp+=[(i,board) for i,_,_ in topicslist[board]]
topictemp.sort(key=lambda x:x[0]) # sort by date [ID] only
for i,(topicid,board) in enumerate(topictemp):
    topicmap['%i/%s'%(topicid,board)]=i+1


''' This section will go through the topic IDs found before and download each topic.
The data is then processed and distilled into posts via the multiple regex's above.'''
print "Downloading Topics and Posts..."
postid=1
for board in topicslist:
    for topicid,viewcount,is_sticky in topicslist[board]:
        try:
            statusline="Topic %i, Board %s ... "%(topicid,board)
            progressline=statusline+"Downloading - "
            pagedata=download_page(URL+SOCNAME+'.m%i'%topicid, progressline, COOKIEDATA)
            pages=re.findall(re_pages_posts,pagedata)
            if pages:
                np=int(pages[0])
                for offset in range(1,np):
                    progressline=statusline+"Downloading Page %i of %i - "%(offset+1,np) # 2 of 3, 3 of 3
                    pagedata+=download_page(URL+SOCNAME+'.m%i'%topicid+'-'+str(offset+1), progressline, COOKIEDATA)
            processed_data=pagedata
            processed_data='  <forum_id=%i>'%BOARDS[board]+processed_data
#           file("%i.txt"%topicid,"w").write(processed_data)
            cn=0
            for search,repl in re_repstrings:
                cn+=1
                printline(statusline+"Processing Step %i of %i"%(cn,len(re_repstrings)))
                processed_data=re.sub(search,repl,processed_data)
#               file("%i_%i.txt"%(topicid,cn),"w").write(processed_data)
            printline(statusline+"Converting Topic")
            forum,title=0,''
            posts=[] # will hold tuples of (time,id,userid,name,edittime,editname,data)
            '''   0    1       2         3         4     5    6    7         8            '''
            '''<^>POST|User ID|User Name|Date/Time|Title|Text|EDIT|Edit Name|Edit Time</^>'''
            ''' 0    1  2      3    4        5        6    7     '''
            '''(time,id,userid,name,edittime,editname,data,title)'''
            for line in processed_data.split('</^><^>'):
                ln=line.strip()
                if not ln: continue
                ln=ln.split('<|>')
                if ln[0]=='FORUM':
                    forum=int(ln[1])
                    continue
                elif ln[0]=='POST':
                    post=[0,0,0,'',0,'','',title]
                    if len(ln)==9:
                        if ln[6]=='EDIT':
                            post[4]=parsetime(ln[8])
                            post[5]=ln[7]
                    post[0]=parsetime(ln[3])
                    post[1]=postid
                    if ln[2]: post[2]=memberslist.get(ln[1],0)
                    post[3]=ln[2].strip()
                    post[6]=ln[5].strip()
                    post[7]=ln[4].strip()
                    if not title:
                        title=post[7]
                    postid+=1
                    posts+=[post]
            if not posts:
                printline(statusline+"Error: Topic is empty!")
                print # a blank line, for the next topic
                continue
            posts.sort(key=lambda x:x[0]) # sort by date code only
            # This is for SMF
            ''' `ID_TOPIC` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,`
                `isSticky` tinyint(4) NOT NULL DEFAULT '0',
                `ID_BOARD` smallint(5) unsigned NOT NULL DEFAULT '0',
                `ID_FIRST_MSG` int(10) unsigned NOT NULL DEFAULT '0',
                `ID_LAST_MSG` int(10) unsigned NOT NULL DEFAULT '0',
                `ID_MEMBER_STARTED` mediumint(8) unsigned NOT NULL DEFAULT '0',
                `ID_MEMBER_UPDATED` mediumint(8) unsigned NOT NULL DEFAULT '0',
                `ID_POLL` mediumint(8) unsigned NOT NULL DEFAULT '0',
                `numReplies` int(10) unsigned NOT NULL DEFAULT '0',
                `numViews` int(10) unsigned NOT NULL DEFAULT '0',
                `locked` tinyint(4) NOT NULL DEFAULT '0'
                '''
            topicid=topicmap['%i/%s'%(topicid,board)] # map the topic id so that we get a "real" topic ID, not a date code
            # change this for a different forum
            topicdata[topicid]=[topicid,int(bool(re.findall(re_sticky,pagedata)) or is_sticky),forum,posts[0][1],posts[-1][1],posts[0][2],posts[-1][2],len(posts)-1,viewcount,int(bool(re.findall(re_locked,pagedata)))]
            for post in posts:
                ''' `ID_MSG` int(10) unsigned NOT NULL AUTO_INCREMENT,
                    `ID_TOPIC` mediumint(8) unsigned NOT NULL DEFAULT '0',
                    `ID_BOARD` smallint(5) unsigned NOT NULL DEFAULT '0',
                    `posterTime` int(10) unsigned NOT NULL DEFAULT '0',
                    `ID_MEMBER` mediumint(8) unsigned NOT NULL DEFAULT '0',
                    `ID_MSG_MODIFIED` mediumint(8) unsigned NOT NULL DEFAULT '0',
                    `subject` tinytext NOT NULL,
                    `posterName` tinytext NOT NULL,
                    `posterEmail` tinytext NOT NULL,
                    `posterIP` tinytext NOT NULL,
                    `smileysEnabled` tinyint(4) NOT NULL DEFAULT '1',
                    `modifiedTime` int(10) unsigned NOT NULL DEFAULT '0',
                    `modifiedName` tinytext NOT NULL,
                    `body` text NOT NULL,
                    `icon` varchar(16) NOT NULL DEFAULT 'xx'
                    '''
                ''' 0    1  2      3    4        5        6    '''
                '''(time,id,userid,name,edittime,editname,data)'''
                # change this for a different forum
                postdata+=[[post[1],topicid,forum,post[0],post[2],post[1],post[7],post[3],post[4],post[5],post[6]]]
            printline(statusline+"Completed: %i post%s"%(len(posts),int(len(posts)!=1)*'s'))
            print # blank line for next topic
        except KeyboardInterrupt: break # abort processing this board
        except Exception:
            do_except('Topic ID %s in Board %s'%(topicid, board), statusline)
# POST ID RENUMBERING - WITHOUT THIS SMF WILL SORT YOUR POSTS STRANGELY
print "Renumbering Posts"
postdata.sort(key=lambda x:x[3]) # sort by date [4th value; index 3]
postid=1
postmap={}
for i,pd in enumerate(postdata): # i will be index, pd will be the data
    oldid=pd[0] # save old id
    postdata[i][0]=postid # set new ID_MSG
    postdata[i][5]=postid # set new ID_MSG_MODIFIED
    if topicdata[pd[1]][3]==oldid: topicdata[pd[1]][3]=postid # check ID_FIRST_MSG
    if topicdata[pd[1]][4]==oldid: topicdata[pd[1]][4]=postid # check ID_LAST_MSG
    postmap['%i/%i'%(pd[1],oldid)]=postid
    postid+=1
# END RENUMBERING
out=open('topics_posts_smf.sql','w')
out.write('TRUNCATE TABLE `%stopics`;TRUNCATE TABLE `%smessages`;'%(table_prefix,table_prefix))
# change these two for a different forum
topicdata_vals=[escape_vars(i) for i in topicdata.values()]
postdata=[escape_vars(i) for i in postdata]
for i in range(0,len(topicdata_vals),topics_max_group):
    out.write('INSERT INTO `%stopics` (`ID_TOPIC`,`isSticky`,`ID_BOARD`,`ID_FIRST_MSG`,`ID_LAST_MSG`,`ID_MEMBER_STARTED`,`ID_MEMBER_UPDATED`,`ID_POLL`,`numReplies`,`numViews`,`locked`) VALUES '%table_prefix)
    out.write(',\n'.join(["(%i,%i,%i,%i,%i,%i,%i,0,%i,%i,%i)"%tuple(dat) for dat in topicdata_vals[i:i+topics_max_group]]))
    out.write(";\n")
for i in range(0,len(postdata),posts_max_group):
    out.write('INSERT INTO `%smessages` (`ID_MSG`,`ID_TOPIC`,`ID_BOARD`,`posterTime`,`ID_MEMBER`,`ID_MSG_MODIFIED`,`subject`,`posterName`,`posterEmail`,`posterIP`,`smileysEnabled`,`modifiedTime`,`modifiedName`,`body`,`icon`) VALUES '%table_prefix)
    out.write(',\n'.join(["(%i,%i,%i,%i,%i,%i,'%s','%s','','unknown',1,%i,'%s','%s','xx')"%tuple(dat) for dat in postdata[i:i+posts_max_group]]))
    out.write(";\n")
out.close()
print 'Elapsed Conversion Time %.02f seconds' % (time() - beg_time)
print 'Converted',len(postdata),'posts and',len(topicdata),'topics.'
raw_input("Complete! Press <enter> to exit.")
