#!/usr/bin/python
'''Forumer-IPB to phpBB 2 Converter by nneonneo
Based heavily on the Invisionfree converter
Version 0.2.0
Topics and Posts Part
Nov 8 2009
Updated Dec 12 2009'''
import os,re,sys,random
from time import strptime,mktime,time
try:
    from settings import *
except Exception, detail:
    print "Error: Settings file has some error."
    print "Details of the error:"
    sys.excepthook(*sys.exc_info())
    raw_input("Press <enter> to quit.")
    sys.exit(1)
sys.path.append('..')
from common import *

# Use fixed BBCode UIDs.
random.seed(RANDOMNUMBER)

# Don't edit this file, unless you are SURE you know what you are doing.
topics_max_group = 500
posts_max_group = 200
sys.setrecursionlimit(100000) # safety
t=time()
img_locked="<img src='%s' border='0'  alt='Closed Topic' />"%lockimage
re_pages=re.compile(',(\\d+)\\);">Pages:</a> \\((\\d+)\\)') # page detection
re_topics=re.compile("<a href='javascript:who_posted\\((\\d+)\\);'>[^<]*</a></td>\\s*<td align='center' class='row.'>\\s*([\\d,]+)\\s*</td>")
re_cat=re.compile("<div id='navstrip' align='left'>.+<a href='"+URL+"\\?act=SC&amp;c=(\\d+)'>([^<]+?)</a>.+</div>\\n<br />")
# the massive grep list of doom!
# the grep list works by changing certain things to delimited, structured data. The delimiters are "<^>" at the start and "</^>" at the end of a record, and the fields are separated with "<|>".
# first one: detection of the exact forum we're in
repstrings=[("""<div id='navstrip' align='left'>.+<a href='"""+URL+"""\\?showforum=(\\d+)'>[^<]+?</a>(?:<!--|</div>)""","""<^>FORUM<|>\\1</^>"""),
# detect the title of the topic
("""<title>.+? -> (.+?)</title>""","""<^>TITLE<|>\\1</^>"""),
# re hack: replace "unreg" with a registered user, id 0. RE doesn't work right :(
("""<span class='unreg'>(.+?)</span>""","""<span class='normalname'><a href='nonexistanturl?showuser=0'>\\1</a></span>"""),
# !!! the big one: get the entire post
("""<!--Begin Msg Number (\\d+)-->[\\w\\W]+?<span class='normalname'><a href='.+?\\?showuser=(\\d+)'>(?:<span .+?>)?(.+)(?:</span>)?</a>[\\w\\W]+?\"text-decoration:underline\">Posted(?::| on)</a></b> ([^<]+)</span>[\\w\\W]+?<!-- THE POST \\1 -->\\n +<div class='postcolor'>([\\w\\W]+?)<!-- THE POST -->""","""<^>POST<|>\\1<|>\\2<|>\\3<|>\\4<|>\\5</^>"""),
# OLD - ("""<!--Begin Msg Number (\\d+)-->[\\w\\W]+?<span class='(?:normalname'><a href='.+?\\?showuser=(\\d+)|unreg)'>(?:<.+?>)?([^<]+)<[\\w\\W]+?\"text-decoration:underline\">Posted(?::| on)</a></b> ([^<]+)</span>[\\w\\W]+?<!-- THE POST \\1 -->\\n +<div class='postcolor'>([\\w\\W]+?)<!-- THE POST -->""","""<^>POST|\\1|\\2|\\3|\\4|\\5</^>"""),
# add a "<^>" tag to the end of the file - acts like the start of a tag
("""\\Z""","""<^>"""),
# and a "</^>" tag to the beginning - like the end of a tag
("""\\A""","""</^>"""),
# delete everything between the tags (blank space) leaving only the tags
("""</\\^>[\\w\\W]+?<\\^>""","""</^><^>"""),
# clean up the post, remove the div bit at the end and the trailing spaces
(""" ? </div>\\n        \\n        """,""""""),
# kill duplicate data from subsequent pages
("""(.)\\nTITLE<\\|>.+\\nFORUM<\\|>\\d+""","""\\1"""),
# remove attachments
("""<br />\\n<strong><span class='edit'>Attached (?:File \\( Number of downloads: \\d+ \\)|Image \\(Click thumbnail to expand\\))[\\w\\W]+? {8}\\n {8}\\n""",""""""),
# clarify the edit-by information; this gets added as optional extra fields
("""<br /><br /><span class='edit'>This post has been edited by <b>(.+?)</b> on (.+?)</span>""","""<|>EDIT<|>\\1<|>\\2"""),
# convert image links
("""\\(IMG:<a href='(.+?)' target='_blank'>.+?</a>\\)""","""[img:<UID>]\\1[/img:<UID>]"""),
# clean up quotes somewhat for easier quote processing
("""</div><table border='0' align='center' width='95%' cellpadding='3' cellspacing='1'><tr><td><b>QUOTE</b>.*?</td></tr><tr><td id='QUOTE'>""",""""""),
# emails - phpBB autoparses valid emails.
("""<a href='mailto:(.+?)'>(?:<u>)?(.+?)(?:</u>)?</a>""",""" \\1 """),
# convert URL links
("""<a href='(.+?)' target='_blank'>(?:<u>)?(.+?)(?:</u>)?</a>""","""[url=\\1]\\2[/url]"""),
# destroy any blank lines
("""^\\n""",""""""),
# and remove the blank line at the end.
("""\\n\\Z""",""""""),
# code tags
("<!--c1--></div><table border='0' align='center' width='95%' cellpadding='3' cellspacing='1'><tr><td><b>CODE</b> </td></tr><tr><td id='CODE'><!--ec1-->","[code:1:<UID>]"),
("<!--c2--></td></tr></table><div class='postcolor'><!--ec2-->","[/code:1:<UID>]"),
# sql tags - converted into <pre> tags
("<!--sql--></div><table border='0' align='center' width='95%' cellpadding='3' cellspacing='1'><tr><td><b>SQL</b> </td></tr><tr><td id='CODE'><!--sql1-->","<pre>"),
("<!--sql2--></td></tr></table><div class='postcolor'><!--sql3-->","</pre>"),
# html tags - converted into <pre> tags
("<!--html--></div><table border='0' align='center' width='95%' cellpadding='3' cellspacing='1'><tr><td><b>HTML</b> </td></tr><tr><td id='CODE'><!--html1-->","<pre>"),
("<!--html2--></td></tr></table><div class='postcolor'><!--html3-->","</pre>"),
# b,i,u tags
("<(/?[biu])>","""[\\1:<UID>]"""),
# list tags
("<ol type='([1aA])'>","[list=\\1:<UID>]"), # ordered, phpBB doesn't support i or I
("<ul>","[list:<UID>]"), # unordered
("</([ou])l>","[/list:\\1:<UID>]"), # closing tags
("<li>","[*:<UID>]"), # list item
("</li>","")] # end tag not required
re_repstrings=[]
for a,b in repstrings: re_repstrings+=[(re.compile(a),b)] # compile all search patterns for increased efficiency; replace patterns aren't normal grep so they can't be compiled

def parsetime(tm,fmt='%B %d, %Y %I:%M %p'): # glorious time parser, returns the UNIX time-since-epoch-in-seconds thing ;)
    return mktime(strptime(tm,fmt))

def parsespans(dat):
    '''<span style='font-family:Courier'><span style='font-size:14pt;line-height:100%'><span style='color:#468212'>PWNAGE</span></span></span>'''
    '''[font=Courier][SIZE=7][color=#468212]PWNAGE[/SIZE][/color][/font]'''
    '''[pre][size=14pt][color=#468212]PWNAGE[/size][/color][/pre]'''
    sb="<span"
    se='</span>'
    begin_off=dat.find(sb)
    if begin_off==-1: return dat # no spans!
    out=dat[:begin_off] # data right up to the span
    rest=dat[begin_off+len(sb):] # the remainder, after the sb block
    lwrrest=rest.lower()
    if lwrrest.startswith(" style='font-size:"):
        type="size"
        starttag='[size='+rest[len(" style='font-size:"):].split("pt;")[0]+':<UID>]'
        endtag='[/size:<UID>]'
    elif lwrrest.startswith(" style='color:"):
        type="color"
        tagparams=rest[len(" style='color:"):]
        sc=tagparams.find(';')
        ap=tagparams.find("'")
        if sc!=-1 and (sc<ap or ap==-1): starttag='[color='+tagparams.split(";")[0]+':<UID>]'
        else: starttag='[color='+tagparams.split("'")[0]+':<UID>]'
        endtag='[/color:<UID>]'
    else:
        starttag=endtag=type=''
    spandata=starttag
    se_off=rest.find(">") # nearest span ending
    if se_off==-1:
        print "Warning: Invalid <span> found!!"
        return dat
    rest=rest[se_off+1:] # what's after the > ?
    text=rest
    nestlevel=1 # nesting level: we're inside one span
    while nestlevel:
        se_off=rest.find(se) # where's the </span>
        sb_off=rest.find(sb) # or another <span
        if se_off==-1: 
            print "Warning: No </span> found!!"
            return dat
        if sb_off==-1 or se_off<sb_off: # no new beginning (sb) before the se? good news!
            nestlevel-=1
            rest=rest[se_off+len(se):]
            continue
        elif sb_off!=-1 and sb_off<se_off: # a new beginning? darn. process it. new beginning must be before the end.
            rest=rest[sb_off+len(sb):] 
            nestlevel+=1 # increase nesting level, we won't actually process it, this just helps us find the exact block of this span
            continue
    spandata+=parsespans(text[:-(len(rest)+len(se))])+endtag # gotcha! the end of the span. Now, process the innards for nested spans.
    spandata+=parsespans(rest) # parse the rest
    return out+spandata

def parsequotes(dat):
    '''<div class='postcolor'>  <!--QuoteBegin-penwwh+--></div><table border='0' align='center' width='95%' cellpadding='3' cellspacing='1'><tr><td><b>QUOTE</b> (penwwh)</td></tr><tr><td id='QUOTE'><!--QuoteEBegin-->hmm<!--QuoteBegin--></div><table border='0' align='center' width='95%' cellpadding='3' cellspacing='1'><tr><td><b>QUOTE</b> </td></tr><tr><td id='QUOTE'><!--QuoteEBegin-->test<!--QuoteEnd--></td></tr></table><div class='postcolor'><!--QuoteEEnd-->lol<!--QuoteEnd--></td></tr></table><div class='postcolor'><!--QuoteEEnd--><br><!--QuoteBegin--></div><table border='0' align='center' width='95%' cellpadding='3' cellspacing='1'><tr><td><b>QUOTE</b> </td></tr><tr><td id='QUOTE'><!--QuoteEBegin-->txx<!--QuoteEnd--></td></tr></table><div class='postcolor'><!--QuoteEEnd--><br><!--QuoteBegin--></div><table border='0' align='center' width='95%' cellpadding='3' cellspacing='1'><tr><td><b>QUOTE</b> </td></tr><tr><td id='QUOTE'><!--QuoteEBegin-->tx2<!--QuoteEnd--></td></tr></table><div class='postcolor'><!--QuoteEEnd-->  </div></div>'''
    '''[quote]hmm[quote]test[/quote]lol[/quote]
[quote]txx[/quote]
[quote]tx2[/quote]'''
    qb='<!--QuoteBegin'
    qeb='<!--QuoteEBegin-->'
    qe='<!--QuoteEnd-->'
    qee='<!--QuoteEEnd-->'
    begin_off=dat.find(qb)
    if begin_off==-1: return dat # no quotes!
    out=dat[:begin_off] # data right up to the quote
    rest=dat[begin_off+len(qb):] # the remainder, after the qb block
    quotedata='[quote:<UID>' # quotedata stores the quote information that we will put in
    if not rest.startswith('-->'):
        rest=rest[1:]
        plus=rest.find('+') # different kinds of separators =\
        at=rest.find(' @ ')
        date=''
        x=[]
        if at!=-1 and (plus==-1 or at<plus): # which separator is first????
            x=rest.split(' @ ',1)
        else:
            x=rest.split('+',1)
        quotedata+='="'+x[0]+'"' # this may need to change for different forum software; use '='+x[0] if your quotes are like [quote=quoteauthorman]
        date=x[1].split('-->',1)[0].replace('+',',').replace(' @ ',', ').strip(', ').replace('<br />','')
    quotedata+=']'
    qeb_off=rest.find(qeb) # nearest quoteebegin
    if qeb_off==-1:
        print "Warning: No QuoteEBegin block found!!"
        return dat
    rest=rest[qeb_off+len(qeb):] # what's after the qeb?
    text=rest
    nestlevel=1 # nesting level: we're inside one quote
    while nestlevel:
        qe_off=rest.find(qe) # where's the qe
        qeb_off=rest.find(qeb) # or do we have another qeb nested
        if qe_off==-1: 
            print "Warning: No QuoteEnd found!!"
            return dat
        if qeb_off==-1 or qe_off<qeb_off: # no new beginning (qeb) before the quoteend? good news!
            nestlevel-=1
            rest=rest[qe_off+len(qe):]
            continue
        elif qeb_off!=-1 and qeb_off<qe_off: # a new beginning? darn. process it. new beginning must be before the end.
            rest=rest[qeb_off+len(qeb):] 
            nestlevel+=1 # increase nesting level, we won't actually process it, this just helps us find the exact block of this quote
            continue
    quotedata+=parsequotes(text[:-(len(rest)+len(qe))].strip())+'[/quote:<UID>]' # gotcha! the end of the quote. Now, process the innards for nested quotes.
    qee_off=rest.find(qee) # locate the QuoteEEnd, and parse from that point.
    if qee_off!=-1:
        quotedata+=parsequotes(rest[qee_off+len(qee):].strip())
    return out+quotedata

postid=1
topicdata,postdata={},[]
topicviews={}
block_size=4096
forum_stats={} # topics, posts, latest_post_id, latest_post_time; this will store forum stats so we can update the DB with that information.
categories={}

print "Downloading Forum Structure..."
out=open("categories_forums_phpBB.sql","w")
out.write('TRUNCATE TABLE `'+table_prefix+'forums`; TRUNCATE TABLE `'+table_prefix+'categories`;\n')
for forumid in range(1,NUMFORUMS+1):
    try:
        statusline="Forum %s ... "%forumid
        progressline=statusline+"Downloading - "
        pagedata=download_page(URL+'?showforum='+str(forumid)+'&prune_day=100', progressline, COOKIEDATA)
        titles=re.findall("""<title>.+? -> (.+?)</title>""",pagedata)
        if not titles:
            continue # error accessing forum...
        title=titles[0]
        cats=re.findall(re_cat,pagedata)
        if cats:
            catid,cattitle=cats[0]
            catid=int(catid)
        else:
            catid,cattitle=255,"Lost category"
        categories[catid]=cattitle
        pages=re.findall(re_pages,pagedata)
        if pages:
            perpage=int(pages[0][0])
            np=int(pages[0][1])
            for offset in range(1,np):
                progressline=statusline+"Downloading Extra Page %i of %i - "%(offset,np-1)
                pagedata+=download_page(URL+'?showforum='+str(forumid)+'&prune_day=100&st='+str(offset*perpage),progressline, COOKIEDATA)
        for topic,views in re.findall(re_topics,pagedata):
            topicviews[int(topic)]=int(views.replace(',',''))
        out.write('INSERT INTO `'+table_prefix+'forums` (forum_id, cat_id, forum_order, forum_name, forum_desc) VALUES (%s, %s, %s, \'%s\', \'\');\n'%(forumid, catid, forumid*10, escape_var(title)))
        printline(statusline+"Completed!")
    except Exception:
        do_except('Forum ID %i'%forumid,statusline)

for catid in categories:
    out.write('INSERT INTO `'+table_prefix+'categories` (cat_id, cat_order, cat_title) VALUES (%s, %s, \'%s\');\n'%(catid, catid*10, escape_var(categories[catid])))

out.close()
print
print "Completed!"
print

for topicid in range(1,NUMTOPICS+1):
    try:
        statusline="Topic ID %i ... "%topicid
        progressline=statusline+"Downloading - "
        pagedata=download_page(URL+'?showtopic='+str(topicid),progressline, COOKIEDATA)
        pages=re.findall(re_pages,pagedata)
        if pages:
            perpage=int(pages[0][0])
            np=int(pages[0][1])
            for offset in range(1,np):
                progressline=statusline+"Downloading Extra Page %i of %i - "%(offset,np-1)
                pagedata+=download_page(URL+'?showtopic='+str(topicid)+'&st='+str(offset*perpage),progressline, COOKIEDATA)
        processed_data=pagedata
        cn=0
        for search,repl in re_repstrings:
            cn+=1
            printline(statusline+"Processing Step %i of %i"%(cn,len(re_repstrings)))
#           file("%i_%i.txt"%(topicid,cn),"w").write(processed_data)
            processed_data=re.sub(search,repl,processed_data)
        printline(statusline+"Converting Topic")
        forum,title=0,''
        posts=[] # will hold tuples of (time,id,userid,name,edittime,editname,data)
        '''   0    1       2       3         4         5    6    7         8           '''
        '''<^>POST|Post ID|User ID|User Name|Date/Time|Text|EDIT|Edit Name|Edit Time</^>'''
        ''' 0    1  2      3    4        5        6    '''
        '''(time,id,userid,name,edittime,editname,data)'''
        for line in processed_data.split('</^><^>'):
            ln=line.strip()
            if not ln: continue
            ln=ln.split('<|>')
            if ln[0]=='FORUM':
                forum=int(ln[1])
                continue
            elif ln[0]=='TITLE':
                (title,)=escape_vars([ln[1]])
                continue
            elif ln[0]=='POST':
                post=[0,0,0,'',0,'','']
                if len(ln)==9:
                    if ln[6]=='EDIT':
                        post[4]=parsetime(ln[8])
                        post[5]=ln[7]
                post[0]=parsetime(ln[4])
                post[1]=int(ln[1])
                if ln[2]: post[2]=int(ln[2])
                if post[2]==0: post[2]=-1
                post[3]=ln[3]
                post[6]=parsespans(parsequotes(ln[5].strip()))
                posts+=[post]
        if not posts:
            printline(statusline+"Error: Topic is empty!")
            print # a blank line, for the next topic
            continue
        posts.sort(key=lambda x:x[0]) # sort by date code only
        for i in range(len(posts)):
            posts[i][1]=postid
            postid+=1
        if forum not in forum_stats: forum_stats[forum]=(0,0,0,0)
        highestpost_id,highestpost_time=forum_stats[forum][2],forum_stats[forum][3]
        if posts[-1][0] > forum_stats[forum][3]: highestpost_id,highestpost_time=posts[-1][1],posts[-1][0]
        forum_stats[forum]=(forum_stats[forum][0]+1,forum_stats[forum][1]+len(posts),highestpost_id,highestpost_time)
        # change this for a different forum
        topicdata[topicid]=[topicid,int((topicid in sticky) or (pagedata.find("<option value='16'>Unpin this Topic</option>")!=-1)),forum,posts[0][1],posts[-1][1],posts[0][2] or -1,posts[0][0],title,len(posts)-1,topicviews.get(topicid,0),int(pagedata.find(img_locked)!=-1)]
        for post in posts:
            ''' 0    1  2      3    4        5        6    '''
            '''(time,id,userid,name,edittime,editname,data)'''
            # change this for a different forum
            post=escape_vars(post)
            bbcode_uid='%010x'%random.randint(0,0xFFFFFFFFFFL)
            post[6]=post[6].replace(":<UID>",":"+bbcode_uid)
            postdata+=[[[post[1],topicid,forum,post[2],post[0],post[3]*(post[2]==-1),str(post[4])*bool(post[4]),int(bool(post[4]))],[post[1],bbcode_uid,title,post[6].replace("<br />","\r\n")]]]
        printline(statusline+"Completed! Added %i posts."%len(posts))
        print # blank line for next topic
    except KeyboardInterrupt: break
    except Exception:
        do_except('Topic ID %s'%topicid,statusline)
# POST ID RENUMBERING
# Apparently, phpBB requires post renumbering too....
print "Renumbering Posts"
postdata.sort(key=lambda x:x[0][4]) # sort by date [4th value; index 3]
postid=1
for i,pd in enumerate(postdata): # i will be index, pd will be the data
    oldid=pd[0][0] # save old id
    postdata[i][0][0]=postid # set new posts.post_id
    postdata[i][1][0]=postid # set new posts_text.post_id
    tid=pd[0][1]
    if topicdata[tid][3]==oldid: topicdata[tid][3]=postid # check topic_first_post_id
    if topicdata[tid][4]==oldid: topicdata[tid][4]=postid # check topic_last_post_id
    postid+=1
# END RENUMBERING
out=open('topics_posts_phpBB.sql','w')
out.write('TRUNCATE TABLE `%stopics`;TRUNCATE TABLE `%sposts`;TRUNCATE TABLE `%sposts_text`;'%(table_prefix,table_prefix,table_prefix))
# change these two for a different forum
topicdata_vals = topicdata.values()
for i in range(0,len(topicdata_vals),topics_max_group):
    out.write('INSERT INTO `%stopics` (`topic_id`,`topic_type`,`forum_id`,`topic_first_post_id`,`topic_last_post_id`,`topic_poster`,`topic_time`,`topic_title`,`topic_replies`,`topic_views`,`topic_status`) VALUES '%table_prefix)
    out.write(',\n'.join(["(%i,%i,%i,%i,%i,%i,%i,'%s',%i,%i,%i)"%tuple(td) for td in topicdata_vals[i:i+topics_max_group]]))
    out.write(";\n")
for i in range(0,len(postdata),posts_max_group):
    out.write('INSERT INTO `%sposts` (`post_id`,`topic_id`,`forum_id`,`poster_id`,`post_time`,`poster_ip`,`post_username`,`post_edit_time`,`post_edit_count`) VALUES '%table_prefix)
    out.write(',\n'.join(["(%i,%i,%i,%i,%i,'00000000','%s','%s',%i)"%tuple(pd[0]) for pd in postdata[i:i+posts_max_group]]))
    out.write(";\n")
for i in range(0,len(postdata),posts_max_group):
    out.write('INSERT INTO `%sposts_text` (`post_id`,`bbcode_uid`,`post_subject`,`post_text`) VALUES '%table_prefix)
    out.write(',\n'.join(["(%i,'%s','%s','%s')"%tuple(pd[1]) for pd in postdata[i:i+posts_max_group]]))
    out.write(";\n")
for fs in forum_stats: out.write('UPDATE `%sforums` SET forum_topics=%i,forum_posts=%i,forum_last_post_id=%i WHERE forum_id=%i;\n'%(table_prefix,forum_stats[fs][0],forum_stats[fs][1],forum_stats[fs][2],fs))
out.close()
print 'Elapsed Conversion Time %.02f seconds' % (time() - t)
print 'Converted',len(postdata),'posts and',len(topicdata),'topics.'
raw_input("Complete! Press <enter> to exit.")
