#!/usr/bin/python
'''Forumotion to phpBB 3 Converter by nneonneo
Based on the Invisionfree converter
Version 0.3.6
Topics and Posts Part
Mar 29 2008
Updated Dec 16 2010'''
import os,re,urlparse,sys,random
from hashlib import md5
from time import strftime,strptime,mktime,time,localtime
try:
    from settings import *
except Exception, detail:
    print "Error: Settings file has some error."
    print "Details of the error:"
    sys.excepthook(*sys.exc_info())
    raw_input("Press <enter> to quit.")
    sys.exit(1)
sys.path.append('..')
from common import *

# Don't edit this file, unless you are SURE you know what you are doing.
topics_max_group = 500
posts_max_group = 200
members_max_group = 500
beg_time=time()
img_locked='<img src="%s" class="i_reply" '%lockimage
re_pages=re.compile('<div class="pagination">Page <strong>1</strong> of <strong>(\\d+)</strong>') # page detection
re_forum_pages=re.compile('Page <strong>1</strong> of <strong>(\\d+)</strong>') # page detection on forum pages
re_topicviews=re.compile('<a class="topictitle" href="/t(\\d+)-[^"]*">.*?<dd class="views">([\\d,]+) <dfn>Views</dfn>')
re_announce=re.compile('<div class="forumbg announcement">(.+?)<div class="forumbg">')
# the massive grep list of doom!
# the grep list works by changing certain things to delimited, structured data. The delimiters are "<^>" at the start and "</^>" at the end of a record, and the fields are separated with "<|>".
# first one: detection of the exact forum we're in
repstrings=[
# figure out what forum this is in
("""<a href="/f(\\d+)-[^"]*" class="nav">[^<]*</a></p>""", """<^>FORUM<|>\\1</^>"""),
# detect the title of the topic
("""<title>(.+?)</title>""","""<^>TITLE<|>\\1</^>"""),
# re hack: replace "unreg" with a registered user, id 0. RE doesn't work right :(
("""</dt><dd>Guest<br /></dd><dd><br /></dd><dd>""","""</dt><dd>Guest<br /></dd><li><a href="/u0-guest">"""),
#'''   0      1         2         3           4           5       6      7      8           9           10           11             '''
#'''<^>POST<|>Post ID<|>User ID<|>User Name<|>Date/Time<|>Title<|>Text<|>EDIT<|>Edit Name<|>Edit Time<|>Edit Count<|>Edit Reason</^>'''
# !!! the big one: get the entire post
("""<h2 class="topic-title">.+?<a href="[^"]*" name="(\\d*)">(.+?)</a></h2>.+?((?:[^ ]+ at |\\d+-\\d+-\\d+, )\\d+:\\d+|(?:[^ ]+ at |... ... \\d+, \\d+ )\\d+:\\d+ ..)</p>.*<div class="content clearfix"><div>(.+?)</div></div>(<br /><br />[^<]*?|)(?:<div id="[^"]+" class="signature">.+?</div>|<div class="signature_div" id="[^"]+">.+?</div>)?</div><(?:dl|div) class="postprofile" id="profile\\1">(?:.|<!--\\n div)*?.*?<strong style="font-size:1.2em">(?:<a[^>]*>)?(?:<[^>]*>)*(.+?)(?:</[^>]*>)*(?:</a>)?</strong></dt>[\\w\\W]+?<a href="/u(\\d+)""","""<^>POST<|>\\1<|>\\7<|>\\6<|>\\3<|>\\2<|>\\4<^EDIT^>\\5</^>"""),
# edit info
("""<\\^EDIT\\^></\\^>""","""</^>"""), # delete blank edit data
(""" \\(Reason for editing : (.*?)\\)</\\^>""","""\\1</^>"""), # clean up reason
("""<\\^EDIT\\^><br[^>]*><br[^>]*>Last edited by (.*?) on (.*?); edited (\\d+) times? in total(.*?)</\\^>""","""<|>EDIT<|>\\1<|>\\2<|>\\3<|>\\4</^>"""), # convert recognizable edit data
("""<\\^EDIT\\^>.+?</\\^>""", "</^>"), # delete any trailing edit data
# add a "<^>" tag to the end of the file - acts like the start of a tag
("""\\Z""","""<^>"""),
# and a "</^>" tag to the beginning - like the end of a tag
("""\\A""","""</^>"""),
# delete everything between the tags (blank space) leaving only the tags
("""</\\^>[\\w\\W]*?<\\^>""","""</^><^>"""),
# kill duplicate data from subsequent pages
("""POST<\\|>(.+)\\nTITLE<\\|>.+""","""POST<|>\\1"""),
# destroy any blank lines
("""^\\n""",""""""),
# and remove the blank line at the end.
("""\\n\\Z""","""""")]
# BBCode-only repstrings; these will be run exclusively on post text
bbcode_repstrings=[
# convert image links
("""<img src="([^"]+)" alt="" />""","[img:<UID>]\\1[/img:<UID>]"),
# known emotes
('<img src="http://illiweb.com/fa/i/smiles/icon_biggrin.png" alt="Very Happy" longdesc="1" />', ":D"),
('<img src="http://illiweb.com/fa/i/smiles/icon_smile.gif" alt="Smile" longdesc="2" />', ":)"),
('<img src="http://illiweb.com/fa/i/smiles/icon_sad.gif" alt="Sad" longdesc="3" />', ":("),
('<img src="http://illiweb.com/fa/i/smiles/icon_surprised.gif" alt="Surprised" longdesc="4" />', ":o"),
('<img src="http://illiweb.com/fa/i/smiles/icon_eek.gif" alt="Shocked" longdesc="5" />', ":shock:"),
('<img src="http://illiweb.com/fa/i/smiles/icon_cool.gif" alt="Cool" longdesc="6" />', "8)"),
('<img src="http://illiweb.com/fa/i/smiles/icon_lol.gif" alt="Laughing" longdesc="7" />', ":lol:"),
('<img src="http://illiweb.com/fa/i/smiles/icon_mad.gif" alt="Mad" longdesc="8" />', ":x"),
('<img src="http://illiweb.com/fa/i/smiles/icon_razz.gif" alt="Razz" longdesc="9" />', ":P"),
('<img src="http://illiweb.com/fa/i/smiles/icon_redface.gif" alt="Embarassed" longdesc="10" />', ":oops:"),
('<img src="http://illiweb.com/fa/i/smiles/icon_cry.gif" alt="Crying or Very sad" longdesc="11" />', ":cry:"),
('<img src="http://illiweb.com/fa/i/smiles/icon_evil.gif" alt="Evil or Very Mad" longdesc="12" />', ":evil:"),
('<img src="http://illiweb.com/fa/i/smiles/icon_twisted.gif" alt="Twisted Evil" longdesc="13" />', ":twisted:"),
('<img src="http://illiweb.com/fa/i/smiles/icon_rolleyes.gif" alt="Rolling Eyes" longdesc="14" />', ":roll:"),
('<img src="http://illiweb.com/fa/i/smiles/icon_wink.gif" alt="Wink" longdesc="15" />', ";)"),
('<img src="http://illiweb.com/fa/i/smiles/icon_exclaim.gif" alt="Exclamation" longdesc="16" />', ":!:"),
('<img src="http://illiweb.com/fa/i/smiles/icon_question.gif" alt="Question" longdesc="17" />', ":?:"),
('<img src="http://illiweb.com/fa/i/smiles/icon_idea.png" alt="Idea" longdesc="18" />', ":idea:"),
('<img src="http://illiweb.com/fa/i/smiles/icon_arrow.gif" alt="Arrow" longdesc="19" />', ":arrow:"),
('<img src="http://illiweb.com/fa/i/smiles/icon_neutral.gif" alt="Neutral" longdesc="20" />', ":|"),
# emotes (convert to straight images)
("""<img src="/([^"]+)" alt="[^"]*" longdesc="[^"]*" />""","[img:<UID>]%s\\1[/img:<UID>]"%URL),
("""<img src="([^"]+)" alt="[^"]*" smilieid="[^"]*" />""","[img:<UID>]\\1[/img:<UID>]"),
("""<img src="([^"]+)" alt="[^"]*" longdesc="[^"]*" />""","[img:<UID>]\\1[/img:<UID>]"),
# code tags
("""<dl class="codebox"><dt>Code:</dt><dd><code>""","[code:<UID>]"),
("""</code></dd></dl>""","""[/code:<UID>]"""),
# spoilers with custom BBCode tag
("""<dl class="codebox spoiler"><dt style="cursor: pointer;">([^:<]*):</dt><dd><div class="spoiler_content">""","[spoiler=\\1:<UID>]"),
("""</div></dd></dl>""","""[/spoiler:<UID>]"""),
# quotes: anything else (phpBB only supports author argument)
("""<blockquote><div><cite>(.+?) wrote:</cite>""","[quote=&quot;\\1&quot;:<UID>]"),
# quotes: no author
("""<blockquote><div>""","[quote:<UID>]"),
# quotes: closing
("""</div></blockquote>""","[/quote:<UID>]"),
# b,i,u tags
("<(/?[biu])>","[\\1:<UID>]"),
("<(/?)strong>","[\\1b:<UID>]"),
# [s] tags, not supported by phpBB3
("<span><strike>|</strike></span>",""),
# alignment with custom BBCode tag
("""<div (?:style="margin:auto;text-align:|align=")([^"]*?)(?:;width:100%"|")>(.+?)</div>""", """[align=\\1:<UID>]\\2[/align:<UID>]"""),
# emails (phpBB autoparses valid emails)
("""<a href="mailto:([^"]+?)">(?:<u>)?(.+?)(?:</u>)?</a>""","""[email:<UID>]\\1[/email:<UID>]"""),
# fix nested URLs
("""<a href=[^>]*><a href=([^>]*)>(.+?)</a></a>""", "<a href=\\1>\\2</a>"),
# convert URL links
("""<a href="([^"]+?)"[^>]*?>(?:<u>)?(.+?)(?:</u>)?</a>""","""[url=\\1:<UID>]\\2[/url:<UID>]"""),
# list tags
("<ol type=['\"]([1aAiI])['\"]>","[list=\\1:<UID>]"),
("<ul>","[list:<UID>]"), # unordered
("</ol>","[/list:o:<UID>]"), # closing tag
("</ul>","[/list:u:<UID>]"), # closing tag
("<li/>(.+?)<","[*:<UID>]\\1[/*:m:<UID>]<"),
("<li>","[*:<UID>]"), # list item
("</li>","[/*:m:<UID>]"), # end tag not required
# font formatting
("""<span style="font-size: (\\d+)px; line-height: normal">""",lambda m:"[size=%i:<UID>]"%(100*int(m.group(1))/12)),
("</span>","[/size:<UID>]"),
# flash
("""<embed pluginspage="http://www.macromedia.com/go/getflashplayer" src="(.+?)" width="(.+?)" height="(.+?)" type="application/x-shockwave-flash" wmode="transparent" quality="high" scale="exactfit"></embed>""","""[flash=\\2,\\3:<UID>]\\1[/flash:<UID>]"""),]

re_repstrings=[(re.compile(a),b) for a,b in repstrings]
re_bbcode=[(re.compile(a),b) for a,b in bbcode_repstrings]

def parsetime(tm,fmt=None): # glorious time parser, returns the UNIX time-since-epoch-in-seconds thing ;)
    if fmt is not None:
        return mktime(strptime(tm.replace("Sept","Sep"), fmt))

    for fmt in ('%Y-%m-%d, %H:%M', '%Y-%m-%d, %I:%M %p', '%a %b %d, %Y %I:%M %p'):
        try:
            return mktime(
                strptime(
                    tm.replace("Sept","Sep").
                                   replace("<b>Today</b> at ",strftime('%Y-%m-%d, ')).
                                   replace("[b]Today[/b] at ",strftime('%Y-%m-%d, ')).
                                   replace("Today at ",strftime('%Y-%m-%d, ')).
                                   replace("Yesterday at ",strftime('%Y-%m-%d, ',localtime(time()-24*3600)))
                    ,fmt)
                )
        except:
            pass
    raise ValueError("Couldn't parse time %s."%tm)

def parsespans(dat):
    # copied from IF converter and repurposed for font tags :P
    sb="<font"
    se='</font>'
    begin_off=dat.find(sb)
    if begin_off==-1: return dat # no spans!
    out=dat[:begin_off] # data right up to the span
    rest=dat[begin_off+len(sb):] # the remainder, after the sb block
    lwrrest=rest.lower()
    if lwrrest.startswith(' color="'):
        type="color"
        tagparams=rest[len(' color="'):].split('"')[0]
        starttag='[color=%s:<UID>]'%tagparams
        endtag='[/color:<UID>]'
    elif lwrrest.startswith(' face="'):
        # font with custom BBCode tag
        type="font"
        tagparams=rest[len(' face="'):].split('"')[0]
        starttag='[font=%s:<UID>]'%tagparams
        endtag='[/font:<UID>]'
    else:
        starttag=endtag=type=''
    spandata=starttag
    se_off=rest.find(">") # nearest span ending
    if se_off==-1:
        print "Warning: Invalid <font> found!!"
        return dat
    rest=rest[se_off+1:] # what's after the > ?
    text=rest
    nestlevel=1 # nesting level: we're inside one span
    while nestlevel:
        se_off=rest.find(se) # where's the </span>
        sb_off=rest.find(sb) # or another <span
        if se_off==-1: 
            print "Warning: No </span> found!!"
            return dat
        if sb_off==-1 or se_off<sb_off: # no new beginning (sb) before the se? good news!
            nestlevel-=1
            rest=rest[se_off+len(se):]
            continue
        elif sb_off!=-1 and sb_off<se_off: # a new beginning? darn. process it. new beginning must be before the end.
            rest=rest[sb_off+len(sb):] 
            nestlevel+=1 # increase nesting level, we won't actually process it, this just helps us find the exact block of this span
            continue
    spandata+=parsespans(text[:-(len(rest)+len(se))])+endtag # gotcha! the end of the span. Now, process the innards for nested spans.
    spandata+=parsespans(rest) # parse the rest
    return out+spandata

''' This section will download each individual member page and process it, extracting
all the visible profile data. Members will then be renumbered according to join date
so that the member order matches the order obtained if they had signed up in phpBB.'''

print "Downloading Members..."
out=open('members_phpBB3.sql','w')
out.write('DELETE FROM '+table_prefix+'users;'+'DELETE FROM '+table_prefix+'user_group;'+'INSERT INTO '+table_prefix+'''users (user_id, user_type, group_id, username, username_clean, user_regdate, user_password, user_email, user_lang, user_style, user_rank, user_colour, user_posts, user_permissions, user_ip, user_birthday, user_lastpage, user_last_confirm_key, user_post_sortby_type, user_post_sortby_dir, user_topic_sortby_type, user_topic_sortby_dir, user_avatar, user_sig, user_sig_bbcode_uid, user_from, user_icq, user_aim, user_yim, user_msnm, user_jabber, user_website, user_occ, user_interests, user_actkey, user_newpasswd, user_allow_massemail) VALUES (1, 2, 1, 'Anonymous', 'anonymous', 0, '', '', 'en', 1, 0, '', 0, '', '', '', '', '', 't', 'a', 't', 'd', '', '', '', '', '', '', '', '', '', '', '', '', '', '', 0);INSERT INTO '''+table_prefix+'''user_group (group_id, user_id, user_pending) VALUES('1', '1', '0');''')
PM_data=open('pm_passwords.txt','w')
memberdata=[]
memberslist={}
memberset=set()
for memberid in xrange(1,NUMUSERS+1):
    try:
        random.seed(RANDOMNUMBER+hash(memberid)) # creates static member passwords: they will never change.
        statusline="Member %s ... "%memberid
        userdata=download_page(URL+'profile.forum?mode=viewprofile&u='+str(memberid),statusline+"Downloading - ",COOKIEDATA)
        if '<div id="profile-advanced-layout">' in userdata:
            # "advanced" layout, grab additional info
            userdata+=download_page(URL+'profile.forum?mode=viewprofile&page_profil=contact&u='+str(memberid),statusline+"Downloading Page 2 - ",COOKIEDATA)
            userdata+=download_page(URL+'profile.forum?mode=viewprofile&page_profil=stats&u='+str(memberid),statusline+"Downloading Page 3 - ",COOKIEDATA)
        p=re.findall("""<dt>(?:<span[^>]*>)?([^<>\\n]+?)(?:&nbsp;\\*)?(?:</span>)?(?:&nbsp;\\*)?: ?(?:&nbsp;)?</dt> ?<dd>(?:<div class="field_uneditable">)?(.+?)(?:</div>|</dd>)""", userdata) # locate all "quick info" lines
        p+=re.findall("""<br />([^<>\\n]+?) *: (.+?)(?:</div>)?<span class="corners-bottom">""", userdata)
        p+=re.findall("""<li><label>(Joined|Last visit) *:</label> ?(.+?)</li>""", userdata)
        username=re.findall('<h[^>]*>Viewing profile :: (.+?)</h',userdata)
        if not p or not username: # oops, no profile lines found
            printline(statusline+"Warning: Member doesn't exist!")
            print
            continue
        """
        Indices of "dat" mapped to phpBB phpbb_users columns
        0:user_id
        1:username
        2:[realName]
        3:user_email
        4:[websiteTitle]
        5:user_website
        6:user_birthday
        7:[gender]
        8:user_from
        9:user_posts
        10:[karmaGood] <-- warning, could be negative; I wonder how that's handled?
        11:user_regdate
        12:user_icq
        13:user_aim
        14:user_yim
        15:user_msnm
        16:user_lastvisit
        17:user_password
        18:user_avatar
        19:user_level
        20:[ID_POST_GROUP]
        21:user_occ
        22:user_interests
        """
        username = username[0].replace('&#39;', "'")
        username = re.sub('<[^>]*>','', username) # strip tags
        dat=[memberid+1,username,phpbb3_username_clean(username),'','','',' 0- 0-   0',0,'',0,0,0,'','','','',0,'','',0,0,'','']
        for i in ('<div style="text-align:center;"><img src="([^"]+?)" alt="" /><br />', '<img src="([^"]+?)" alt="\\[avatar\\]" border="0".*?/>'):
            av = re.findall(i, userdata)
            if av and av[0] != 'http://illiweb.com/fa/invision/pp-blank-thumb.png':
                if av[0].startswith('/'):
                    dat[18] = URL+av[0][1:]
                else:
                    dat[18] = av[0]
                break

        if memberid in ADMINS:
            dat[19]=3

        for t,i in p:
            try:
                t=t.strip(':')
                i=i.strip()
                if i in ['&nbsp;','&nbsp;-']: continue
                if t=='Avatar':
                    av=(re.findall('<img src="(.+?)"',i) or [''])[0]
                    if av.startswith('/'):
                        dat[18]=URL+av[1:]
                    else:
                        dat[18]=av
                elif t=='Rank':
                    pass
                elif t=='Status': pass
                elif t=='Administrate user':
                    url=re.findall("""<a href="([^"]*)">Profile</a>""",i)[0].replace('&amp;','&')
                    for cookie in ('', COOKIEDATA):
                        data=download_page(urlparse.urljoin(URL,url),statusline+"Retrieving e-mail address...",cookie,retry_limit=2)
                        found=re.findall("""<input[^>]*name="email"[^>]*value="([^"]*)\"""",data)
                        if found:
                            break
                    else:
                        raise Exception("Please log in to your administration panel and update the cookie in order to download member e-mails.")
                    dat[3]=found[0]
                elif t=='Location': dat[8]=i
                elif t=='Birthday':
                    date=(re.findall("""<span style="vertical-align: top;">(.+?)&nbsp;.+</span>""",i) or [i])[0]
                    if date != "None Specified":
                        dat[6]=strftime('%d-%m-%Y',strptime(date,PROFILE_DATEFMT))
                elif t=='Gender':
                    if 'Male' in i:
                        dat[7]=1
                    elif 'Female' in i:
                        dat[7]=2
                elif t=='Job/hobbies': dat[21]=i
                elif t=='Humor': dat[22]=i
                elif t in ['Send an email', 'Send e-mail', 'Send an e-mail']: dat[3]=(re.findall('<a href="mailto:(.+?)">',i) or [dat[3]])[0]
                elif t=='Website':
                    dat[5]=re.findall("""<a href="([^"]+)\"""",i)[0]
                    dat[4]='Website'
                elif t=='Private Message': pass
                elif t=='MSN Messenger':
                    dat[15]=re.findall("""<a href="msnim:chat\\?contact=(.+?)\"""",i)[0]
                    dat[15]=re.sub('&#(\\d+);',lambda match: chr(int(match.group(1))), dat[15])
                elif t=='Yahoo Messenger': dat[14]=re.findall("""<a href="http://edit.yahoo.com/config/send_webmesg\\?.target=(.+?)&amp;.src=pg\"""",i)[0]
                elif t=='AIM Address': dat[13]=re.findall("""<a href="aim:goim\\?screenname=(.+?)\"""",i)[0]
                elif t=='ICQ Number': dat[12]=re.findall("""<a href="http://www.icq.com/people/(.+?)\"""",i)[0]
                elif t=='Skype': pass
                elif t in ['Joined', 'Join date', 'Joined date', 'Registration date']: dat[11]=parsetime(i,PROFILE_DATEFMT)
                elif t=='Last visit':
                    if i!='Never' and i!='unknown':
                        dat[16]=parsetime(i)
                elif t=='Private messages': pass
                elif t in ['Posts', 'Total posts', 'Number of posts']: dat[9]=int((re.findall("<strong>(\\d+)</strong>",i) or [i])[0])
                elif t=='Friends and foes': pass
                elif t=='Zodiac': pass
                elif t=='Chinese zodiac': pass
                elif t=='Age': pass
                elif t=='Points': pass
                elif t=='Reputation': pass
                else:
                    print # blank line; prevent overwrite
                    print "\tUnknown field %s, data %s"%(t,i)
            except ValueError,detail:
                print # blank line to prevent overwrite
                print "\tError:",detail
        memberslist[dat[1]]=dat[0]
        printline(statusline+"Processing")
        password=randpw()
        dat[17]=md5hex(password)
        #dat[20]=postgroup(dat[9]) # compute post group AFTER we've got the posts
        memberdata+=[dat]
        memberset.add(dat[0])
        PM_data.write("%s|%s\n"%(dat[1],password))
        printline(statusline+"Completed! User Password: %s"%password)
        print # blank line for next member
    except KeyboardInterrupt: break # abort processing, write out data now
    except Exception:
        do_except('Member ID %s'%memberid, statusline)
memberdata=[escape_vars(i) for i in memberdata]
for i in xrange(0,len(memberdata),members_max_group):
    # n.b. username _could_ be their display name, but then user sorting gets broken :'(
    out.write("INSERT INTO "+table_prefix+"users(user_id, user_type, group_id, username, username_clean, user_regdate, user_password, user_email, user_email_hash, user_lang, user_style, user_rank, user_colour, user_posts, user_permissions, user_ip, user_birthday, user_lastpage, user_last_confirm_key, user_post_sortby_type, user_post_sortby_dir, user_topic_sortby_type, user_topic_sortby_dir, user_avatar, user_sig, user_sig_bbcode_uid, user_from, user_icq, user_aim, user_yim, user_msnm, user_jabber, user_lastvisit, user_website, user_occ, user_interests, user_actkey, user_newpasswd, user_pass_convert, user_avatar_type) VALUES ")
    out.write(',\n'.join(["(%i, %i, %i, '%s', '%s', %i, '%s', '%s', '%s', 'en', 1, %i, '%s', %i, '', '', '%s', '', '', 't', 'a', 't', 'd', '%s', '', '', '%s', '%s', '%s', '%s', '%s', '', %i, '%s', '%s', '%s', '', '', 1, 2)" %(dat[0],dat[19],5 if dat[19] else 2,dat[1],dat[2],dat[11],dat[17],dat[3],phpbb3_email_hash(dat[3]),1 if dat[19] else 0,'AA0000' if dat[19] else '',dat[9],dat[6],dat[18],dat[8],dat[12],dat[13],dat[14],dat[15],dat[16],dat[5],dat[21],dat[22])  for dat in memberdata[i:i+members_max_group]]))
    out.write(";\n")
    out.write("INSERT INTO "+table_prefix+"user_group (group_id, user_id, user_pending) VALUES ")
    out.write(',\n'.join(["('2', '%i', '0')"%dat[0] for dat in memberdata[i:i+members_max_group]]))
    out.write(";\n")
    for dat in memberdata[i:i+members_max_group]:
        if dat[19]==3: # admin
            out.write("INSERT INTO "+table_prefix+"user_group (group_id, user_id, user_pending, group_leader) VALUES (4, %i, 0, 0);\n"%dat[0])
            out.write("INSERT INTO "+table_prefix+"user_group (group_id, user_id, user_pending, group_leader) VALUES (5, %i, 0, 1);\n"%dat[0])
out.write(phpbb3_bots(table_prefix, max(dat[0] for dat in memberdata)+1))
PM_data.close()
out.close()
print "Members: Completed: %d member%s"%(len(memberdata), int(len(memberdata)!=1)*'s')


topics={}
BOARDS={}
SEEN=set()
sticky=set(sticky)
print "Downloading Forum Structure..."
out=open("categories_forums_phpBB3.sql","w")
out.write(phpbb3_custom_bbcode_sql(table_prefix))
out.write('DELETE FROM '+table_prefix+'forums;\nDELETE FROM '+table_prefix+'acl_groups WHERE forum_id > 0;\n')
re_forums='''<li class="row"><dl.*?><d(?:t|d class="dterm")><[^>]*>(?:<h[^>]* class="hierarchy">)?<a href="/([cf]\\d+)-[^"]*" class="forumtitle">(.+?)</a>(?:</h[^>]*>)?<br />([\\w\\W]*?)(?:<br />)*(?:<strong></strong>|<span class="mod-text">|</div>|</dd>|</dt>)'''

def dl_cvt_subforum(fid, left, parent, name, desc, depth=0):
    ''' recursively download and convert subforums '''
    global statusline
    if fid in SEEN:
        return left-1
    SEEN.add(fid)
    if fid[0]=='f':
        BOARDS[int(fid[1:])]=left
    curleft=left+1
    statusline=' '*depth+"Forum %s ... "%fid
    progressline=statusline+"Downloading - "
    if fid=='c0': u='forum'
    else: u='%s-'%fid
    forumdata = download_page(URL+u, progressline, COOKIEDATA)
    pagedata=forumdata
    pages=re.findall(re_forum_pages,pagedata)
    if pages and pages[0]!='1':
        np=int(pages[0])
        perpage=int(re.findall('%sp(\\d+)-[^"]*">2</a>'%fid,pagedata)[0])
        for offset in xrange(1,np):
            progressline=statusline+"Downloading Extra Page %i of %i - "%(offset,np-1)
            pagedata+=download_page(URL+'%sp%i-'%(fid,offset*perpage),progressline,COOKIEDATA)
    ntopics = 0
    for tid,v in re.findall(re_topicviews,pagedata):
        if int(tid) in topics: continue
        topics[int(tid)]=int(v.replace(',',''))
        ntopics += 1
    announcedata = re.findall(re_announce, pagedata)
    for data in announcedata:
        for tid,v in re.findall(re_topicviews, data):
            sticky.add(int(tid))
    subforums = re.findall(re_forums, forumdata)
    printline(statusline+"Completed: %d topic%s found"%(ntopics, int(ntopics!=1)*'s'))
    print
    for sfid, sname, sdesc in subforums:
        curleft=dl_cvt_subforum(sfid, curleft, left, sname, sdesc, depth+1)+1
    out.write('INSERT INTO '+table_prefix+'forums (forum_id, parent_id, left_id, right_id, forum_name, forum_desc, forum_type) VALUES (%i, %i, %i, %i, \'%s\', \'%s\', %i);\n'%((left, parent, left, curleft, escape_var(name), escape_var(desc), int(fid[0]=='f'))))
    out.write(phpbb3_default_forum_acl(table_prefix, left))
    return curleft

try:
    dl_cvt_subforum('c0', 1, 0, 'Forum', '')
    out.close()
    print "Forums: Completed: %d topic%s found"%(len(topics), int(len(topics)!=1)*'s')
except Exception:
    do_except("Categories and Forums", statusline)

print "Downloading Topics and Posts..."
topicdata,postdata=[],[]
block_size=4096
forum_stats={} # topics, posts, latest_post_time, latest_post; this will store forum stats so we can update the DB with that information.
for topicid in topics:
    try:
        statusline="Topic ID %i ... "%topicid
        progressline=statusline+"Downloading - "
        pagedata=download_page(URL+'t%i-'%topicid,progressline,COOKIEDATA)
        pages=re.findall(re_pages,pagedata)
        if pages and pages[0]!='1':
            np=int(pages[0])
            perpage=int(re.findall('t%ip(\\d+)-[^"]*">2</a>'%topicid,pagedata)[0])
            for offset in xrange(1,np):
                progressline=statusline+"Downloading Extra Page %i of %i - "%(offset,np-1)
                pagedata+=download_page(URL+'t%ip%i-'%(topicid,offset*perpage),progressline,COOKIEDATA)
        processed_data=pagedata
        cn=0
        for search,repl in re_repstrings:
            cn+=1
            printline(statusline+"Processing Step %i of %i"%(cn,len(re_repstrings)))
#           file("%i_%i.txt"%(topicid,cn),"w").write(processed_data)
            processed_data=re.sub(search,repl,processed_data)
        printline(statusline+"Converting Topic")
        forum = 1
        views = topics[topicid]
        title=''
        posts=[] # will hold tuples of (time,id,userid,name,edittime,editname,data)
        '''   0      1         2         3           4           5       6      7      8           9           10           11             '''
        '''<^>POST<|>Post ID<|>User ID<|>User Name<|>Date/Time<|>Title<|>Text<|>EDIT<|>Edit Name<|>Edit Time<|>Edit Count<|>Edit Reason</^>'''
        ''' 0    1  2      3    4        5        6    7         8          9'''
        '''(time,id,userid,name,edittime,editname,data,editcount,editreason,title)'''
        for line in processed_data.split('</^><^>'):
            ln=line.strip()
            if not ln: continue
            ln=ln.split('<|>')
            if ln[0]=='FORUM':
                forum = BOARDS[int(ln[1])]
            if ln[0]=='TITLE' and not title:
                title=ln[1]
                continue
            elif ln[0]=='POST':
                post=[0,0,1,'',0,0,'',0,'',title]
                if len(ln)==12:
                    if ln[7]=='EDIT':
                        post[4]=parsetime(ln[9])
                        post[5]=memberslist.get(ln[8],1)
                        post[7]=int(ln[10])
                        post[8]=ln[11]
                post[0]=parsetime(ln[4])
                post[1]=int(ln[1])
                if ln[2] and int(ln[2])+1 in memberset:
                    post[2]=int(ln[2])+1
                post[3]=ln[3]
                post_text=ln[6].strip()
                for search,repl in re_bbcode:
                    post_text=re.sub(search,repl,post_text)
                post[6]=parsespans(post_text)
                post[9]=ln[5]
                posts+=[post]
        if not posts:
            printline(statusline+"Error: Topic is empty!")
            print # a blank line, for the next topic
            continue
        posts.sort(key=lambda x:x[0]) # sort by date code only
        if forum not in forum_stats: forum_stats[forum]=[0,0,0,None]
        fs = forum_stats[forum]
        fs[0] += 1
        fs[1] += len(posts)
        lastpost = posts[-1]
        if lastpost[0] > fs[2]:
            fs[2] = lastpost[0]
            fs[3] = lastpost
        # change this for a different forum
        topicdata+=[(topicid,int(topicid in sticky),forum,posts[0][1],posts[0][3],posts[-1][1],posts[-1][2],posts[-1][3],title,posts[-1][0],posts[0][2],posts[0][0],title,len(posts)-1,len(posts)-1,views,int(pagedata.find(img_locked)!=-1))]
        for post in posts:
            ''' 0    1  2      3    4        5        6    '''
            '''(time,id,userid,name,edittime,editname,data)'''
            # change this for a different forum
            bbcode_uid=''.join([random.choice('abcdefghijklmnopqrstuvwxyz0123456789') for __ in xrange(8)])
            bbcode_bitfield=phpbb3_makebitfield(post[6]).strip()
            post[6]=post[6].replace(":<UID>",":"+bbcode_uid).replace('<br />','\n')
            postdata+=[[post[1],topicid,forum,post[2],post[0],'',post[3],post[4],post[7],post[5],post[9],post[6],bbcode_uid,md5(post[6]).hexdigest(),bbcode_bitfield,post[8]]]
        printline(statusline+"Completed: %i post%s"%(len(posts),int(len(posts)!=1)*'s'))
        print # blank line for next topic
    except KeyboardInterrupt: break
    except Exception:
        do_except("Topic ID %i"%topicid, statusline)

out=open('topics_posts_phpBB3.sql','w')
out.write('DELETE FROM %stopics;DELETE FROM %stopics_posted;DELETE FROM %sposts;'%(table_prefix,table_prefix,table_prefix))
# change these two for a different forum
topicdata_vals=[escape_vars(i) for i in topicdata]
postdata=[escape_vars(i) for i in postdata]
for i in xrange(0,len(topicdata_vals),topics_max_group):
    out.write("INSERT INTO %stopics (topic_id,topic_type,forum_id,topic_first_post_id,topic_first_poster_name,topic_last_post_id,topic_last_poster_id,topic_last_poster_name,topic_last_post_subject,topic_last_post_time,topic_poster,topic_time,topic_title,topic_replies,topic_replies_real,topic_views,topic_status) VALUES "%table_prefix)
    out.write(',\n'.join(["(%i,%i,%i,%i,'%s',%i,%i,'%s','%s',%i,%i,%i,'%s',%i,%i,%i,%i)"%tuple(td) for td in topicdata_vals[i:i+topics_max_group]]))
    out.write(";\n")
    out.write("INSERT INTO %stopics_posted (user_id, topic_id, topic_posted) VALUES "%table_prefix)
    out.write(',\n'.join(',\n'.join(["(%i, %i, 1)"%(k,td[0]) for k in set([p[3] for p in postdata if p[1]==td[0]])]) for td in topicdata_vals[i:i+topics_max_group]))
    out.write(";\n")
for i in xrange(0,len(postdata),posts_max_group):
    out.write("INSERT INTO %sposts (post_id,topic_id,forum_id,poster_id,post_time,poster_ip,post_username,post_edit_time,post_edit_count,post_edit_user,post_subject,post_text,bbcode_uid,post_checksum,bbcode_bitfield,post_edit_reason) VALUES "%table_prefix)
    out.write(',\n'.join(["(%i,%i,%i,%i,%i,'%s','%s',%i,%i,%i,'%s','%s','%s','%s','%s','%s')"%tuple(pd) for pd in postdata[i:i+posts_max_group]]))
    out.write(";\n")
for fs in forum_stats:
    out.write('UPDATE `%sforums` SET forum_topics=%i,forum_topics_real=%i,forum_posts=%i WHERE forum_id=%i;\n'%(table_prefix,forum_stats[fs][0],forum_stats[fs][0],forum_stats[fs][1],fs))
    post = forum_stats[fs][3]
    if post is not None:
        '''(time,id,userid,name,edittime,editname,data,editcount,editreason)'''
        out.write("UPDATE `%sforums` SET forum_last_post_id=%i,forum_last_post_subject='%s',forum_last_post_time=%i,forum_last_poster_id=%i,forum_last_poster_name='%s',forum_last_poster_colour='%s' WHERE forum_id=%i;\n"%(table_prefix,post[1],escape_var(post[9]),post[0],post[2],escape_var(post[3]),"AA0000" if post[2]-1 in ADMINS else '',fs))
out.close()
print 'Elapsed Conversion Time %.02f seconds' % (time() - beg_time)
print 'Converted',len(postdata),'posts and',len(topicdata),'topics.'
raw_input("Complete! Press <enter> to exit.")
