#!/usr/bin/python
'''InvisionFree/InvisionPlus to SMF 1.1 Converter by nneonneo
Version 0.2.1
Topics and Posts Part
June 27 2006
Updated Jun 3 2010'''
import os,re,sys
from time import strptime,mktime,time
try:
    from settings import *
    COOKIEDATA=get_cookie()
except Exception, detail:
    print "Error: Settings file has some error."
    print "Details of the error:"
    sys.excepthook(*sys.exc_info())
    raw_input("Press <enter> to quit.")
    sys.exit(1)
sys.path.append('..')
from common import *

# Don't edit this file, unless you are SURE you know what you are doing.
topics_max_group = 500
posts_max_group = 200
sys.setrecursionlimit(100000) # safety
t=time()
escURL=re.escape(URL)
img_locked="<img src='%s' border='0' alt=''>"%lockimage
re_pages=re.compile(',(\\d+)\\);">Pages:</a> \\((\\d+)\\)') # page detection
re_topics=re.compile("<a href='javascript:who_posted\\((\\d+)\\);'>[^<]*</a></td>\\s*<td align='center' class='row.'>\\s*([\\d,]+)\\s*</td>")
re_cat=re.compile("<div id='navstrip' align='left'>.+<a href='"+escURL+"act=SC&amp;c=(\\d+)'>([^<]+?)</a>")
# the massive grep list of doom!
# the grep list works by changing certain things to delimited, structured data. The delimiters are "<^>" at the start and "</^>" at the end of a record, and the fields are separated with "<|>".
# first one: detection of the exact forum we're in
repstrings=[("""<div id='navstrip' align='left'>.+<a href='"""+escURL+"""showforum=(\\d+)'>[^<]+?</a>""","""<^>FORUM<|>\\1</^>"""),
# detect the title of the topic
("""<title>.+? -> (.+?)</title>""","""<^>TITLE<|>\\1</^>"""),
# re hack: replace "unreg" with a registered user, id 0. RE doesn't work right :(
("""<span class='unreg'>(.+?)</span>""","""<span class='normalname'><a href='nonexistanturl?showuser=0'>\\1</a></span>"""),
# !!! the big one: get the entire post
("""<!--Begin Msg Number (\\d+)-->[\\w\\W]+?<span class='normalname'><a href='.+?(?:showuser|MID)=(\\d+)'>(?:<span .+?>)?(.+)(?:</span>)?</a>[\\w\\W]+?\"text-decoration:underline\">Posted(?::| on)</a></b> ([^<]+)</span>[\\w\\W]+?<!-- THE POST \\1 -->\\n +<div class='postcolor'>([\\w\\W]+?)<!-- THE POST -->""","""<^>POST<|>\\1<|>\\2<|>\\3<|>\\4<|>\\5</^>"""),
# OLD - ("""<!--Begin Msg Number (\\d+)-->[\\w\\W]+?<span class='(?:normalname'><a href='.+?\\?showuser=(\\d+)|unreg)'>(?:<.+?>)?([^<]+)<[\\w\\W]+?\"text-decoration:underline\">Posted(?::| on)</a></b> ([^<]+)</span>[\\w\\W]+?<!-- THE POST \\1 -->\\n +<div class='postcolor'>([\\w\\W]+?)<!-- THE POST -->""","""<^>POST|\\1|\\2|\\3|\\4|\\5</^>"""),
# add a "<^>" tag to the end of the file - acts like the start of a tag
("""\\Z""","""<^>"""),
# and a "</^>" tag to the beginning - like the end of a tag
("""\\A""","""</^>"""),
# delete everything between the tags (blank space) leaving only the tags
("""</\\^>[\\w\\W]+?<\\^>""","""</^><^>"""),
# clean up the post, remove the div bit at the end and the trailing spaces
(""" ? </div>\\n        \\n        """,""""""),
# kill duplicate data from subsequent pages
("""(.)\\nTITLE<\\|>.+\\nFORUM<\\|>\\d+""","""\\1"""),
# remove attachments
("""<br />\\n<strong><span class='edit'>Attached (?:File \\( Number of downloads: \\d+ \\)|Image \\(Click thumbnail to expand\\))[\\w\\W]+? {8}\\n {8}\\n""",""""""),
# clarify the edit-by information; this gets added as optional extra fields
("""<br /><br /><span class='edit'>This post has been edited by <b>(.+?)</b> on (.+?)</span>""","""<|>EDIT<|>\\1<|>\\2"""),
# convert image links
("""\\(IMG:<a href='(.+?)' target='_blank'>.+?</a>\\)""","""[img]\\1[/img]"""),
("""\\(<a href='(.+?)' target='_blank'>Posted Image</a>\\)""","""[img]\\1[/img]"""),
# clean up quotes somewhat for easier quote processing
("""</div><table border='0' align='center' width='95%' cellpadding='3' cellspacing='1'><tr><td><b>QUOTE</b>.*?</td></tr><tr><td id='QUOTE'>""",""""""),
# emails
("""<a href='mailto:(.+?)'>(?:<u>)?(.+?)(?:</u>)?</a>""","""[email=\\1]\\1[/email]"""),
# convert URL links
("""<a href='(.+?)' target='_blank'>(?:<u>)?(.+?)(?:</u>)?</a>""","""[url=\\1]\\2[/url]"""),
# destroy any blank lines
("""^\\n""",""""""),
# and remove the blank line at the end.
("""\\n\\Z""",""""""),
# code tags
("<!--c1--></div><table border='0' align='center' width='95%' cellpadding='3' cellspacing='1'><tr><td><b>CODE</b> </td></tr><tr><td id='CODE'><!--ec1-->","[code]"),
("<!--c2--></td></tr></table><div class='postcolor'><!--ec2-->","[/code]"),
# sql tags - converted into [pre] tags
("<!--sql--></div><table border='0' align='center' width='95%' cellpadding='3' cellspacing='1'><tr><td><b>SQL</b> </td></tr><tr><td id='CODE'><!--sql1-->","[pre]"),
("<!--sql2--></td></tr></table><div class='postcolor'><!--sql3-->","[/pre]"),
# html tags - converted into [pre] tags
("<!--html--></div><table border='0' align='center' width='95%' cellpadding='3' cellspacing='1'><tr><td><b>HTML</b> </td></tr><tr><td id='CODE'><!--html1-->","[pre]"),
("<!--html2--></td></tr></table><div class='postcolor'><!--html3-->","[/pre]"),
# b,i,u,s tags
("<(/?(?:[bius]|su[bp]|hr))>","[\\1]"),
# list tags
("<ol type='1'>","[list type=decimal]"), # ordered, 1,2,3
("<ol type='a'>","[list type=lower-alpha]"), # ordered, a,b,c
("<ol type='A'>","[list type=upper-alpha]"), # ordered, A,B,C
("<ol type='i'>","[list type=lower-roman]"), # ordered, i,ii,iii
("<ol type='I'>","[list type=upper-roman]"), # ordered, I,II,III
("<ul>","[list]"), # unordered
("</[ou]l>","[/list]"), # closing tags
("<li>","[li]"), # list item
("</li>","[/li]")] # end tag
re_repstrings=[]
for a,b in repstrings: re_repstrings+=[(re.compile(a),b)] # compile all search patterns for increased efficiency; replace patterns aren't normal grep so they can't be compiled

def parsetime(tm,fmt='%b %d %Y, %I:%M %p'): # glorious time parser, returns the UNIX time-since-epoch-in-seconds thing ;)
    return mktime(strptime(tm,fmt))

def parsespans(dat):
    '''<span style='font-family:Courier'><span style='font-size:14pt;line-height:100%'><span style='color:#468212'>PWNAGE</span></span></span>'''
    '''[font=Courier][SIZE=7][color=#468212]PWNAGE[/SIZE][/color][/font]'''
    '''[pre][size=14pt][color=#468212]PWNAGE[/size][/color][/pre]'''
    sb="<span"
    se='</span>'
    begin_off=dat.find(sb)
    if begin_off==-1: return dat # no spans!
    out=dat[:begin_off] # data right up to the span
    rest=dat[begin_off+len(sb):] # the remainder, after the sb block
    lwrrest=rest.lower()
    if lwrrest.startswith(" style='font-family:courier'>"):
        type="tt"
        starttag='[tt]'
        endtag='[/tt]'
    elif lwrrest.startswith(" style='font-size:"):
        type="size"
        starttag='[size='+rest[len(" style='font-size:"):].split(";")[0]+']'
        endtag='[/size]'
    elif lwrrest.startswith(" style='color:"):
        type="color"
        color=rest[len(" style='color:"):].split("'")[0]
        if ';font-weight:bold' in color: # special, for SQL statements
            color=color.split(";")[0]
            starttag='[color='+color+'][b]'
            endtag='[/b][/color]'
        else:
            starttag='[color='+color+']'
            endtag='[/color]'
    else:
        starttag=endtag=type=''
    spandata=starttag
    se_off=rest.find(">") # nearest span ending
    if se_off==-1:
        print "Warning: Invalid <span> found!!"
        return dat
    rest=rest[se_off+1:] # what's after the > ?
    text=rest
    nestlevel=1 # nesting level: we're inside one span
    while nestlevel:
        se_off=rest.find(se) # where's the </span>
        sb_off=rest.find(sb) # or another <span
        if se_off==-1: 
            print "Warning: No </span> found!!"
            return dat
        if sb_off==-1 or se_off<sb_off: # no new beginning (sb) before the se? good news!
            nestlevel-=1
            rest=rest[se_off+len(se):]
            continue
        elif sb_off!=-1 and sb_off<se_off: # a new beginning? darn. process it. new beginning must be before the end.
            rest=rest[sb_off+len(sb):] 
            nestlevel+=1 # increase nesting level, we won't actually process it, this just helps us find the exact block of this span
            continue
    spandata+=parsespans(text[:-(len(rest)+len(se))])+endtag # gotcha! the end of the span. Now, process the innards for nested spans.
    spandata+=parsespans(rest) # parse the rest
    return out+spandata

def parsequotes(dat):
    '''<div class='postcolor'>  <!--QuoteBegin-penwwh+--></div><table border='0' align='center' width='95%' cellpadding='3' cellspacing='1'><tr><td><b>QUOTE</b> (penwwh)</td></tr><tr><td id='QUOTE'><!--QuoteEBegin-->hmm<!--QuoteBegin--></div><table border='0' align='center' width='95%' cellpadding='3' cellspacing='1'><tr><td><b>QUOTE</b> </td></tr><tr><td id='QUOTE'><!--QuoteEBegin-->test<!--QuoteEnd--></td></tr></table><div class='postcolor'><!--QuoteEEnd-->lol<!--QuoteEnd--></td></tr></table><div class='postcolor'><!--QuoteEEnd--><br><!--QuoteBegin--></div><table border='0' align='center' width='95%' cellpadding='3' cellspacing='1'><tr><td><b>QUOTE</b> </td></tr><tr><td id='QUOTE'><!--QuoteEBegin-->txx<!--QuoteEnd--></td></tr></table><div class='postcolor'><!--QuoteEEnd--><br><!--QuoteBegin--></div><table border='0' align='center' width='95%' cellpadding='3' cellspacing='1'><tr><td><b>QUOTE</b> </td></tr><tr><td id='QUOTE'><!--QuoteEBegin-->tx2<!--QuoteEnd--></td></tr></table><div class='postcolor'><!--QuoteEEnd-->  </div></div>'''
    '''[quote]hmm[quote]test[/quote]lol[/quote]
[quote]txx[/quote]
[quote]tx2[/quote]'''
    qb='<!--QuoteBegin'
    qeb='<!--QuoteEBegin-->'
    qe='<!--QuoteEnd-->'
    qee='<!--QuoteEEnd-->'
    begin_off=dat.find(qb)
    if begin_off==-1: return dat # no quotes!
    out=dat[:begin_off] # data right up to the quote
    rest=dat[begin_off+len(qb):] # the remainder, after the qb block
    quotedata='[quote' # quotedata stores the quote information that we will put in
    if not rest.startswith('-->'):
        rest=rest[1:]
        plus=rest.find('+') # different kinds of separators =\
        at=rest.find(' @ ')
        date=''
        x=[]
        if at!=-1 and (plus==-1 or at<plus): # which separator is first????
            x=rest.split(' @ ',1)
        else:
            x=rest.split('+',1)
        quotedata+=' author='+x[0] # this may need to change for different forum software; use '='+x[0] if your quotes are like [quote=quoteauthorman]
        date=x[1].split('-->',1)[0].replace('+',',').replace(' @ ',', ').strip(', ').replace('<br />','')
        if date:
            got_date=False
            for date_fmt in ['%b %d %Y, %I:%M %p','%b %d, %Y, %I:%M %p','%b %d %Y %I:%M%p','%b %d, %Y','%b %d %Y']:
                try:
                    quotedata+=' date='+str(int(parsetime(date,date_fmt))) # if your forum software doesn't support dates, replace this line with "pass" (w/o quotes)
                except ValueError:
                    continue
                else:
                    got_date=True
                    break
            if not got_date:
                print "Warning: Invalid Date String:",date
                #print dat
    quotedata+=']'
    qeb_off=rest.find(qeb) # nearest quoteebegin
    if qeb_off==-1:
        print "Warning: No QuoteEBegin block found!!"
        return dat
    rest=rest[qeb_off+len(qeb):] # what's after the qeb?
    text=rest
    nestlevel=1 # nesting level: we're inside one quote
    while nestlevel:
        qe_off=rest.find(qe) # where's the qe
        qeb_off=rest.find(qeb) # or do we have another qeb nested
        if qe_off==-1: 
            print "Warning: No QuoteEnd found!!"
            return dat
        if qeb_off==-1 or qe_off<qeb_off: # no new beginning (qeb) before the quoteend? good news!
            nestlevel-=1
            rest=rest[qe_off+len(qe):]
            continue
        elif qeb_off!=-1 and qeb_off<qe_off: # a new beginning? darn. process it. new beginning must be before the end.
            rest=rest[qeb_off+len(qeb):] 
            nestlevel+=1 # increase nesting level, we won't actually process it, this just helps us find the exact block of this quote
            continue
    quotedata+=parsequotes(text[:-(len(rest)+len(qe))].strip())+'[/quote]' # gotcha! the end of the quote. Now, process the innards for nested quotes.
    qee_off=rest.find(qee) # is there another quote somewhere?
    if qee_off!=-1:
        quotedata+=parsequotes(rest[qee_off+len(qee):].strip()) # yes? then we have to parse the rest.
    return out+quotedata

postid=1
topicdata,postdata={},[]
topicviews={}
block_size=4096
categories={}

print "Downloading Forum Structure..."
out=open("categories_forums_smf.sql","w")
out.write('TRUNCATE TABLE `'+table_prefix+'boards`; TRUNCATE TABLE `'+table_prefix+'categories`;\n')
for forumid in range(1,NUMFORUMS+1):
    try:
        statusline="Forum %s ... "%forumid
        progressline=statusline+"Downloading - "
        pagedata=download_page(URL+'showforum='+str(forumid)+'&prune_day=100', progressline, COOKIEDATA)
        titles=re.findall("""<title>.+? -> (.+?)</title>""",pagedata)
        if not titles:
            continue # error accessing forum...
        title=titles[0]
        cats=re.findall(re_cat,pagedata)
        if cats:
            catid,cattitle=cats[0]
            catid=int(catid)
        else:
            catid,cattitle=255,"Lost category"
        categories[catid]=cattitle
        pages=re.findall(re_pages,pagedata)
        if pages:
            perpage=int(pages[0][0])
            np=int(pages[0][1])
            for offset in range(1,np):
                progressline=statusline+"Downloading Extra Page %i of %i - "%(offset,np-1)
                pagedata+=download_page(URL+'showforum='+str(forumid)+'&prune_day=100&st='+str(offset*perpage),progressline, COOKIEDATA)
        for topic,views in re.findall(re_topics,pagedata):
            topicviews[int(topic)]=int(views.replace(',',''))
        out.write('INSERT INTO `'+table_prefix+'boards` (ID_BOARD, ID_CAT, childLevel, ID_PARENT, boardOrder, name, description) VALUES (%i, %s, 0, 0, %s, \'%s\', \'\');\n'%(forumid, catid, forumid, escape_var(title)))
        printline(statusline+"Completed!")
    except Exception:
        do_except('Forum ID %i'%forumid,statusline)

for catid in categories:
    out.write('INSERT INTO `'+table_prefix+'categories` (ID_CAT, catOrder, name) VALUES (%s, %s, \'%s\');\n'%(catid, catid-1, escape_var(categories[catid])))

out.close()
print
print "Completed!"
print

for topicid in range(1,NUMTOPICS+1):
    try:
        statusline="Topic ID %i ... "%topicid
        progressline=statusline+"Downloading - "
        pagedata=download_page(URL+'showtopic='+str(topicid),progressline, COOKIEDATA)
        pages=re.findall(re_pages,pagedata)
        if pages:
            perpage=int(pages[0][0])
            np=int(pages[0][1])
            for offset in range(1,np):
                progressline=statusline+"Downloading Extra Page %i of %i - "%(offset,np-1)
                pagedata+=download_page(URL+'showtopic='+str(topicid)+'&st='+str(offset*perpage),progressline, COOKIEDATA)
        processed_data=pagedata
        cn=0
        for search,repl in re_repstrings:
            cn+=1
            printline(statusline+"Processing Step %i of %i"%(cn,len(re_repstrings)))
#           file("%i_%i.txt"%(topicid,cn),"w").write(processed_data)
            processed_data=re.sub(search,repl,processed_data)
        printline(statusline+"Converting Topic")
        forum,title=0,''
        posts=[] # will hold tuples of (time,id,userid,name,edittime,editname,data)
        '''   0    1       2       3         4         5    6    7         8           '''
        '''<^>POST|Post ID|User ID|User Name|Date/Time|Text|EDIT|Edit Name|Edit Time</^>'''
        ''' 0    1  2      3    4        5        6    '''
        '''(time,id,userid,name,edittime,editname,data)'''
        for line in processed_data.split('</^><^>'):
            ln=line.strip()
            if not ln: continue
            ln=ln.split('<|>')
            if ln[0]=='FORUM':
                forum=int(ln[1])
                continue
            elif ln[0]=='TITLE':
                (title,)=escape_vars([ln[1]])
                continue
            elif ln[0]=='POST':
                post=[0,0,0,'',0,'','']
                if len(ln)==9:
                    if ln[6]=='EDIT':
                        post[4]=parsetime(ln[8])
                        post[5]=ln[7]
                post[0]=parsetime(ln[4])
                post[1]=int(ln[1])
                if ln[2]: post[2]=int(ln[2])
                post[3]=ln[3]
                post[6]=parsespans(parsequotes(ln[5].strip()))
                posts+=[escape_vars(post)]
        if not posts:
            printline(statusline+"Error: Topic is empty!")
            print # a blank line, for the next topic
            continue
        posts.sort(key=lambda x:x[0]) # sort by date code only
        # This is for SMF
        ''' `ID_TOPIC` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,`
            `isSticky` tinyint(4) NOT NULL DEFAULT '0',
            `ID_BOARD` smallint(5) unsigned NOT NULL DEFAULT '0',
            `ID_FIRST_MSG` int(10) unsigned NOT NULL DEFAULT '0',
            `ID_LAST_MSG` int(10) unsigned NOT NULL DEFAULT '0',
            `ID_MEMBER_STARTED` mediumint(8) unsigned NOT NULL DEFAULT '0',
            `ID_MEMBER_UPDATED` mediumint(8) unsigned NOT NULL DEFAULT '0',
            `ID_POLL` mediumint(8) unsigned NOT NULL DEFAULT '0',
            `numReplies` int(10) unsigned NOT NULL DEFAULT '0',
            `numViews` int(10) unsigned NOT NULL DEFAULT '0',
            `locked` tinyint(4) NOT NULL DEFAULT '0'
            '''
        # change this for a different forum
        topicdata[topicid]=[topicid,int((topicid in sticky) or (pagedata.find("</option><option value='16'>Unpin this Topic</option>")!=-1)),forum,posts[0][1],posts[-1][1],posts[0][2],posts[-1][2],len(posts)-1,topicviews.get(topicid,0),int(pagedata.find(img_locked)!=-1)]
        for post in posts:
            ''' `ID_MSG` int(10) unsigned NOT NULL AUTO_INCREMENT,
                `ID_TOPIC` mediumint(8) unsigned NOT NULL DEFAULT '0',
                `ID_BOARD` smallint(5) unsigned NOT NULL DEFAULT '0',
                `posterTime` int(10) unsigned NOT NULL DEFAULT '0',
                `ID_MEMBER` mediumint(8) unsigned NOT NULL DEFAULT '0',
                `ID_MSG_MODIFIED` mediumint(8) unsigned NOT NULL DEFAULT '0',
                `subject` tinytext NOT NULL,
                `posterName` tinytext NOT NULL,
                `posterEmail` tinytext NOT NULL,
                `posterIP` tinytext NOT NULL,
                `smileysEnabled` tinyint(4) NOT NULL DEFAULT '1',
                `modifiedTime` int(10) unsigned NOT NULL DEFAULT '0',
                `modifiedName` tinytext NOT NULL,
                `body` text NOT NULL,
                `icon` varchar(16) NOT NULL DEFAULT 'xx'
                '''
            ''' 0    1  2      3    4        5        6    '''
            '''(time,id,userid,name,edittime,editname,data)'''
            # change this for a different forum
            postdata+=[[post[1],topicid,forum,post[0],post[2],post[1],title,post[3],post[4],post[5],post[6]]]
        printline(statusline+"Completed! Added %i posts."%len(posts))
        print # blank line for next topic
    except KeyboardInterrupt: break
    except Exception:
        do_except('Topic ID %s'%topicid,statusline)
# POST ID RENUMBERING
print "Renumbering Posts"
postdata.sort(key=lambda x:x[3]) # sort by date [4th value; index 3]
postid=1
for i,pd in enumerate(postdata): # i will be index, pd will be the data
    oldid=pd[0] # save old id
    postdata[i][0]=postid # set new ID_MSG
    postdata[i][5]=postid # set new ID_MSG_MODIFIED
    if topicdata[pd[1]][3]==oldid: topicdata[pd[1]][3]=postid # check ID_FIRST_MSG
    if topicdata[pd[1]][4]==oldid: topicdata[pd[1]][4]=postid # check ID_LAST_MSG
    postid+=1
# END RENUMBERING
out=open('topics_posts_smf.sql','w')
out.write('TRUNCATE TABLE `%stopics`;TRUNCATE TABLE `%smessages`;'%(table_prefix,table_prefix))
# change these two for a different forum
topicdata_vals = topicdata.values()
for i in range(0,len(topicdata_vals),topics_max_group):
    out.write('INSERT INTO `%stopics` (`ID_TOPIC`,`isSticky`,`ID_BOARD`,`ID_FIRST_MSG`,`ID_LAST_MSG`,`ID_MEMBER_STARTED`,`ID_MEMBER_UPDATED`,`ID_POLL`,`numReplies`,`numViews`,`locked`) VALUES '%table_prefix)
    out.write(',\n'.join(["(%i,%i,%i,%i,%i,%i,%i,0,%i,%i,%i)"%tuple(td) for td in topicdata_vals[i:i+topics_max_group]]))
    out.write(";\n")
for i in range(0,len(postdata),posts_max_group):
    out.write('INSERT INTO `%smessages` (`ID_MSG`,`ID_TOPIC`,`ID_BOARD`,`posterTime`,`ID_MEMBER`,`ID_MSG_MODIFIED`,`subject`,`posterName`,`posterEmail`,`posterIP`,`smileysEnabled`,`modifiedTime`,`modifiedName`,`body`,`icon`) VALUES '%table_prefix)
    out.write(',\n'.join(["(%i,%i,%i,%i,%i,%i,'%s','%s','','unknown',1,%i,'%s','%s','xx')"%tuple(pd) for pd in postdata[i:i+posts_max_group]]))
    out.write(";\n")
out.close()
print 'Elapsed Conversion Time %.02f seconds' % (time() - t)
print 'Converted',len(postdata),'posts and',len(topicdata),'topics.'
raw_input("Complete! Press <enter> to exit.")
