#!/usr/bin/python
'''SuddenLaunch to SMF 1.1 Converter by nneonneo
Based off the Proboards converter
Version 0.3.1
Boards, Topics, Posts and Members conversion
Mar 27 2008
Updated Sept 24 2010'''
# It is necessary to combine both member and topic/post conversion because
# of the "unique" way in which SuddenLaunch displays data.
import os,re,sys,random
from time import strptime,strftime,mktime,time,localtime
from fcrypt import crypt
try:
    from settings import *
    COOKIEDATA="%suser=%s; %spass=%s"%(COOKIEPREFIX, USERNAME, COOKIEPREFIX, crypt(PASSWORD, 'yy'))
except Exception, detail:
    print "Error: Settings file has some error."
    print "Details of the error:"
    sys.excepthook(*sys.exc_info())
    raw_input("Press <enter> to quit.")
    sys.exit(1)
sys.path.append('..')
from common import *

# Don't edit below here [unless you know exactly what you are doing]
members_max_group = 500
topics_max_group = 500
posts_max_group = 200
beg_time=time()
img_locked=re.compile('<img src="%s" alt=" " border="0"/> <b>Author</b>'%lockimage)
img_sticky=re.compile('<img src="%s" alt=" " border="0"/> <b>Author</b>'%stickyimage)
img_stickylock=re.compile('<img src="%s" alt=" " border="0"/> <b>Author</b>'%stickylockimage)

# topics by board [board maps to topic list]
topicslist={}

# members [maps member names to ids]
memberslist={'guest hack':0} # the space ensures that "real" users will not have this ID

# map old topicids to new ones; format '%i/%s'%(topicid,board):newid
topicmap={}

# category detection
re_cats=re.compile('''(?s)<a name="([^"]+)"></a> <font size=2 class="cattext"[^>]*><b>(.+?)</b></font></td></tr>(.+?)class="catbg"''')

# forum detection
re_forums=re.compile('''(?s)<a href="index.cgi\\?board=([^"]+)"><B>(.+?)</B></a>.*?</font><br><font size="1">(.*?)<BR>(?:<i>Moderators?: .+?)?</font></td>''')

# subforum detection
re_subforums=re_forums

# page detection
re_pages=re.compile('''<b>Pages:</b> .+?(\\d+)</font></a>(?:&nbsp;)?</font></td>''')

# member page detection
re_member_pages=re.compile('''<select onChange="if\\(this\\.options\\[this\\.selectedIndex\\]\\.value\\) window\\.location=this\\.options\\[this\\.selectedIndex\\]\\.value;">.+?(\d+)</select>|onmouseover="pageDropList\\(this,'[^']*',(\\d+),''')

# thread ID detection
thread_search=re.compile('''&action=display&num=(\d+)".+?(?:</td>\n<td.+?){3}.+?>([\d,]+)<''')

# member detection
member_search=re.compile('''<A HREF="index.cgi\\?action=viewprofile&username=(.+?)"''')

# the massive grep list of doom!
# the grep list works by changing certain things to delimited, structured data. The delimiters are "<^>" at the start and "</^>" at the end of a record, and the fields are separated with "<|>".
# first one: detection of the exact forum we're in
repstrings=[("""<forum_id=(\\d+)>""","""<^>FORUM<|>\\1</^>"""),
# detect the title of the topic
("""<title>%s - ([^<]+?)</title>"""%BOARDNAME,"""<^>TITLE<|>\\1</^>"""),
# re hack: replace "unreg" with a registered user, id 0. RE doesn't work right :(
("""<FONT SIZE=-1><B>(.*?)</B>\\n</FONT><BR>Guest<BR>""","""<FONT SIZE=-1><A HREF="index.cgi?action=viewprofile&username=guest hack"><B>\\1</B></A>\n<BR>Guest<BR>"""),
# change e-mail links back
("""<script language="JavaScript" type="text/javascript"><!--\\ndocument.write\\('<a href="mail'\\+'to:([^']+?)'\\+'@'\\+'([^"]+?)">'\\);// --></script>""","""<a href="mailto:\\1@\\2">"""),
# !!! the big one: get the entire post
("""(?s)<FONT SIZE=-1><A HREF="index.cgi\\?action=viewprofile&username=(.+?)".*?><B>(.*?)</B></A>\
.+?&#171; .+? ([^ ]+? at [^ ]+?) &#187;.+?\\n?<hr width="100%" size="1" class="hr">\\n<font size="2">\
\\n(.*?)\\n</font>\\n</td>\\n</tr>""","""<^>POST<|>99999<|>\\1<|>\\2<|>\\3<|>\\4</^>"""),
# clarify the edit-by information; this gets added as optional extra fields
("""</\\^><tr>\\n<td.+\\n<table.+\\n<tr>\\n<td.+&#171; <i>Last Edit:</i> (.+?) by <a href="[^"]+?".*?>(?:<b>)?(.+?)(?:</b>)?</a> &#187;""","""<|>EDIT<|>\\2<|>\\1</^>"""),
# add a "<^>" tag to the end of the file - acts like the start of a tag
("""\\Z""","""<^>"""),
# and a "</^>" tag to the beginning - like the end of a tag
("""\\A""","""</^>"""),
# delete everything between the tags (blank space) leaving only the tags
("""</\\^>[\\w\\W]*?<\\^>""","""</^><^>"""),
# kill duplicate data from subsequent pages
("""POST<\\|>(.+)\\nTITLE<\\|>.+""","""POST<|>\\1"""),
# convert image links
("""<img src="([^"]+?)" alt="" border="0"[^>]*>""","""[img]\\1[/img]"""),
# convert emotes
("""<img src="([^"]+?)" BORDER=0>""","""[img]\\1[/img]"""),
# destroy any blank lines
("""^\\n""",""""""),
# and remove the blank line at the end.
("""\\n\\Z""",""""""),
# code tags
("""<UL><b>Code:</b><table bgcolor="[^"]+?" class="bordercolor" cellspacing="1" width="90%"><tr><td><table cellpadding="2" cellspacing="0" class="code" width="100%"><tr><td><font face="Courier New" class="code" size="2">""","[code]"),
(""" ?</font></td></tr></table></td></tr></table></UL>""","""[/code]"""),
# quotes: no author
("""<b>Quote:</b><table bgcolor="[^"]+?" class="bordercolor" cellspacing="1" width="90%"><tr><td width="100%"><table cellpadding="2" cellspacing="0" class="quote" width="100%"><tr><td width="100%"><font face="Arial,Helvetica" class="quote" size="1">""","[quote]"),
# quotes: anything else
("""<B>on (.+?), <a href="index.cgi\\?action=display&board=([a-zA-Z0-9]+)&amp&num=(\\d+)&amp&start=(\\d+)#[^"]*">(.*?)  wrote</a>:</B><table bgcolor="[^"]+?" class="bordercolor" cellspacing="1" width="90%"><tr><td width="100%"><table cellpadding="2" cellspacing="0" class="quote" width="100%"><tr><td width="100%"><font face="Arial,Helvetica" class="quote" size="1"> ?""","<<quote <quotelink>\\2*\\3*\\3\\4*\\1</quotelink> author=\\5>>"),
# quotes: closing
(""" </font></td></tr></table></td></tr></table>""","[/quote]"),
# b,i,u,s,pre,sub,sup,tt.center tags
("<(/?([bius]|pre|su[bp]|tt|center))>","[\\1]"),
# strike -> [s]
("<(/?s)trike>","[\\1]"),
# marquee -> [move]
("<(/?m)arquee>","[\\1ove]"),
# emails
("""<a href="mailto:([^"]+?)">(?:<u>)?(.+?)(?:</u>)?</a>""","""[email=\\1]\\2[/email]"""),
# fix nested URLs [autogen by ProBoards]
("""<a href="([^"]+?)"[^>]*?><a href="\\1"[^>]*?>\\1</a></a>""","""[url]\\1[/url]"""),
# convert URL links - run twice to catch weirdness...
("""<a href="([^"]+?)"[^>]*?>(?:<u>)?(.+?)(?:</u>)?</a>""","""[url=\\1]\\2[/url]"""),
("""<a href="([^"]+?)"[^>]*?>(?:<u>)?(.+?)(?:</u>)?</a>""","""[url=\\1]\\2[/url]"""),
# hr [horizontal line]
("""<hr[^>]+?>""","[hr]"),
# list tags
("<ol type='1'>","[list type=decimal]"), # ordered, 1,2,3
("<ol type='a'>","[list type=lower-alpha]"), # ordered, a,b,c
("<ol type='A'>","[list type=upper-alpha]"), # ordered, A,B,C
("<ol type='i'>","[list type=lower-roman]"), # ordered, i,ii,iii
("<ol type='I'>","[list type=upper-roman]"), # ordered, I,II,III
("<ul>","[list]"), # unordered
("</[ou]l>","[/list]"), # closing tags
("<li/>","[*]"),
("<li>","[*]"), # list item
("</li>",""), # end tag usually not present
# tables disabled because some font format tags use them too -> breakage :P
#("""<table border="1">""","""[table]"""),
#("""<(/?t(?:able|d|r))>""","""[\\1]"""),
# the format_tag conversions.
("""<(?:div|font|p) ""","""<format_tag """),
("""</(?:div|font|p)>""","""</format_tag>"""),
# <br/> convert: for SMF
("<br>","<br />")
]
re_repstrings=[]
for a,b in repstrings: re_repstrings+=[(re.compile(a, re.IGNORECASE),b)] # compile all search patterns for increased efficiency; replace patterns aren't normal grep so they can't be compiled

def parsetime(tm,fmt='%m/%d/%Y at %H:%M:%S'): # glorious time parser, returns the UNIX time-since-epoch-in-seconds thing ;)
    if tm == "Day 1":
        return 0 # hack...
    return mktime(
        strptime(
            re.sub("[\\[<][bB][\\]>]Today[\\[<]/[bB][\\]>] at ",strftime('%m/%d/%Y at '),tm.replace("Sept","Sep").
                           replace("Yesterday at ",strftime('%m/%d/%Y at ',localtime(time()-24*3600))))
            ,fmt)
        )

def parseformats(dat):
    def ishex(s):
        for i in s:
            if i.upper() not in '1234567890ABCDEF': return False
        return True
    fb="<format_tag"
    fe='</format_tag>'
    begin_off=dat.find(fb)
    if begin_off==-1: return dat # no tags!
    out=dat[:begin_off] # data right up to the tag
    rest=dat[begin_off+len(fb):] # the remainder, after the fb block
    lwrrest=rest.lower()
    if lwrrest.startswith(' size="'):
        type="size"
        starttag='[size='+str(min(int(rest[len(' size="'):].split('"')[0]),9))+']'
        endtag='[/size]'
    elif lwrrest.startswith(' color="'):
        type="color"
        color=rest[len(' color="'):].split('"')[0]
        if len(color) in [3,6] and ishex(color): color='#'+color.upper() #hexcolors
        else: color=color.lower()
        starttag='[color='+color+']'
        endtag='[/color]'
    elif lwrrest.startswith(' face="'):
        type="font"
        starttag='[font='+rest[len(' size="'):].split('"')[0]+']'
        endtag='[/font]'
    elif lwrrest.startswith(' align="'):
        type="align"
        pos=rest[len(' align="'):].split('"')[0]
        starttag='['+pos+']'
        endtag='[/'+pos+']'
    elif lwrrest.startswith(' style="padding:5px;width:'):
        type="shadow"
        params=re.findall('^ style="padding:5px;width:\\d+px; filter:shadow\\(color=([#0-9a-z\\-]+),direction=([0-9a-z]+)\\)">',lwrrest)[0]
        starttag='[shadow='+','.join(params)+']'
        endtag='[/shadow]'
    elif lwrrest.startswith(' style="width:'):
        type="glow"
        params=re.findall('^ style="width:(\\d+)px; filter:glow\\(color=([#0-9a-z\\-]+),strength=(\\d+)\\)">',lwrrest)[0]
        starttag='[glow=%s,%s,%s]'%(params[1],params[2],params[0])
        endtag='[/glow]'
    else:
        starttag=endtag=type=''
    fmtdata=starttag
    fe_off=rest.find(">") # nearest tag ending
    if fe_off==-1:
        print "Warning: Invalid <format_tag> found!!"
        return dat
    rest=rest[fe_off+1:] # what's after the > ?
    text=rest
    nestlevel=1 # nesting level: we're inside one font
    while nestlevel:
        fe_off=rest.find(fe) # where's the end tag
        fb_off=rest.find(fb) # or another start tag
        if fe_off==-1: 
            print "Warning: No </format_tag> found!!"
            return dat
        if fb_off==-1 or fe_off<fb_off: # no new beginning (fb) before the fe? good news!
            nestlevel-=1
            rest=rest[fe_off+len(fe):]
            continue
        elif fb_off!=-1 and fb_off<fe_off: # a new beginning? darn. process it. new beginning must be before the end.
            rest=rest[fb_off+len(fb):] 
            nestlevel+=1 # increase nesting level, we won't actually process it, this just helps us find the exact block of this tag
            continue
    fmtdata+=parseformats(text[:-(len(rest)+len(fe))])+endtag # gotcha! the end of the tag. Now, process the innards for nested tags.
    fmtdata+=parseformats(rest) # parse the rest
    return out+fmtdata

postid=1
topicdata,postdata={},[]
BOARDS={}
BPASS={}
for i in BOARDPASSWORDS:
    if BOARDPASSWORDS[i]:
        BPASS[i]='; %sboardpassword=%s'%(COOKIEPREFIX, BOARDPASSWORDS[i])

print "Downloading Forum Structure..."
out=open("categories_forums_smf.sql","w")
out.write('TRUNCATE TABLE `'+table_prefix+'boards`; TRUNCATE TABLE `'+table_prefix+'categories`;\n')
try:
    statusline="Categories ... "
    progressline=statusline+"Downloading - "
    pagedata = download_page(URL, progressline, COOKIEDATA)
    cats=re.findall(re_cats,pagedata)
    if not cats:
        print
        print "Failed to get any categories :("
        print "Please notify nneonneo."
        raw_input("Press <enter> to exit.")
        sys.exit(1)
    catnumber = 1
    forumnumber = 1
    for catid, name, data in cats:
        out.write('INSERT INTO `'+table_prefix+'categories` (ID_CAT, catOrder, name) VALUES (%s, %s, \'%s\');\n'%(catnumber, catnumber-1, escape_vars([name])[0]))
        for fid, name, desc in re.findall(re_forums, data):
            BOARDS[fid] = forumnumber
            out.write('INSERT INTO `'+table_prefix+'boards` (ID_BOARD, ID_CAT, childLevel, ID_PARENT, boardOrder, name, description) VALUES (%i, %s, 0, 0, %s, \'%s\', \'%s\');\n'%((forumnumber, catnumber, forumnumber)+tuple(escape_vars([name, desc]))))
            parentforum=forumnumber
            forumnumber += 1
            statusline="Forum %s ... "%fid
            progressline=statusline+"Downloading - "
            forumdata = download_page(URL+"?board=%s"%fid, progressline, COOKIEDATA+BPASS.get(fid, ''))
            subforums = re.findall(re_subforums, forumdata)
            for sfid, sname, sdesc in subforums:
                BOARDS[sfid] = forumnumber
                out.write('INSERT INTO `'+table_prefix+'boards` (ID_BOARD, ID_CAT, childLevel, ID_PARENT, boardOrder, name, description) VALUES (%s, %s, 1, %s, %s, \'%s\', \'%s\');\n'%((forumnumber, catnumber, parentforum, forumnumber)+tuple(escape_vars([sname, sdesc]))))
                forumnumber += 1
        catnumber += 1
    out.close()
    printline(statusline+"Completed!")
    print
except Exception:
    do_except("Categories and Forums", statusline)

print "Downloading Memberlist..."
''' This section downloads and processes the memberlist from the "Members" link at the top.'''
membersfound=set()
try:
    statusline="Members ... "
    progressline=statusline+"Downloading - "
    pagedata=download_page(URL+'?action=mlall', progressline, COOKIEDATA)
    pages=re.findall(re_member_pages,pagedata)
    if pages:
        np=int(''.join(pages[0]))
        for offset in range(2,np+1):
            progressline=statusline+"Downloading Page %i of %i - "%(offset,np)
            pagedata+=download_page(URL+'?action=mlall&start='+str((offset-1)*20), progressline, COOKIEDATA)
    printline(statusline+"Finding Members")
    membersfound=set(re.findall(member_search,pagedata))
    printline(statusline+"Completed!")
    print # blank line for next board
except Exception:
    do_except('Memberlist', statusline)

''' This section will download each individual member page and process it, extracting
all the visible profile data. Members will then be renumbered according to join date
so that the member order matches the order obtained if they had signed up in SMF.'''

print "Downloading Members..."
out=open('members_smf.sql','w')
out.write('TRUNCATE TABLE `'+table_prefix+'members`;')
PM_data=open('pm_passwords.txt','w')
memberdata=[]
for memberid in membersfound:
    try:
        if memberid=='guest hack': continue
        random.seed(RANDOMNUMBER+hash(memberid)) # creates static member passwords: they will never change.
        statusline="Member %s ... "%memberid
        userdata=download_page(URL+'?action=viewprofile&username='+str(memberid),statusline+"Downloading - ",COOKIEDATA)
        userdata=re.sub("""<script language="JavaScript" type="text/javascript"><!--\\ndocument.write\\('<a href="mail'\\+'to:(.+?)'\\+'@'\\+'(.+?)">.+</a>'\\);// --></script>""","""\\1@\\2""",userdata) # de-obfuscate e-mails
        p=re.findall("""<tr>\n<td><font size=2><b>([^<>\\n]+?): </b></font></td>\n<td><font size=2>(.+?)</font></td>\n</tr>""",userdata) # locate all "quick info" lines
        if not p: # oops, no profile lines found
            printline(statusline+"Warning: Member doesn't exist!")
            print
            continue
        """
        Indices of "dat" mapped to SMF smf_members columns
        0:ID_MEMBER
        1:memberName
        2:realName
        3:emailAddress
        4:websiteTitle
        5:websiteUrl
        6:birthdate
        7:gender
        8:location
        9:posts
        10:karmaGood <-- warning, could be negative; I wonder how that's handled?
        11:dateRegistered
        12:ICQ
        13:AIM
        14:YIM
        15:MSN
        16:lastLogin
        17:passwd
        18:avatar
        19:ID_GROUP
        20:ID_POST_GROUP
        """
        dat=[0,memberid,'','','','','0001-01-01',0,'',0,0,0,'','','','',0,'','',0,0]
        dat[18]=(re.findall('<img src="([^"]+?)" alt="\\[avatar\\]" border="0".*?/>',userdata) or [''])[0]
        #group=(re.findall("<br/><b>([^<]+)</b><br/>member is (?:off|on)line<br/><br/><center>",userdata) or [''])[0]
        #dat[19]=groups.get(group,0)
        if memberid == 'admin':
            dat[19]=1
        else:
            dat[19]=0 # evidently, it is nearly impossible to extract the group because BBCode is allowed,
        # forcing us to parse it and stuff. Not worth the effort. Admins can set mods, etc. themselves.

        for t,i in p:
            try:
                t=t.strip().strip(':')
                i=i.strip()
                if not i: continue
                if t=='Name': dat[2]=i
                elif t=='Email':
                    if i!='<i>hidden</i>':
                        if i.endswith(' (hidden)'): i=i[:-9]
                        if '</a>' in i:
                            dat[3]=re.findall('''['"]mailto:([^"']*)['"]''',i)[0]
                        else:
                            dat[3]=i
                elif t=='Website': dat[5],dat[4]=re.findall("""<a href="(.*?)" target=_blank>(.*?)</a>""",i)[0]
                elif t=='Birthday': dat[6]=strftime('%Y-%m-%d',strptime(i,'%m/%d/%Y'))
                elif t in ['Gender','Sex']: dat[7]={'Undisclosed':0,'Male':1,'Female':2}[i]
                elif t=='Location': dat[8]=i
                elif t=='Posts': dat[9]=int(i.replace(',',''))
                elif t=='Karma': dat[10]=int(i.replace(',',''))
                elif t=='Date Registered': dat[11]=int(parsetime(i, '%m/%d/%y at %H:%M:%S'))
                elif t=='ICQ': dat[12]=re.findall("""<a href=".+?">(.*?)</a>""",i)[0]
                elif t=='AIM': dat[13]=re.findall("""<a href=".+?">(.*?)</a>""",i)[0]
                elif t=='YIM': dat[14]=re.findall("""<a href=".+?">(.*?)</a>""",i)[0]
                elif t=='MSN': dat[15]=i
                elif t=='Last Login Date':
                    if " (invisible)" in i:
                        i=i.split(" (invisible)")[0]
                    if i!='N/A': dat[16]=int(parsetime(i))
                elif t=='Age': pass
                elif t=='Account Status': pass
                elif t=='Last Known IP': pass # I don't want to convert this; SMF can figure it out when they log in
                elif t=='Position': pass
                else:
                    print # blank line; prevent overwrite
                    print "\tUnknown field %s, data %s"%(t,i)
            except ValueError,detail:
                print # blank line to prevent overwrite
                print "\tError:",detail
        printline(statusline+"Processing")
        password=randpw()
        dat[17]=md5hex(password)
        dat[20]=postgroup(dat[9]) # compute post group AFTER we've got the posts
        memberdata+=[dat]
        PM_data.write("%s|%s\n"%(memberid,password))
        printline(statusline+"Completed! User Password: %s"%password)
        print # blank line for next member
    except KeyboardInterrupt: break # abort processing, write out data now
    except Exception:
        do_except('Member ID %s'%memberid, statusline)
memberdata.sort(key=lambda x:x[11]) # sort by date registered
for i,dat in enumerate(memberdata):
    memberdata[i][0]=i+1
    memberslist[dat[1]]=i+1
memberdata=[escape_vars(i) for i in memberdata]
for i in range(0,len(memberdata),members_max_group):
    out.write("INSERT INTO `"+table_prefix+"members` (`ID_MEMBER`,`memberName`,`realName`,`emailAddress`,`websiteTitle`,`websiteUrl`,`birthdate`,`gender`,`location`,`posts`,`karmaGood`,`dateRegistered`,`ICQ`,`AIM`,`YIM`,`MSN`,`lastLogin`,`passwd`,`passwordSalt`,`avatar`,`ID_GROUP`,`ID_POST_GROUP`) VALUES ")
    out.write(',\n'.join(["(%i,'%s','%s','%s','%s','%s','%s',%i,'%s',%i,%i,%i,'%s','%s','%s','%s',%i,'%s','','%s',%i,%i)"%tuple(dat) for dat in memberdata[i:i+members_max_group]]))
    out.write(";\n")
PM_data.close()
out.close()


''' Now that we're done with the members, lets do the boards.
Boards are name-coded, while topics are coded by their creation time.
This section will download each board and gather all the topics within.
At the same time, it will map topics to a renumbering scheme in order of ID
(the creation time).'''
print "Downloading Boards..."
for board in BOARDS:
    try:
        statusline="Board %s ... "%board
        progressline=statusline+"Downloading - "
        pagedata=download_page(URL+'?board='+board,progressline,COOKIEDATA+BPASS.get(board, ''))
        pages=re.findall(re_pages,pagedata)
        if pages:
            np=int(''.join(pages[0]))
            for offset in range(2,np+1):
                progressline=statusline+"Downloading Extra Page %i of %i - "%(offset-1,np-1)
                pagedata+=download_page(URL+'?board='+board+'&start='+str((offset-1)*20),progressline,COOKIEDATA+BPASS.get(board, ''))
        printline(statusline+"Finding Topics")
        added_topics=re.findall(thread_search,pagedata)
        topicslist[board]=dict([(int(topic_id),int(views.replace(',',''))) for topic_id,views in added_topics])
        printline(statusline+"Completed: %i topic%s"%(len(added_topics),int(len(added_topics)!=1)*'s'))
        print # blank line for next board
    except Exception:
        do_except('Board ID %s'%board, statusline)
topictemp=[]
for board in topicslist:
    topictemp+=[(i,board) for i in topicslist[board]]
topictemp.sort(key=lambda x:x[0]) # sort by ID only
for i,(topicid,board) in enumerate(topictemp):
    topicmap['%i/%s'%(topicid,board)]=i+1


''' This section will go through the topic IDs found before and download each topic.
The data is then processed and distilled into posts via the multiple regex's above.'''
print "Downloading Topics and Posts..."
for board in topicslist:
    for topicid in topicslist[board]:
        try:
            viewcount=topicslist[board][topicid]
            statusline="Topic %i, Board %s ... "%(topicid,board)
            progressline=statusline+"Downloading - "
            pagedata=download_page(URL+'?board=%s&action=display&num=%i'%(board,topicid),progressline,COOKIEDATA+BPASS.get(board, ''))
            pages=re.findall(re_pages,pagedata)
            if pages:
                np=int(''.join(pages[0]))
                for offset in range(2,np+1):
                    progressline=statusline+"Downloading Page %i of %i - "%(offset,np) # 2 of 3, 3 of 3
                    pagedata+=download_page(URL+'?board=%s&action=display&num=%i&start=%i'%(board,topicid,(offset-1)*15),progressline,COOKIEDATA+BPASS.get(board, ''))
            processed_data='  <forum_id=%i>'%BOARDS[board]+pagedata
#           file("%i.txt"%topicid,"w").write(processed_data)
            cn=0
            for search,repl in re_repstrings:
                cn+=1
                printline(statusline+"Processing Step %i of %i"%(cn,len(re_repstrings)))
                processed_data=re.sub(search,repl,processed_data)
#               file("%i_%i.txt"%(topicid,cn),"w").write(processed_data)
            printline(statusline+"Converting Topic")
            forum,title=0,''
            posts=[] # will hold tuples of (time,id,userid,name,edittime,editname,data)
            '''   0    1       2       3         4         5    6    7         8           '''
            '''<^>POST|Post ID|User ID|User Name|Date/Time|Text|EDIT|Edit Name|Edit Time</^>'''
            ''' 0    1  2      3    4        5        6    '''
            '''(time,id,userid,name,edittime,editname,data)'''
            postid=0
            for line in processed_data.split('</^><^>'):
                ln=line.strip()
                if not ln: continue
                ln=ln.split('<|>')
                if ln[0]=='FORUM':
                    forum=int(ln[1])
                    continue
                elif ln[0]=='TITLE':
                    title=ln[1]
                    continue
                elif ln[0]=='POST':
                    post=[0,0,0,'',0,'','']
                    if len(ln)==9:
                        if ln[6]=='EDIT':
                            post[4]=parsetime(ln[8])
                            post[5]=ln[7]
                    post[0]=parsetime(ln[4])
                    #post[0]=int(ln[1]) # PB used to identify all posts with creation time; this is not necessarily true now.
                    post[1]=int(str(topicid)+str(postid))
                    postid+=1
                    if ln[2]: post[2]=memberslist.get(ln[2],0)
                    post[3]=re.sub('<format_tag color="[^"]+">','',ln[3].replace('</format_tag>','')) # begone, format tags!
                    post[6]=ln[5].strip()
                    selflinks=re.findall("(%s\\?(?:action=display&)?board=([a-zA-Z0-9]+?)&(?:action=display&)?thread=(\\d+))"%URL,post[6])
                    for link in selflinks:
                        try: post[6]=post[6].replace(link[0],"?topic="+str(topicmap['%s/%s'%(link[2],link[1])]))
                        except KeyError: continue
                    selflinks=re.findall("(%s\\?action=viewprofile&user=([a-zA-Z0-9]+))"%URL,post[6])
                    for link in selflinks:
                        post[6]=post[6].replace(link[0],"?action=profile;u="+str(memberslist.get(link[1],0)))
                    posts+=[post]
            if not posts:
                printline(statusline+"Error: Topic is empty!")
                print # a blank line, for the next topic
                continue
            posts.sort(key=lambda x:x[0]) # sort by date code only
            # This is for SMF
            ''' `ID_TOPIC` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,`
                `isSticky` tinyint(4) NOT NULL DEFAULT '0',
                `ID_BOARD` smallint(5) unsigned NOT NULL DEFAULT '0',
                `ID_FIRST_MSG` int(10) unsigned NOT NULL DEFAULT '0',
                `ID_LAST_MSG` int(10) unsigned NOT NULL DEFAULT '0',
                `ID_MEMBER_STARTED` mediumint(8) unsigned NOT NULL DEFAULT '0',
                `ID_MEMBER_UPDATED` mediumint(8) unsigned NOT NULL DEFAULT '0',
                `ID_POLL` mediumint(8) unsigned NOT NULL DEFAULT '0',
                `numReplies` int(10) unsigned NOT NULL DEFAULT '0',
                `numViews` int(10) unsigned NOT NULL DEFAULT '0',
                `locked` tinyint(4) NOT NULL DEFAULT '0'
                '''
            topicid=topicmap['%i/%s'%(topicid,board)] # map the topic id so that we get a "real" topic ID
            # change this for a different forum
            topicdata[topicid]=[topicid,int(bool(re.findall(img_sticky,pagedata)) or bool(re.findall(img_stickylock,pagedata))),forum,posts[0][1],posts[-1][1],posts[0][2],posts[-1][2],len(posts)-1,viewcount,int(bool(re.findall(img_locked,pagedata)) or bool(re.findall(img_stickylock,pagedata)))]
            for post in posts:
                ''' `ID_MSG` int(10) unsigned NOT NULL AUTO_INCREMENT,
                    `ID_TOPIC` mediumint(8) unsigned NOT NULL DEFAULT '0',
                    `ID_BOARD` smallint(5) unsigned NOT NULL DEFAULT '0',
                    `posterTime` int(10) unsigned NOT NULL DEFAULT '0',
                    `ID_MEMBER` mediumint(8) unsigned NOT NULL DEFAULT '0',
                    `ID_MSG_MODIFIED` mediumint(8) unsigned NOT NULL DEFAULT '0',
                    `subject` tinytext NOT NULL,
                    `posterName` tinytext NOT NULL,
                    `posterEmail` tinytext NOT NULL,
                    `posterIP` tinytext NOT NULL,
                    `smileysEnabled` tinyint(4) NOT NULL DEFAULT '1',
                    `modifiedTime` int(10) unsigned NOT NULL DEFAULT '0',
                    `modifiedName` tinytext NOT NULL,
                    `body` text NOT NULL,
                    `icon` varchar(16) NOT NULL DEFAULT 'xx'
                    '''
                ''' 0    1  2      3    4        5        6    '''
                '''(time,id,userid,name,edittime,editname,data)'''
                # change this for a different forum
                postdata+=[[post[1],topicid,forum,post[0],post[2],post[1],title,post[3],post[4],post[5],post[6]]]
            printline(statusline+"Completed: %i post%s"%(len(posts),int(len(posts)!=1)*'s'))
            print # blank line for next topic
        except KeyboardInterrupt: break # abort processing this board
        except Exception:
            do_except('Topic ID %s in Board %s'%(topicid,board), statusline)
# POST ID RENUMBERING - WITHOUT THIS SMF WILL SORT YOUR POSTS STRANGELY
print "Renumbering Posts"
postdata.sort(key=lambda x:x[3]) # sort by date [4th value; index 3]
postid=1
postmap={}
for i,pd in enumerate(postdata): # i will be index, pd will be the data
    oldid=pd[0] # save old id
    postdata[i][0]=postid # set new ID_MSG
    postdata[i][5]=postid # set new ID_MSG_MODIFIED
    if topicdata[pd[1]][3]==oldid: topicdata[pd[1]][3]=postid # check ID_FIRST_MSG
    if topicdata[pd[1]][4]==oldid: topicdata[pd[1]][4]=postid # check ID_LAST_MSG
    postmap['%i/%i'%(pd[1],oldid)]=postid
    postid+=1
for i,pd in enumerate(postdata):
    quotes=re.findall('<<quote <quotelink>(.+?)</quotelink> author=(.+?)>>',pd[10])
    if quotes:
        for edt,aut in quotes:
            dt=edt.split('*')
            topic=topicmap.get('%s/%s'%(dt[1],dt[0]),0)
            post=postmap.get('%i/%s'%(topic,dt[2]),0)
            posttime=parsetime(dt[3])
            author=aut.replace('</format_tag>','').replace('[/url]','')
            author=re.sub('<format_tag color="[^"]+">','',re.sub('\\[url=/index.cgi\\?action=viewprofile&amp;user=[^]]+\\]','',author))
            postdata[i][10]=postdata[i][10].replace('<<quote <quotelink>%s</quotelink> author=%s>>'%(edt,aut),'[quote author=%s link=topic=%i.msg%i#msg%i date=%i]'%(author,topic,post,post,posttime))
    postdata[i][10]=parseformats(postdata[i][10])
# END RENUMBERING
out=open('topics_posts_smf.sql','w')
out.write('TRUNCATE TABLE `%stopics`;TRUNCATE TABLE `%smessages`;'%(table_prefix,table_prefix))
# change these two for a different forum
topicdata_vals=[escape_vars(i) for i in topicdata.values()]
postdata=[escape_vars(i) for i in postdata]
for i in range(0,len(topicdata_vals),topics_max_group):
    out.write('INSERT INTO `%stopics` (`ID_TOPIC`,`isSticky`,`ID_BOARD`,`ID_FIRST_MSG`,`ID_LAST_MSG`,`ID_MEMBER_STARTED`,`ID_MEMBER_UPDATED`,`ID_POLL`,`numReplies`,`numViews`,`locked`) VALUES '%table_prefix)
    out.write(',\n'.join(["(%i,%i,%i,%i,%i,%i,%i,0,%i,%i,%i)"%tuple(dat) for dat in topicdata_vals[i:i+topics_max_group]]))
    out.write(";\n")
for i in range(0,len(postdata),posts_max_group):
    out.write('INSERT INTO `%smessages` (`ID_MSG`,`ID_TOPIC`,`ID_BOARD`,`posterTime`,`ID_MEMBER`,`ID_MSG_MODIFIED`,`subject`,`posterName`,`posterEmail`,`posterIP`,`smileysEnabled`,`modifiedTime`,`modifiedName`,`body`,`icon`) VALUES '%table_prefix)
    out.write(',\n'.join(["(%i,%i,%i,%i,%i,%i,'%s','%s','','unknown',1,%i,'%s','%s','xx')"%tuple(dat) for dat in postdata[i:i+posts_max_group]]))
    out.write(";\n")
out.close()
print 'Elapsed Conversion Time %.02f seconds' % (time() - beg_time)
print 'Converted',len(postdata),'posts and',len(topicdata),'topics.'
raw_input("Complete! Press <enter> to exit.")
