#!/usr/bin/python
'''Yuku to phpBB 2 Converter by nneonneo
Version 0.1.5
Converts Categories, Forums, Members, Topics and Posts.
Feb 16 2008
Updated Sept 16 2010'''
import os,re,sys,random
from time import strptime,strftime,mktime,time,localtime
try:
    from settings import *
except Exception, detail:
    print "Error: Settings file has some error."
    print "Details of the error:"
    sys.excepthook(*sys.exc_info())
    raw_input("Press <enter> to quit.")
    sys.exit(1)
sys.path.append('..')
from common import *

# Don't edit below here [unless you know exactly what you are doing]
members_max_group = 500
topics_max_group = 500
posts_max_group = 200
beg_time=time()

boards=[]

# topics by board [board maps to topic list]
topicslist={}

# members [maps member names to ids]
memberslist={'guest hack':-1} # the space ensures that "real" users will not have this ID

# map old topicids to new ones; format '%i/%s'%(topicid,board):newid
topicmap={}

# category detection
re_cats=re.compile('''(?sm)<div id="dir-(\\d+)" class="[^"]*category-box[^"]*".*?<h2><a name="#dir-\\1"></a>([^<]*)</h2>(.+?)^</div>''')

# forum detection
re_forums=re.compile('''(?s)<h3><a href="/forums/(\\d+)[^"]*"[^<]*>(.+?)</a></h3>.+?<h4 class="description">(.*?)</h4>''')

# subforum detection
re_subforums=re.compile('''(?s)<h3><a href="/forums/(\\d+)[^"]*"[^<]*>(.+?)</a></h3>.+?<p class="description">(.*?)</p>''')

# member page detection, page detection
re_pages=re_member_pages=re.compile('''<div class="pager  pager-list">.+?<div class="number"><a href="[^"]+\\?page=(\\d+)[^>]*>\\1</a> </div> <div class="next''')

# member detection
member_search=re.compile('''<tr class="(?:even|odd) ([^ ]+)  ">\\n\t+<td class="poster-name">([\\w\\W]+?)</tr>''')
owner_search=re.compile('''<!-- community owner -->\\s*<p>\\s*<strong>Owner:</strong>\\s*<a href="http://([^"]+?)\\.yuku\\.com"''')
adminlist_search=re.compile('''<ul class="administrator-list">([\\w\\W]*?)</ul>''')
admin_search=re.compile('''<li class="(?:even|odd)[^"]*"><a href="http://([^"]+?)\\.yuku\\.com"''')

# thread ID detection
if CONVERTVIEWS:
    thread_search=re.compile('''(?s)<tr class="(?:first|last)(?: last)? (?:even|odd)([^"]*)">.+?<td class="topic-titles[^"]*">.+?<a href="/topic/(\\d+)[^"]*".+?<td class="views">([\\d,]+)</td>''')
else:
    thread_search=re.compile('''(?s)<tr class="(?:first|last)(?: last)? (?:even|odd)([^"]*)">.+?<td class="topic-titles[^"]*">.+?<a href="/topic/(\\d+)[^"]*"''')

# the massive grep list of doom!
# the grep list works by changing certain things to delimited, structured data. The delimiters are "<^>" at the start and "</^>" at the end of a record, and the fields are separated with "<|>".
# first one: detection of the exact forum we're in
repstrings=[("""<forum_id=(\\d+)>""","""<^>FORUM<|>\\1</^>"""),
# detect the title of the topic
("""<meta name="Description" content="([^"]+)">""","""<^>TITLE<|>\\1</^>"""),
# Yuku doesn't allow guest posting...?
# !!! the big one: get the entire post
# stop at signature, if found
("""(?sm)<tbody [^>]*class\\s*=\\s*"[^"]*thread-post[^"]*\\s+[^"]+\\s+post-(?:un)?read"\\s*id\\s*=\\s*"post-id-(\\d+)\\s*">.+?<a href="http://([^"]+?)\\.yuku\\.com" title="[^"]+s Profile">([^<]+)</a>.+?\
<p class="post-date">\\s*<span class="date">([^<]+)</span>\\s*<span class="time">([^<]+)</span>\\s*</p>.+?\
<div [^>]*class\\s*=\\s*"\\s*post-body\\s*"\\s*>.+?<div [^>]*class\\s*=\\s*"\\s*scrolling\\s*">.+?<div\\s*>\\s*(.*?)\\s*(?:<div class=['"]signature['"]>|</div\\s*>\\n\\s+<br>\\n\\s+</div>\\n\\s+</div>)""",
 """<^>POST<|>\\1<|>\\2<|>\\3<|>\\4 \\5<|>\\6</^>"""),
# clarify the edit-by information; this gets added as optional extra fields
("""</\\^>\\s+<div [^>]*class\\s*=\\s*"\\s*edit-info\\s*">\\s+Last Edited By: (?:<a href="[^"]+">)?([^<]+)(?:</a>)? ?(?:\\n\\s*)?(.+?)\\.\\n""","""<|>EDIT<|>\\1<|>\\2</^>"""),
# add a "<^>" tag to the end of the file - acts like the start of a tag
("""\\Z""","""<^>"""),
# and a "</^>" tag to the beginning - like the end of a tag
("""\\A""","""</^>"""),
# delete everything between the tags (blank space) leaving only the tags
("""</\\^>[\\w\\W]*?<\\^>""","""</^><^>"""),
# kill duplicate data from subsequent pages
("""POST<\\|>(.+)\\nTITLE<\\|>.+""","""POST<|>\\1"""),
# convert image links: nearly arbitrary HTML is allowed in Yuku
("""<img [^>]*src="([^"]+?)"[^>]*>""","""[img:<UID>]\\1[/img:<UID>]"""),
# Can't convert emotes -- not enough info.
# destroy any blank lines
("""^\\n""",""""""),
# and remove the blank line at the end.
("""\\n\\Z""",""""""),
# attempt to parse quotes
('<blockquote><!SP><strong class="quote-title"><!SP>(.+?) wrote:<!SP></strong><!SP><hr><!SP>','[quote:<UID>="\\1"]'),
('<blockquote><!SP>','[quote:<UID>]'),
('<!SP></blockquote>','[/quote:<UID>]'),
# b,i,u tags
("<(/?[biu])>","[\\1:<UID>]"),
# emails (phpBB autoparses valid emails)
("""<a href="mailto:([^"]+?)">(?:<u>)?(.+?)(?:</u>)?</a>""","""[email]\\1[/email]"""),
# convert URL links
("""<a href="([^"]+?)"[^>]*?>(?:<u>)?(.+?)(?:</u>)?</a>""","""[url=\\1]\\2[/url]"""),
# list tags (i and I not supported)
("<ol type='([1aA])'>","[list=\\1:<UID>]"),
("<ol>","[list=1:<UID>]"),
("<ul>","[list:<UID>]"), # unordered
("</ol>","[/list:o:<UID>]"), # closing tag
("</ul>","[/list:u:<UID>]"), # closing tag
("<li/>","[*:<UID>]"),
("<li[^>]*>","[*:<UID>]"), # list item
("</li>",""), # no end tag needed
]
re_repstrings=[]
for a,b in repstrings: re_repstrings+=[(re.compile(a.replace('<!SP>','(?:\\s|<[bB][rR][^>]*>)*')),b)] # compile all search patterns for increased efficiency; replace patterns aren't normal grep so they can't be compiled

def parsetime(tm,fmt=DATEFORMAT+' '+TIMEFORMAT): # glorious time parser, returns the UNIX time-since-epoch-in-seconds thing ;)
    return mktime(strptime(tm,fmt))

postid=1
topicdata,postdata={},[]

print "Downloading Forum Structure..."
out=open("categories_forums_phpBB.sql","w")
out.write('TRUNCATE TABLE `'+table_prefix+'forums`; TRUNCATE TABLE `'+table_prefix+'categories`;\n')
try:
    statusline="Categories ... "
    progressline=statusline+"Downloading - "
    pagedata = download_page(URL, progressline, COOKIEDATA)
    cats=re.findall(re_cats,pagedata)
    if not cats:
        print
        print "Failed to get any categories :("
        print "Please notify nneonneo."
        raw_input("Press <enter> to exit.")
        sys.exit(1)
    catorder = 10
    forumorder = 10
    for catid, name, data in cats:
        out.write('INSERT INTO `'+table_prefix+'categories` (cat_id, cat_order, cat_title) VALUES (%s, %s, \'%s\');\n'%(catid, catorder, escape_vars([name])[0]))
        catorder += 10
        for fid, name, desc in re.findall(re_forums, data):
            boards.append(int(fid))
            out.write('INSERT INTO `'+table_prefix+'forums` (forum_id, cat_id, forum_order, forum_name, forum_desc) VALUES (%s, %s, %s, \'%s\', \'%s\');\n'%((fid, catid, forumorder)+tuple(escape_vars([name, desc]))))
            forumorder += 10
            statusline="Forum %s ... "%fid
            progressline=statusline+"Downloading - "
            forumdata = download_page(URL+"forums/%s"%fid, progressline, COOKIEDATA)
            subforums = re.findall(re_subforums, forumdata)
            for sfid, sname, sdesc in subforums:
                boards.append(int(sfid))
                out.write('INSERT INTO `'+table_prefix+'forums` (forum_id, cat_id, forum_order, forum_name, forum_desc) VALUES (%s, %s, %s, \'%s\', \'%s\');\n'%((sfid, catid, forumorder)+tuple(escape_vars([sname, sdesc]))))
                forumorder += 10
    out.close()
    printline(statusline+"Completed!")
    print
except Exception:
    do_except("Categories and Forums", statusline)

print "Downloading Memberlist..."
out=open('members_phpBB.sql','w')
out.write('TRUNCATE TABLE `'+table_prefix+'users`;'+'TRUNCATE TABLE `'+table_prefix+'user_group`;'+'TRUNCATE TABLE `'+table_prefix+'groups`;INSERT INTO '+table_prefix+'''users (user_id, user_active, username, user_password, user_session_time, user_session_page, user_lastvisit, user_regdate, user_level, user_posts, user_timezone, user_style, user_lang, user_dateformat, user_new_privmsg, user_unread_privmsg, user_last_privmsg, user_login_tries, user_last_login_try, user_emailtime, user_viewemail, user_attachsig, user_allowhtml, user_allowbbcode, user_allowsmile, user_allowavatar, user_allow_pm, user_allow_viewonline, user_notify, user_notify_pm, user_popup_pm, user_rank, user_avatar, user_avatar_type, user_email, user_icq, user_website, user_from, user_sig, user_sig_bbcode_uid, user_aim, user_yim, user_msnm, user_occ, user_interests, user_actkey, user_newpasswd) VALUES('-1', '0', 'Anonymous', '', '0', '0', '0', '0', '0', '0', '0.00', NULL, 'english', '', '0', '0', '0', '0', '0', NULL, '0', '0', '1', '1', '1', '1', '0', '1', '0', '1', '0', NULL, '', '0', '', '', '', '', '', NULL, '', '', '', '', '', '', '');INSERT INTO '''+table_prefix+'''groups (group_id, group_type, group_name, group_description, group_moderator, group_single_user) VALUES('1', '1', 'Anonymous', 'Personal User', '0', '1');INSERT INTO '''+table_prefix+'''user_group (group_id, user_id, user_pending) VALUES('1', '-1', '0');''')
PM_data=open('pm_passwords.txt','w')
admin_list=[]
try:
    statusline="Admin list ... "
    progressline=statusline+"Downloading - "
    pagedata = download_page(URL+"directory/featured", progressline, COOKIEDATA)
    admin_list.extend(re.findall(owner_search, pagedata))
    data = re.findall(adminlist_search, pagedata)
    if data:
        admin_list.extend(re.findall(admin_search, data[0]))
    printline(statusline+"Completed!")
    print
except Exception:
    do_except('Admin list', statusline)

memberdata=[]
try:
    statusline="Members ... "
    progressline=statusline+"Downloading - "
    pagedata = download_page(URL+"domainstats/activemembers", progressline, COOKIEDATA)
    pages=re.findall(re_member_pages,pagedata)
    if pages:
        np=int(pages[0])
        for offset in range(2,np+1):
            progressline=statusline+"Downloading Page %i of %i - "%(offset,np)
            pagedata += download_page(URL+"domainstats/activemembers?page="+str(offset), progressline, COOKIEDATA)
    printline(statusline+"Finding Members")
    for i,m in enumerate(re.findall(member_search,pagedata)):
        try:
            statusline="Member %s ... "%m[0]
            printline(statusline+"Processing")
            memberid, data = m
            new_id = i+1
            joindate = parsetime(re.findall('<td class="joined">([^<]+)</td>',data)[0], DATEFORMAT)
            posts = int(re.findall('<td class="posts">([^<]+)</td>',data)[0].replace(',',''))
            member_url, memberid, name = re.findall('<a href="(http://([^"]+?)\\.yuku\\.com)" title="[^"]+s Profile">([^<]+)</a></p>',data)[0]
            avatar = re.findall('<p class="user-avatar"><a href=[^>]+><img src="([^"]+)"',data)[0]
            if avatar == '/common/bypass/images/missinng_avatar.gif': # missinng [sic]...
                avatar=''
            group = int(memberid in admin_list)
            random.seed(RANDOMNUMBER+hash(memberid)) # creates static member passwords: they will never change.
            password=randpw()
            passhash=md5hex(password)
            PM_data.write("%s|%s|%s\n"%(memberid,name,password))
            printline(statusline+"Completed! User Password: %s"%password)
            memberdata+=[[new_id, memberid, group, joindate, posts, name, avatar, passhash]]
            printline(statusline+"Completed!")
        except Exception:
            do_except('Member %s'%m[0], statusline)
    print # blank line for next part
except Exception:
    do_except('Members', statusline)
membernames = {}
memberdata.sort(key=lambda x:x[3]) # sort by date registered
for i,dat in enumerate(memberdata):
    memberdata[i][0]=i+1
    memberslist[dat[1]]=i+1
    name = memberid = dat[1]
    # fix up the name, and remove the suffix if possible
    if '.' in name:
        newname = name.rsplit('.',1)[0]
        if newname not in membernames:
            name = newname
    membernames[name] = memberid
    dat[5] = name
memberdata=[escape_vars(i) for i in memberdata]
for i in range(0,len(memberdata),members_max_group):
    out.write("INSERT INTO `"+table_prefix+"users` (user_id, username, user_posts, user_regdate, user_password, user_avatar, user_level, user_occ, user_interests, user_sig, user_viewemail, user_style, user_attachsig, user_lang, user_actkey, user_newpasswd) VALUES ")
    out.write(',\n'.join(["(%i, '%s', %i, %i, '%s', '%s', '%s', '', '', '', 0, NULL, 0, '', '', '')"%(dat[0],dat[5],dat[4],dat[3],dat[7],dat[6],dat[2]) for dat in memberdata[i:i+members_max_group]]))
    out.write(";\n")
    out.write("INSERT INTO `"+table_prefix+"groups` (group_id, group_type, group_name, group_description, group_moderator, group_single_user) VALUES ")
    out.write(',\n'.join(["('%i', '1', '%s', 'Personal User', '0', '1')"%(dat[0]+1,'Admin'*dat[2]) for dat in memberdata[i:i+members_max_group]]))
    out.write(";\n")
    out.write("INSERT INTO `"+table_prefix+"user_group` (group_id, user_id, user_pending) VALUES ")
    out.write(',\n'.join(["('%i', '%i', '0')"%(dat[0]+1,dat[0]) for dat in memberdata[i:i+members_max_group]]))
    out.write(";\n")
PM_data.close()
out.close()

print "Downloading Boards..."
for board in boards:
    try:
        statusline="Board %s ... "%board
        progressline=statusline+"Downloading - "
        pagedata=download_page(URL+"forums/%i"%board, progressline, COOKIEDATA)
        pages=re.findall(re_pages,pagedata)
        if pages:
            np=int(pages[0])
            for offset in range(2,np+1):
                progressline=statusline+"Downloading Extra Page %i of %i - "%(offset-1,np-1)
                pagedata+=download_page(URL+"forums/%i?page=%i"%(board,offset), progressline, COOKIEDATA)
        printline(statusline+"Finding Topics")
        added_topics=re.findall(thread_search,pagedata)
        if CONVERTVIEWS:
            topicslist[board]=dict([(int(topic_id),(attribs.strip().split(' '),int(views.replace(',','')))) for attribs,topic_id,views in added_topics])
        else:
            topicslist[board]=dict([(int(topic_id),(attribs.strip().split(' '),0)) for attribs,topic_id in added_topics])
        printline(statusline+"Completed: %i topic%s"%(len(added_topics),int(len(added_topics)!=1)*'s'))
        print # blank line for next board
    except Exception:
        do_except("Board ID %s"%board, statusline)
topictemp=[]

''' This section will go through the topic IDs found before and download each topic.
The data is then processed and distilled into posts via the multiple regex's above.'''
print "Downloading Topics and Posts..."
for board in topicslist:
    for topicid in topicslist[board]:
        try:
            viewcount=topicslist[board][topicid][1]
            statusline="Topic %i, Board %s ... "%(topicid,board)
            progressline=statusline+"Downloading - "
            pagedata=download_page(URL+"topic/%i"%topicid, progressline, COOKIEDATA)
            pages=re.findall(re_pages,pagedata)
            if pages:
                np=int(pages[0])
                for offset in range(2,np+1):
                    progressline=statusline+"Downloading Page %i of %i - "%(offset,np) # 2 of 3, 3 of 3
                    pagedata+=download_page(URL+"topic/%i?page=%i"%(topicid,offset), progressline, COOKIEDATA)
            processed_data='  <forum_id=%i>'%board+pagedata
#           file("%i.txt"%topicid,"w").write(processed_data)
            cn=0
            for search,repl in re_repstrings:
                cn+=1
                printline(statusline+"Processing Step %i of %i"%(cn,len(re_repstrings)))
                processed_data=re.sub(search,repl,processed_data)
#               file("%i_%i.txt"%(topicid,cn),"w").write(processed_data)
            printline(statusline+"Converting Topic")
            forum,title=0,''
            posts=[]
            '''   0    1       2       3         4         5    6    7         8           '''
            '''<^>POST|Post ID|User ID|User Name|Date/Time|Text|EDIT|Edit Name|Edit Time</^>'''
            ''' 0    1  2      3    4        5        6    '''
            '''(time,id,userid,name,edittime,editname,data)'''
            for line in processed_data.split('</^><^>'):
                ln=line.strip()
                if not ln: continue
                ln=ln.split('<|>')
                if ln[0]=='FORUM':
                    forum=int(ln[1])
                    continue
                elif ln[0]=='TITLE':
                    title=ln[1]
                    continue
                elif ln[0]=='POST':
                    post=[0,0,0,'',0,'','']
                    if len(ln)==9:
                        if ln[6]=='EDIT':
                            post[4]=parsetime(ln[8])
                            post[5]=ln[7]
                    try:
                        post[0]=parsetime(ln[4].strip('(').strip(')')) # brackets? wtf?
                        assert post[0] >= time()-(3600*24*365*15), "Post is more than 15 years old!"
                        assert post[0] <= time()+(3600*24*180), "Post is more than half a year in the future!"
                    except Exception:
                        do_except('Post %s: Bad timestamp %s'%(ln[1],ln[4]),statusline)
                        continue
                    post[1]=int(ln[1])
                    if ln[2]: post[2]=memberslist.get(ln[2],-1)
                    post[3]=ln[3]
                    post[6]=ln[5].strip()
                    posts+=[post]
            if not posts:
                printline(statusline+"Error: Topic is empty!")
                print # a blank line, for the next topic
                continue
            posts.sort(key=lambda x:x[0]) # sort by date code only
            # This is for phpBB
            '''
            topic_id mediumint(8) UNSIGNED NOT NULL auto_increment,
            forum_id smallint(8) UNSIGNED DEFAULT '0' NOT NULL,
            topic_title char(60) NOT NULL,
            topic_poster mediumint(8) DEFAULT '0' NOT NULL,
            topic_time int(11) DEFAULT '0' NOT NULL,
            topic_views mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
            topic_replies mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
            topic_status tinyint(3) DEFAULT '0' NOT NULL,
            topic_vote tinyint(1) DEFAULT '0' NOT NULL,
            topic_type tinyint(3) DEFAULT '0' NOT NULL,
            topic_first_post_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
            topic_last_post_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
            topic_moved_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL
            '''
            # change this for a different forum
            topicdata[topicid]=[topicid,'row-sticky' in topicslist[board][topicid][0],forum,posts[0][1],posts[-1][1],posts[0][2],posts[0][0],title,len(posts)-1,viewcount,'row-closed' in topicslist[board][topicid][0]]
            for post in posts:
                '''
              phpbb_posts
                post_id mediumint(8) UNSIGNED NOT NULL auto_increment,
                topic_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
                forum_id smallint(5) UNSIGNED DEFAULT '0' NOT NULL,
                poster_id mediumint(8) DEFAULT '0' NOT NULL,
                post_time int(11) DEFAULT '0' NOT NULL,
                poster_ip char(8) NOT NULL,
                post_username varchar(25),
                enable_bbcode tinyint(1) DEFAULT '1' NOT NULL,
                enable_html tinyint(1) DEFAULT '0' NOT NULL,
                enable_smilies tinyint(1) DEFAULT '1' NOT NULL,
                enable_sig tinyint(1) DEFAULT '1' NOT NULL,
                post_edit_time int(11),
                post_edit_count smallint(5) UNSIGNED DEFAULT '0' NOT NULL
                
              phpbb_posts_text
                post_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
                bbcode_uid char(10) DEFAULT '' NOT NULL,
                post_subject char(60),
                post_text text
                '''
                ''' 0    1  2      3    4        5        6    '''
                '''(time,id,userid,name,edittime,editname,data)'''
                # change this for a different forum
                bbcode_uid='%010x'%random.randint(0,0xFFFFFFFFFFL)
                post[6]=post[6].replace(":<UID>",":"+bbcode_uid).replace('\n',' ').replace('<br>','\n').replace('<br/>','\n').replace('<br />','\n')
                postdata+=[[[post[1],topicid,forum,post[2],post[0],'00000000',post[3],post[4],bool(post[4])*1],
                             [post[1],bbcode_uid,title,post[6]]]]
            printline(statusline+"Completed: %i post%s"%(len(posts),int(len(posts)!=1)*'s'))
            print # blank line for next topic
        except KeyboardInterrupt: break # abort processing this board
        except Exception:
            do_except('Topic ID %s in Board %s'%(topicid,board), statusline)
# POST ID RENUMBERING
# FORUM STATISTIC COUNTING
forum_stats={}
print "Renumbering Posts"
postdata.sort(key=lambda x:x[0][4]) # sort by date [5th value; index 4]
postid=1
for i,pd in enumerate(postdata): # i will be index, pd will be the data
    oldid=pd[0][0] # save old id
    postdata[i][0][0]=postid # set new posts: post_id
    postdata[i][1][0]=postid # set new posts_text: post_id
    if topicdata[pd[0][1]][3]==oldid: topicdata[pd[0][1]][3]=postid # check ID_FIRST_MSG
    if topicdata[pd[0][1]][4]==oldid: topicdata[pd[0][1]][4]=postid # check ID_LAST_MSG
    if pd[0][2] not in forum_stats: forum_stats[pd[0][2]] = [0,0,0]
    forum_stats[pd[0][2]][1]+=1
    forum_stats[pd[0][2]][2]=postid
    postid+=1
for td in topicdata:
    forum_stats[topicdata[td][2]][0]+=1
# END RENUMBERING
out=open('topics_posts_phpBB.sql','w')
out.write('TRUNCATE TABLE `%stopics`;TRUNCATE TABLE `%sposts`;TRUNCATE TABLE `%sposts_text`;'%(table_prefix,table_prefix,table_prefix))
# change these two for a different forum
topicdata_vals=[escape_vars(i) for i in topicdata.values()]
postdata=[[escape_vars(c) for c in i] for i in postdata]
for i in range(0,len(topicdata_vals),topics_max_group):
    out.write("INSERT INTO `%stopics` (`topic_id`,`topic_type`,`forum_id`,`topic_first_post_id`,`topic_last_post_id`,`topic_poster`,`topic_time`,`topic_title`,`topic_replies`,`topic_views`,`topic_status`) VALUES "%table_prefix)
    out.write(',\n'.join(["(%i,%i,%i,%i,%i,%i,%i,'%s',%i,%i,%i)"%tuple(td) for td in topicdata_vals[i:i+topics_max_group]]))
    out.write(";\n")
for i in range(0,len(postdata),posts_max_group):
    out.write("INSERT INTO `%sposts` (`post_id`,`topic_id`,`forum_id`,`poster_id`,`post_time`,`poster_ip`,`post_username`,`post_edit_time`,`post_edit_count`) VALUES "%table_prefix)
    out.write(',\n'.join(["(%i,%i,%i,%i,%i,'%s','%s',%i,%i)"%tuple(pd[0]) for pd in postdata[i:i+posts_max_group]]))
    out.write(";\n")
for i in range(0,len(postdata),posts_max_group):
    out.write("INSERT INTO `%sposts_text` (`post_id`,`bbcode_uid`,`post_subject`,`post_text`) VALUES "%table_prefix)
    out.write(',\n'.join(["(%i,'%s','%s','%s')"%tuple(pd[1]) for pd in postdata[i:i+posts_max_group]]))
    out.write(";\n")
for fs in forum_stats: out.write('UPDATE `%sforums` SET forum_topics=%i,forum_posts=%i,forum_last_post_id=%i WHERE forum_id=%i;\n'%(table_prefix,forum_stats[fs][0],forum_stats[fs][1],forum_stats[fs][2],fs))
out.close()
print 'Elapsed Conversion Time %.02f seconds' % (time() - beg_time)
print 'Converted',len(postdata),'posts and',len(topicdata),'topics.'
raw_input("Complete! Press <enter> to exit.")
