#!/usr/bin/python
'''Yuku to SMF 1.1 Converter by nneonneo
Version 0.1.5
Converts Categories, Forums, Members, Topics and Posts.
Feb 16 2008
Updated Sept 16 2010'''
import os,re,sys,random
from time import strptime,strftime,mktime,time,localtime
try:
    from settings import *
except Exception, detail:
    print "Error: Settings file has some error."
    print "Details of the error:"
    sys.excepthook(*sys.exc_info())
    raw_input("Press <enter> to quit.")
    sys.exit(1)
sys.path.append('..')
from common import *

# Don't edit below here [unless you know exactly what you are doing]
members_max_group = 500
topics_max_group = 500
posts_max_group = 200
beg_time=time()

boards=[]

# topics by board [board maps to topic list]
topicslist={}

# members [maps member names to ids]
memberslist={'guest hack':0} # the space ensures that "real" users will not have this ID

# map old topicids to new ones; format '%i/%s'%(topicid,board):newid
topicmap={}

# category detection
re_cats=re.compile('''(?sm)<div id="dir-(\\d+)" class="[^"]*category-box[^"]*".*?<h2><a name="#dir-\\1"></a>([^<]*)</h2>(.+?)^</div>''')

# forum detection
re_forums=re.compile('''(?s)<h3><a href="/forums/(\\d+)[^"]*"[^<]*>(.+?)</a></h3>.+?<h4 class="description">(.*?)</h4>''')

# subforum detection
re_subforums=re.compile('''(?s)<h3><a href="/forums/(\\d+)[^"]*"[^<]*>(.+?)</a></h3>.+?<p class="description">(.*?)</p>''')

# member page detection, page detection
re_pages=re_member_pages=re.compile('''<div class="pager  pager-list">.+?<div class="number"><a href="[^"]+\\?page=(\\d+)[^>]*>\\1</a> </div> <div class="next''')

# member detection
member_search=re.compile('''<tr class="(?:even|odd) ([^ ]+)  ">\\n\t+<td class="poster-name">([\\w\\W]+?)</tr>''')
owner_search=re.compile('''<!-- community owner -->\\s*<p>\\s*<strong>Owner:</strong>\\s*<a href="http://([^"]+?)\\.yuku\\.com"''')
adminlist_search=re.compile('''<ul class="administrator-list">([\\w\\W]*?)</ul>''')
admin_search=re.compile('''<li class="(?:even|odd)[^"]*"><a href="http://([^"]+?)\\.yuku\\.com"''')

# thread ID detection
if CONVERTVIEWS:
    thread_search=re.compile('''(?s)<tr class="(?:first|last)(?: last)? (?:even|odd)([^"]*)">.+?<td class="topic-titles[^"]*">.+?<a href="/topic/(\\d+)[^"]*".+?<td class="views">([\\d,]+)</td>''')
else:
    thread_search=re.compile('''(?s)<tr class="(?:first|last)(?: last)? (?:even|odd)([^"]*)">.+?<td class="topic-titles[^"]*">.+?<a href="/topic/(\\d+)[^"]*"''')

# the massive grep list of doom!
# the grep list works by changing certain things to delimited, structured data. The delimiters are "<^>" at the start and "</^>" at the end of a record, and the fields are separated with "<|>".
# first one: detection of the exact forum we're in
repstrings=[("""<forum_id=(\\d+)>""","""<^>FORUM<|>\\1</^>"""),
# detect the title of the topic
("""<meta name="Description" content="([^"]+)">""","""<^>TITLE<|>\\1</^>"""),
# Yuku doesn't allow guest posting...?
# !!! the big one: get the entire post
# stop at signature, if found
("""(?sm)<tbody [^>]*class\\s*=\\s*"[^"]*thread-post[^"]*\\s+[^"]+\\s+post-(?:un)?read"\\s*id\\s*=\\s*"post-id-(\\d+)\\s*">.+?<a href="http://([^"]+?)\\.yuku\\.com" title="[^"]+s Profile">([^<]+)</a>.+?\
<p class="post-date">\\s*<span class="date">([^<]+)</span>\\s*<span class="time">([^<]+)</span>\\s*</p>.+?\
<div [^>]*class\\s*=\\s*"\\s*post-body\\s*"\\s*>.+?<div [^>]*class\\s*=\\s*"\\s*scrolling\\s*">.+?<div\\s*>\\s*(.*?)\\s*(?:<div class=['"]signature['"]>|</div\\s*>\\n\\s+<br>\\n\\s+</div>\\n\\s+</div>)""",
 """<^>POST<|>\\1<|>\\2<|>\\3<|>\\4 \\5<|>\\6</^>"""),
# clarify the edit-by information; this gets added as optional extra fields
("""</\\^>\\s+<div [^>]*class\\s*=\\s*"\\s*edit-info\\s*">\\s+Last Edited By: (?:<a href="[^"]+">)?([^<]+)(?:</a>)? ?(?:\\n\\s*)?(.+?)\\.\\n""","""<|>EDIT<|>\\1<|>\\2</^>"""),
# add a "<^>" tag to the end of the file - acts like the start of a tag
("""\\Z""","""<^>"""),
# and a "</^>" tag to the beginning - like the end of a tag
("""\\A""","""</^>"""),
# delete everything between the tags (blank space) leaving only the tags
("""</\\^>[\\w\\W]*?<\\^>""","""</^><^>"""),
# kill duplicate data from subsequent pages
("""POST<\\|>(.+)\\nTITLE<\\|>.+""","""POST<|>\\1"""),
# convert image links: nearly arbitrary HTML is allowed in Yuku
("""<img [^>]*src="([^"]+?)"[^>]*>""","""[img]\\1[/img]"""),
# Can't convert emotes -- not enough info.
# destroy any blank lines
("""^\\n""",""""""),
# and remove the blank line at the end.
("""\\n\\Z""",""""""),
# no code tags (not real ones anyway)
# attempt to parse quotes
('<blockquote><!SP><strong class="quote-title"><!SP>(.+?) wrote:<!SP></strong><!SP><hr><!SP>','[quote author=\\1]'),
('<blockquote><!SP>','[quote]'),
('<!SP></blockquote>','[/quote]'),
# b,i,u,s,pre,sub,sup,tt,center tags
("<(/?([bius]|pre|su[bp]|tt|center))>","[\\1]"),
# more of the same
("<(/?)strong[^>]*>","[\\1b]"),
("<(/?)em>","[\\1i]"),
# strike -> [s]
("<(/?s)trike>","[\\1]"),
# marquee -> [move]
("<(/?m)arquee>","[\\1ove]"),
# emails
("""<a href="mailto:([^"]+?)">(.+?)</a>""","""[email=\\1]\\2[/email]"""),
# URLs
("""<a [^>]*href="([^"]+?)"[^>]*>(.+?)</a>""","""[url=\\1]\\2[/url]"""),
# hr [horizontal line]
("""<hr[^>]*?>""","[hr]"),
# list tags
('<ol>',"[list type=decimal]"),
('<ol style="list-style-type: ([^"]+)">',"[list type=\\1]"),
("<ul>","[list]"),
("</[ou]l>","[/list]"), # closing tags
("<li/>","[*]"),
("<li[^>]*>","[li]"), # list item
("</li>","[/li]"),
# !@#$ arbitrary HTML. I'm not going to bother parsing the format tags.
]
re_repstrings=[]
for a,b in repstrings: re_repstrings+=[(re.compile(a.replace('<!SP>','(?:\\s|<[bB][rR][^>]*>)*')),b)] # compile all search patterns for increased efficiency; replace patterns aren't normal grep so they can't be compiled

def parsetime(tm,fmt=DATEFORMAT+' '+TIMEFORMAT): # glorious time parser, returns the UNIX time-since-epoch-in-seconds thing ;)
    return mktime(strptime(tm,fmt))

postid=1
topicdata,postdata={},[]

print "Downloading Forum Structure..."
out=open("categories_forums_smf.sql","w")
out.write('TRUNCATE TABLE `'+table_prefix+'boards`; TRUNCATE TABLE `'+table_prefix+'categories`;\n')
try:
    statusline="Categories ... "
    progressline=statusline+"Downloading - "
    pagedata = download_page(URL, progressline, COOKIEDATA)
    cats=re.findall(re_cats,pagedata)
    if not cats:
        print
        print "Failed to get any categories :("
        print "Please notify nneonneo."
        raw_input("Press <enter> to exit.")
        sys.exit(1)
    catorder = 0
    forumorder = 1
    for catid, name, data in cats:
        out.write('INSERT INTO `'+table_prefix+'categories` (ID_CAT, catOrder, name) VALUES (%s, %s, \'%s\');\n'%(catid, catorder, escape_vars([name])[0]))
        catorder += 1
        for fid, name, desc in re.findall(re_forums, data):
            boards.append(int(fid))
            out.write('INSERT INTO `'+table_prefix+'boards` (ID_BOARD, ID_CAT, childLevel, ID_PARENT, boardOrder, name, description) VALUES (%s, %s, 0, 0, %s, \'%s\', \'%s\');\n'%((fid, catid, forumorder)+tuple(escape_vars([name, desc]))))
            forumorder += 1
            statusline="Forum %s ... "%fid
            progressline=statusline+"Downloading - "
            forumdata = download_page(URL+"forums/%s"%fid, progressline, COOKIEDATA)
            subforums = re.findall(re_subforums, forumdata)
            for sfid, sname, sdesc in subforums:
                boards.append(int(sfid))
                out.write('INSERT INTO `'+table_prefix+'boards` (ID_BOARD, ID_CAT, childLevel, ID_PARENT, boardOrder, name, description) VALUES (%s, %s, 1, %s, %s, \'%s\', \'%s\');\n'%((sfid, catid, fid, forumorder)+tuple(escape_vars([sname, sdesc]))))
                forumorder += 1
    out.close()
    printline(statusline+"Completed!")
    print
except Exception:
    do_except("Categories and Forums", statusline)

print "Downloading Memberlist..."
out=open('members_smf.sql','w')
out.write('TRUNCATE TABLE `'+table_prefix+'members`;')
PM_data=open('pm_passwords.txt','w')
admin_list=[]
try:
    statusline="Admin list ... "
    progressline=statusline+"Downloading - "
    pagedata = download_page(URL+"directory/featured", progressline, COOKIEDATA)
    admin_list.extend(re.findall(owner_search, pagedata))
    data = re.findall(adminlist_search, pagedata)
    if data:
        admin_list.extend(re.findall(admin_search, data[0]))
    printline(statusline+"Completed!")
    print
except Exception:
    do_except('Admin list', statusline)

memberdata=[]
try:
    statusline="Members ... "
    progressline=statusline+"Downloading - "
    pagedata = download_page(URL+"domainstats/activemembers", progressline, COOKIEDATA)
    pages=re.findall(re_member_pages,pagedata)
    if pages:
        np=int(pages[0])
        for offset in range(2,np+1):
            progressline=statusline+"Downloading Page %i of %i - "%(offset,np)
            pagedata += download_page(URL+"domainstats/activemembers?page="+str(offset), progressline, COOKIEDATA)
    printline(statusline+"Finding Members")
    for i,m in enumerate(re.findall(member_search,pagedata)):
        try:
            statusline="Member %s ... "%m[0]
            printline(statusline+"Processing")
            memberid, data = m
            new_id = i+1
            joindate = parsetime(re.findall('<td class="joined">([^<]+)</td>',data)[0], DATEFORMAT)
            posts = int(re.findall('<td class="posts">([^<]+)</td>',data)[0].replace(',',''))
            member_url, memberid, name = re.findall('<a href="(http://([^"]+?)\\.yuku\\.com)" title="[^"]+s Profile">([^<]+)</a></p>',data)[0]
            avatar = re.findall('<p class="user-avatar"><a href=[^>]+><img src="([^"]+)"',data)[0]
            if avatar == '/common/bypass/images/missinng_avatar.gif': # missinng [sic]...
                avatar=''
            group = int(memberid in admin_list)
            random.seed(RANDOMNUMBER+hash(memberid)) # creates static member passwords: they will never change.
            password=randpw()
            passhash=md5hex(password)
            pgroup=postgroup(posts)
            PM_data.write("%s|%s|%s\n"%(memberid,name,password))
            printline(statusline+"Completed! User Password: %s"%password)
            memberdata+=[[new_id, memberid, group, pgroup, joindate, posts, name, avatar, passhash]]
            printline(statusline+"Completed!")
        except Exception:
            do_except('Member %s'%m[0], statusline)
    print # blank line for next part
except Exception:
    do_except('Members', statusline)
membernames = {}
memberdata.sort(key=lambda x:x[4]) # sort by date registered
for i,dat in enumerate(memberdata):
    memberdata[i][0]=i+1
    memberslist[dat[1]]=i+1
    name = memberid = dat[1]
    # fix up the name, and remove the suffix if possible
    if '.' in name:
        newname = name.rsplit('.',1)[0]
        if newname not in membernames:
            name = newname
    membernames[name] = memberid
    dat[6] = name
memberdata=[escape_vars(i) for i in memberdata]
for i in range(0,len(memberdata),members_max_group):
    out.write("INSERT INTO `"+table_prefix+"members` (`ID_MEMBER`,`memberName`,`realName`,`posts`,`dateRegistered`,`passwd`,`passwordSalt`,`avatar`,`ID_GROUP`,`ID_POST_GROUP`) VALUES ")
    out.write(',\n'.join(["(%i,'%s','%s',%i,%i,'%s','','%s',%i,%i)"%(dat[0],dat[6],dat[6],dat[5],dat[4],dat[8],dat[7],dat[2],dat[3]) for dat in memberdata[i:i+members_max_group]]))
    out.write(";\n")
PM_data.close()
out.close()

print "Downloading Boards..."
for board in boards:
    try:
        statusline="Board %s ... "%board
        progressline=statusline+"Downloading - "
        pagedata=download_page(URL+"forums/%i"%board, progressline, COOKIEDATA)
        pages=re.findall(re_pages,pagedata)
        if pages:
            np=int(pages[0])
            for offset in range(2,np+1):
                progressline=statusline+"Downloading Extra Page %i of %i - "%(offset-1,np-1)
                pagedata+=download_page(URL+"forums/%i?page=%i"%(board,offset), progressline, COOKIEDATA)
        printline(statusline+"Finding Topics")
        added_topics=re.findall(thread_search,pagedata)
        if CONVERTVIEWS:
            topicslist[board]=dict([(int(topic_id),(attribs.strip().split(' '),int(views.replace(',','')))) for attribs,topic_id,views in added_topics])
        else:
            topicslist[board]=dict([(int(topic_id),(attribs.strip().split(' '),0)) for attribs,topic_id in added_topics])
        printline(statusline+"Completed: %i topic%s"%(len(added_topics),int(len(added_topics)!=1)*'s'))
        print # blank line for next board
    except Exception:
        do_except("Board ID %s"%board, statusline)

''' This section will go through the topic IDs found before and download each topic.
The data is then processed and distilled into posts via the multiple regex's above.'''
print "Downloading Topics and Posts..."
for board in topicslist:
    for topicid in topicslist[board]:
        try:
            viewcount=topicslist[board][topicid][1]
            statusline="Topic %i, Board %s ... "%(topicid,board)
            progressline=statusline+"Downloading - "
            pagedata=download_page(URL+"topic/%i"%topicid, progressline, COOKIEDATA)
            pages=re.findall(re_pages,pagedata)
            if pages:
                np=int(pages[0])
                for offset in range(2,np+1):
                    progressline=statusline+"Downloading Page %i of %i - "%(offset,np) # 2 of 3, 3 of 3
                    pagedata+=download_page(URL+"topic/%i?page=%i"%(topicid,offset), progressline, COOKIEDATA)
            processed_data='  <forum_id=%i>'%board+pagedata
#           file("%i.txt"%topicid,"w").write(processed_data)
            cn=0
            for search,repl in re_repstrings:
                cn+=1
                printline(statusline+"Processing Step %i of %i"%(cn,len(re_repstrings)))
                processed_data=re.sub(search,repl,processed_data)
#               file("%i_%i.txt"%(topicid,cn),"w").write(processed_data)
            printline(statusline+"Converting Topic")
            forum,title=0,''
            posts=[]
            '''   0    1       2       3         4         5    6    7         8           '''
            '''<^>POST|Post ID|User ID|User Name|Date/Time|Text|EDIT|Edit Name|Edit Time</^>'''
            ''' 0    1  2      3    4        5        6    '''
            '''(time,id,userid,name,edittime,editname,data)'''
            for line in processed_data.split('</^><^>'):
                ln=line.strip()
                if not ln: continue
                ln=ln.split('<|>')
                if ln[0]=='FORUM':
                    forum=int(ln[1])
                    continue
                elif ln[0]=='TITLE':
                    title=ln[1]
                    continue
                elif ln[0]=='POST':
                    post=[0,0,0,'',0,'','']
                    if len(ln)==9:
                        if ln[6]=='EDIT':
                            post[4]=parsetime(ln[8])
                            post[5]=ln[7]
                    try:
                        post[0]=parsetime(ln[4].strip('(').strip(')')) # brackets? wtf?
                        assert post[0] >= time()-(3600*24*365*15), "Post is more than 15 years old!"
                        assert post[0] <= time()+(3600*24*180), "Post is more than half a year in the future!"
                    except Exception:
                        do_except('Post %s: Bad timestamp %s'%(ln[1],ln[4]),statusline)
                        continue
                    post[1]=int(ln[1])
                    if ln[2]: post[2]=memberslist.get(ln[2],0)
                    post[3]=ln[3]
                    post[6]=ln[5].strip()
                    post[6]=re.sub('\n*<[Bb][Rr] ?/?>\n*','<br />',post[6]).replace('\n',' ')
                    selflinks=re.findall("(/topic/(\\d+))",post[6])
                    for link in selflinks:
                        try: post[6]=post[6].replace(link[0],"?topic="+link[1])
                        except KeyError: continue
                    posts+=[post]
            if not posts:
                printline(statusline+"Error: Topic is empty!")
                print # a blank line, for the next topic
                continue
            posts.sort(key=lambda x:x[0]) # sort by date code only
            # This is for SMF
            ''' `ID_TOPIC` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,`
                `isSticky` tinyint(4) NOT NULL DEFAULT '0',
                `ID_BOARD` smallint(5) unsigned NOT NULL DEFAULT '0',
                `ID_FIRST_MSG` int(10) unsigned NOT NULL DEFAULT '0',
                `ID_LAST_MSG` int(10) unsigned NOT NULL DEFAULT '0',
                `ID_MEMBER_STARTED` mediumint(8) unsigned NOT NULL DEFAULT '0',
                `ID_MEMBER_UPDATED` mediumint(8) unsigned NOT NULL DEFAULT '0',
                `ID_POLL` mediumint(8) unsigned NOT NULL DEFAULT '0',
                `numReplies` int(10) unsigned NOT NULL DEFAULT '0',
                `numViews` int(10) unsigned NOT NULL DEFAULT '0',
                `locked` tinyint(4) NOT NULL DEFAULT '0'
                '''
            # change this for a different forum
            topicdata[topicid]=[topicid,"row-sticky" in topicslist[board][topicid][0],forum,posts[0][1],posts[-1][1],posts[0][2],posts[-1][2],len(posts)-1,viewcount,"row-closed" in topicslist[board][topicid][0]]
            for post in posts:
                ''' `ID_MSG` int(10) unsigned NOT NULL AUTO_INCREMENT,
                    `ID_TOPIC` mediumint(8) unsigned NOT NULL DEFAULT '0',
                    `ID_BOARD` smallint(5) unsigned NOT NULL DEFAULT '0',
                    `posterTime` int(10) unsigned NOT NULL DEFAULT '0',
                    `ID_MEMBER` mediumint(8) unsigned NOT NULL DEFAULT '0',
                    `ID_MSG_MODIFIED` mediumint(8) unsigned NOT NULL DEFAULT '0',
                    `subject` tinytext NOT NULL,
                    `posterName` tinytext NOT NULL,
                    `posterEmail` tinytext NOT NULL,
                    `posterIP` tinytext NOT NULL,
                    `smileysEnabled` tinyint(4) NOT NULL DEFAULT '1',
                    `modifiedTime` int(10) unsigned NOT NULL DEFAULT '0',
                    `modifiedName` tinytext NOT NULL,
                    `body` text NOT NULL,
                    `icon` varchar(16) NOT NULL DEFAULT 'xx'
                    '''
                ''' 0    1  2      3    4        5        6    '''
                '''(time,id,userid,name,edittime,editname,data)'''
                # change this for a different forum
                postdata+=[[post[1],topicid,forum,post[0],post[2],post[1],title,post[3],post[4],post[5],post[6]]]
            printline(statusline+"Completed: %i post%s"%(len(posts),int(len(posts)!=1)*'s'))
            print # blank line for next topic
        except KeyboardInterrupt: break # abort processing this board
        except Exception:
            do_except('Topic ID %s in Board %s'%(topicid,board), statusline)
# POST ID RENUMBERING - WITHOUT THIS SMF WILL SORT YOUR POSTS STRANGELY
print "Renumbering Posts"
postdata.sort(key=lambda x:x[3]) # sort by date [4th value; index 3]
postid=1
postmap={}
for i,pd in enumerate(postdata): # i will be index, pd will be the data
    oldid=pd[0] # save old id
    postdata[i][0]=postid # set new ID_MSG
    postdata[i][5]=postid # set new ID_MSG_MODIFIED
    if topicdata[pd[1]][3]==oldid: topicdata[pd[1]][3]=postid # check ID_FIRST_MSG
    if topicdata[pd[1]][4]==oldid: topicdata[pd[1]][4]=postid # check ID_LAST_MSG
    postid+=1
# END RENUMBERING
out=open('topics_posts_smf.sql','w')
out.write('TRUNCATE TABLE `%stopics`;TRUNCATE TABLE `%smessages`;'%(table_prefix,table_prefix))
# change these two for a different forum
topicdata_vals=[escape_vars(i) for i in topicdata.values()]
postdata=[escape_vars(i) for i in postdata]
for i in range(0,len(topicdata_vals),topics_max_group):
    out.write('INSERT INTO `%stopics` (`ID_TOPIC`,`isSticky`,`ID_BOARD`,`ID_FIRST_MSG`,`ID_LAST_MSG`,`ID_MEMBER_STARTED`,`ID_MEMBER_UPDATED`,`ID_POLL`,`numReplies`,`numViews`,`locked`) VALUES '%table_prefix)
    out.write(',\n'.join(["(%i,%i,%i,%i,%i,%i,%i,0,%i,%i,%i)"%tuple(dat) for dat in topicdata_vals[i:i+topics_max_group]]))
    out.write(";\n")
for i in range(0,len(postdata),posts_max_group):
    out.write('INSERT INTO `%smessages` (`ID_MSG`,`ID_TOPIC`,`ID_BOARD`,`posterTime`,`ID_MEMBER`,`ID_MSG_MODIFIED`,`subject`,`posterName`,`posterEmail`,`posterIP`,`smileysEnabled`,`modifiedTime`,`modifiedName`,`body`,`icon`) VALUES '%table_prefix)
    out.write(',\n'.join(["(%i,%i,%i,%i,%i,%i,'%s','%s','','unknown',1,%i,'%s','%s','xx')"%tuple(dat) for dat in postdata[i:i+posts_max_group]]))
    out.write(";\n")
out.close()
print 'Elapsed Conversion Time %.02f seconds' % (time() - beg_time)
print 'Converted',len(postdata),'posts and',len(topicdata),'topics.'
raw_input("Complete! Press <enter> to exit.")
