#!/usr/bin/python
'''phpBB2 (crawler) to phpBB2 Converter by nneonneo
Version 0.1.1
Topics and Posts Part
Mar 13 2010
Updated Apr 1 2011'''
import re,urllib,sys,random,cgi
from time import strftime,strptime,mktime,time,localtime
try:
    from settings import *
except Exception, detail:
    print "Error: Settings file has some error."
    print "Details of the error:"
    sys.excepthook(*sys.exc_info())
    raw_input("Press <enter> to quit.")
    sys.exit(1)
sys.path.append('..')
from common import *

# Don't edit this file, unless you are SURE you know what you are doing.
topics_max_group = 500
posts_max_group = 200
members_max_group = 500
beg_time=time()
# category detection
re_cats=re.compile(r'<span class="cattitle">\s*<a href="[^"]*c=(\d+)[^"]*" class="cattitle">(.*?)</a></span></td>([\w\W]*?)(?:<td class="catLeft"|</table>)')

# forum detection
re_forums=re.compile(r'<span class="forumlink">\s*<a href="[^"]*(?:f=|,)(\d+)/?" class="forumlink">(.*?)</a><br />\s*</span>\s*<span class="genmed">([\w\W]*?)<br />\s*</span><span class="gensmall">')

re_pages=re.compile(r'Goto page <b>1</b>.+?">(\d+)</a>&nbsp;&nbsp;')

re_topicviews=re.compile(r'<img src="[^"]*images/folder([^"]*)\.gif" width="19"[\w\W]*?<a href="[^"]*(?:t=|,)(\d+)(?:\.html)?" class="topictitle">[\w\W]*?<td class="row2" align="center" valign="middle"><span class="postdetails">([\d,]+)</span></td>\s*<td class="row3Right"')
# the massive grep list of doom!
# the grep list works by changing certain things to delimited, structured data. The delimiters are "<^>" at the start and "</^>" at the end of a record, and the fields are separated with "<|>".
repstrings=[
# detect the title of the topic
("""<a class="maintitle" href="[^"]*">(.+?)</a>""","""<^>TITLE<|>\\1</^>"""),
("""<title>.+View topic - (.+?)</title>""","""<^>TITLE<|>\\1</^>"""),
#'''   0      1         2         3           4           5      6      7           8           9             '''
#'''<^>POST<|>Post ID<|>Subject<|>User Name<|>Date/Time<|>Text<|>EDIT<|>Edit Name<|>Edit Time<|>Edit Count</^>'''
# !!! the big one: get the entire post
("""<span class="name"><a name="(\\d+)"></a><b>(.+?)</b></span><br />[\\w\\W]*?<span class="postdetails">Posted: (.+?)(?:<br />MOVED<br />.+?)?<span class="gen">&nbsp;</span>&nbsp; &nbsp;Post subject: (.*?)</span></td>[\\w\\W]*?<span class="postbody">([\\w\\W]*?)(?:<br />_________________<br />[\\w\\W]*?)?(?:</span>\\s*<span class="gensmall">.*(Last edited by .+? on .+?; edited \\d+ times? in total|))?</span>\\s*</td>\n\\s+</tr>""","""<^>POST<|>\\1<|>\\4<|>\\2<|>\\3<|>\\5<^EDIT^>\\6</^>"""),
# edit info
("""<\\^EDIT\\^></\\^>""","""</^>"""),
("""<\\^EDIT\\^>Last edited by (.*?) on (.*?); edited (\\d+) times? in total</\\^>""","""<|>EDIT<|>\\1<|>\\2<|>\\3</^>"""),
# add a "<^>" tag to the end of the file - acts like the start of a tag
("""\\Z""","""<^>"""),
# and a "</^>" tag to the beginning - like the end of a tag
("""\\A""","""</^>"""),
# delete everything between the tags (blank space) leaving only the tags
("""</\\^>[\\w\\W]*?<\\^>""","""</^><^>"""),
# kill duplicate data from subsequent pages
("""POST<\\|>(.+)\\nTITLE<\\|>.+""","""POST<|>\\1"""),
# destroy any blank lines
("""^\\n""",""""""),
# and remove the blank line at the end.
("""\\n\\Z""","""""")]
# BBCode-only repstrings; these will be run exclusively on post text
bbcode_repstrings=[
# remove imagehelper JS
(r"""<script language="javascript" type="text/javascript">\s*<!--\s*function pointercursor[\w\W]*</script> """, ""),
# convert image links
("""<img src="([^"]+)" (?:alt="[^"]*" )?border="0"[^>]*/>""","[img:<UID>]\\1[/img:<UID>]"),
# quotes: no author
("""</span>\\s*<table width="[^"]*" cellspacing="[^"]*" cellpadding="[^"]*" border="0" align="center">\\s*<tr>\\s*<td><span class="genmed"><b>Quote:</b></span></td>\\s*</tr>\\s*<tr>\\s*<td class="quote">""","[quote:<UID>]"),
# quotes: anything else (phpBB only supports author argument)
("""</span>\\s*<table width="[^"]*" cellspacing="[^"]*" cellpadding="[^"]*" border="0" align="center">\\s*<tr>\\s*<td><span class="genmed"><b>(.+?) wrote:</b></span></td>\\s*</tr>\\s*<tr>\\s*<td class="quote">""","[quote:<UID>=\"\\1\"]"),
# quotes: closing (also closes code tags, which is a bug...)
("""</td>\\s*</tr>\\s*</table>\\s*<span class="postbody">""","[/quote:<UID>]"),
# code tags
("""</span>\\s*<table width="[^"]*" cellspacing="[^"]*" cellpadding="[^"]*" border="0" align="center">\\s*<tr>\\s*<td><span class="genmed"><b>Code:</b></span></td>\\s*</tr>\\s*<tr>\\s*<td class="code">""","[code:<UID>]"),
# emails (phpBB autoparses valid emails)
("""<a href="mailto:([^"]+?)">(?:<u>)?(.+?)(?:</u>)?</a>""","""[email]\\1[/email]"""),
# convert URL links
("""<a href="([^"]+?)"[^>]*?>(?:<u>)?(.+?)(?:</u>)?</a>""","""[url=\\1]\\2[/url]"""),
# list tags
("<ol type=['\"]([1aAiI])['\"]>","[list=\\1:<UID>]"),
("<ul>","[list:<UID>]"), # unordered
("</ol>","[/list:o:<UID>]"), # closing tag
("</ul>","[/list:u:<UID>]"), # closing tag
("<li/>","[*:<UID>]"),
("<li>","[*:<UID>]"), # list item
("</li>",""), # no end tag needed
]

re_repstrings=[(re.compile(a),b) for a,b in repstrings]
re_bbcode=[(re.compile(a),b) for a,b in bbcode_repstrings]

def parsetime(tm,fmt=None): # glorious time parser, returns the UNIX time-since-epoch-in-seconds thing ;)
    if fmt is None:
        return int(tm) # if you followed the instructions, all dates should now be UNIX timestamps, so we can CHEAT.
    # or we could do this the long way
    return mktime(
        strptime(
            tm.replace("Sept","Sep").
                           replace("<b>Today</b> at ",strftime('%Y-%m-%d, ')).
                           replace("[b]Today[/b] at ",strftime('%Y-%m-%d, ')).
                           replace("Today at ",strftime('%Y-%m-%d, ')).
                           replace("Yesterday at ",strftime('%Y-%m-%d, ',localtime(time()-24*3600)))
            ,fmt)
        )

def parsespans(dat):
    # copied from IF converter
    sb="<span"
    se='</span>'
    begin_off=dat.find(sb)
    if begin_off==-1: return dat # no spans!
    out=dat[:begin_off] # data right up to the span
    rest=dat[begin_off+len(sb):] # the remainder, after the sb block
    lwrrest=rest.lower()
    if not lwrrest.startswith(' style="'):
        starttag=endtag=type=''
    elif lwrrest.startswith(' style="font-weight: bold"'):
        type='b'
        starttag='[b:<UID>]'
        endtag='[/b:<UID>]'
    elif lwrrest.startswith(' style="font-style: italic"'):
        type='i'
        starttag='[i:<UID>]'
        endtag='[/i:<UID>]'
    elif lwrrest.startswith(' style="text-decoration: underline"'):
        type='u'
        starttag='[u:<UID>]'
        endtag='[/u:<UID>]'
    elif lwrrest.startswith(' style="font-size: '):
        type='size'
        tagparams=rest[len(' style="font-size: '):].split(';')[0].rstrip('px')
        starttag='[size=%s:<UID>]'%tagparams
        endtag='[/size:<UID>]'
    elif lwrrest.startswith(' style="color: '):
        type="color"
        tagparams=rest[len(' style="color: '):].split('"')[0]
        starttag='[color=%s:<UID>]'%tagparams
        endtag='[/color:<UID>]'
    else:
        starttag=endtag=type=''
    spandata=starttag
    se_off=rest.find(">") # nearest span ending
    if se_off==-1:
        print "Warning: Invalid <span> found!!"
        return dat
    rest=rest[se_off+1:] # what's after the > ?
    text=rest
    nestlevel=1 # nesting level: we're inside one span
    while nestlevel:
        se_off=rest.find(se) # where's the </span>
        sb_off=rest.find(sb) # or another <span
        if se_off==-1: 
            print "Warning: No </span> found!!"
            return dat
        if sb_off==-1 or se_off<sb_off: # no new beginning (sb) before the se? good news!
            nestlevel-=1
            rest=rest[se_off+len(se):]
            continue
        elif sb_off!=-1 and sb_off<se_off: # a new beginning? darn. process it. new beginning must be before the end.
            rest=rest[sb_off+len(sb):] 
            nestlevel+=1 # increase nesting level, we won't actually process it, this just helps us find the exact block of this span
            continue
    spandata+=parsespans(text[:-(len(rest)+len(se))])+endtag # gotcha! the end of the span. Now, process the innards for nested spans.
    spandata+=parsespans(rest) # parse the rest
    return out+spandata

''' This section will download each individual member page and process it, extracting
all the visible profile data. Members will then be renumbered according to join date
so that the member order matches the order obtained if they had signed up in phpBB.'''

print "Downloading Members..."
out=open('members_phpBB.sql','w')
out.write('TRUNCATE TABLE `'+table_prefix+'users`;'+'TRUNCATE TABLE `'+table_prefix+'user_group`;'+'TRUNCATE TABLE `'+table_prefix+'groups`;INSERT INTO '+table_prefix+'''users (user_id, user_active, username, user_password, user_session_time, user_session_page, user_lastvisit, user_regdate, user_level, user_posts, user_timezone, user_style, user_lang, user_dateformat, user_new_privmsg, user_unread_privmsg, user_last_privmsg, user_login_tries, user_last_login_try, user_emailtime, user_viewemail, user_attachsig, user_allowhtml, user_allowbbcode, user_allowsmile, user_allowavatar, user_allow_pm, user_allow_viewonline, user_notify, user_notify_pm, user_popup_pm, user_rank, user_avatar, user_avatar_type, user_email, user_icq, user_website, user_from, user_sig, user_sig_bbcode_uid, user_aim, user_yim, user_msnm, user_occ, user_interests, user_actkey, user_newpasswd) VALUES('-1', '0', 'Anonymous', '', '0', '0', '0', '0', '0', '0', '0.00', NULL, 'english', '', '0', '0', '0', '0', '0', NULL, '0', '0', '1', '1', '1', '1', '0', '1', '0', '1', '0', NULL, '', '0', '', '', '', '', '', NULL, '', '', '', '', '', '', '');INSERT INTO '''+table_prefix+'''groups (group_id, group_type, group_name, group_description, group_moderator, group_single_user) VALUES('1', '1', 'Anonymous', 'Personal User', '0', '1');INSERT INTO '''+table_prefix+'''user_group (group_id, user_id, user_pending) VALUES('1', '-1', '0');''')
PM_data=open('pm_passwords.txt','w')
memberdata=[]
memberslist={}
for memberid in range(1,NUMUSERS+1):
    try:
        random.seed(RANDOMNUMBER+hash(memberid)) # creates static member passwords: they will never change.
        statusline="Member %s ... "%memberid
        userdata=download_page(URL+'profile.php?mode=viewprofile&u='+str(memberid),statusline+"Downloading - ",COOKIEDATA)
        # Fix ICQ field
        userdata=re.sub(r'<td class="row1"><script language="JavaScript" type="text/javascript"><!-- [\w\W]*?</script><noscript>(.+?)</noscript></td>', r'<td class="row1"><span class="gen">\1</span></td>', userdata)
        p=re.findall("""<span class="gen">([^<>\\n]+?):(?:&nbsp;)?</span></td>\\s*<td[^>]*>\\s*(?:<b>)?<span class="gen">(?:<b>)?(.+?)(?:</b>)?</span>(?:</b>)?""",userdata)
        p+=re.findall('            ([a-zA-Z ]+):&nbsp;(.*)', userdata)
        if not p: # oops, no profile lines found
            printline(statusline+"Warning: Member doesn't exist!")
            print
            continue
        """
        Indices of "dat" mapped to phpBB phpbb_users columns
        0:user_id
        1:username
        2:[realName]
        3:user_email
        4:[websiteTitle]
        5:user_website
        6:user_birthday
        7:[gender]
        8:user_from
        9:user_posts
        10:[karmaGood] <-- warning, could be negative; I wonder how that's handled?
        11:user_regdate
        12:user_icq
        13:user_aim
        14:user_yim
        15:user_msnm
        16:user_lastvisit
        17:user_password
        18:user_avatar
        19:user_level
        20:[ID_POST_GROUP]
        21:user_occ
        22:user_interests
        """
        dat=[memberid+1,'','','','','',' 0- 0-   0',0,'',0,0,0,'','','','',0,'','',0,0,'','']
        dat[1]=dat[2]=(re.findall('<th[^>]*>(?:<b>)?Viewing profile :: (.+?)(?:</b>)?</th>',userdata) or [''])[0]
        dat[1]=re.sub('<[^>]*>','',dat[1]) # strip tags
        dat[1]=dat[1].replace('&gt;','>').replace('&lt;','<') # replace entities
        dat[18]=(re.findall('<img src="([^"]+?)" alt=""[^>]*border="0"[^>]*/>',userdata) or [''])[0]
        if ADMINSID:
            try:
                admindata=download_page(URL+"admin/admin_users.php?sid=%s"%ADMINSID,statusline+"Retrieving e-mail address ... ",COOKIEDATA,data=urllib.urlencode({'mode':'edit', 'username':dat[1]}))
                dat[3]=re.findall('<input [^>]*name="email"[^>]*value="([^"]*)" />', admindata)[0]
            except Exception:
                do_except('Member ID %s (e-mail retrieval)'%memberid, statusline)
            try:
                admindata=download_page(URL+"admin/admin_ug_auth.php?sid=%s"%ADMINSID,statusline+"Retrieving user rank ... ",COOKIEDATA,data=urllib.urlencode({'mode':'user', 'username':dat[1]}))
                if '<option value="admin" selected="selected">Administrator</option>' in admindata:
                    dat[19]=1
            except Exception:
                do_except('Member ID %s (rank retrieval)'%memberid, statusline)
        else:
            for userlevel in ('Administrator','Site Admin'):
                if '<br /><span class="postdetails">%s</span></td>'%userlevel in userdata:
                    dat[19]=1

        for t,i in p:
            try:
                t=t.strip(':')
                i=i.strip()
                i=i.replace('<br />', '')
                if i=='&nbsp;' or i=='None': continue
                if t=='Avatar': pass
                elif t=='Location': dat[8]=i
                elif t=='Gender': dat[7]={'Male':1,'Female':2}.get(i,0)
                elif t=='Occupation': dat[21]=i
                elif t=='Interests': dat[22]=i
                elif t=='E-mail address':
                    email=re.findall('<a href="mailto:(.+?)">',i)
                    if email:
                        dat[3]=email[0]
                elif t=='Website': dat[5],dat[4]=(re.findall("""<a href="(.+?)" target="_userwww">(.+?)</a>""",i) or [('','')])[0]
                elif t=='Private Message': pass
                elif t=='MSN Messenger': dat[15]=i
                elif t=='Yahoo Messenger': dat[14]=re.findall("""<a href="http://edit.yahoo.com/config/send_webmesg\\?.target=(.+?)&amp;.src=pg">""",i)[0]
                elif t=='AIM Address':
                    for pattern in ('<a href="gg:(.+?)">', 'aim:goim\\?screenname=([^"]+?)&amp;'):
                        res = re.findall(pattern, i)
                        if res:
                            dat[13] = res[0]
                            break
                elif t=='ICQ Number': dat[12]=re.findall("""<a href="http://wwp.icq.com/scripts/search.dll\\?to=(.+?)">""",i)[0]
                elif t=='Joined': dat[11]=parsetime(i,'%d %b %Y')
                elif t=='Last visited':
                    if i!='NEVER LOGGED':
                        dat[16]=parsetime(i.split(' (')[0])
                elif t=='Total posts': dat[9]=int(i.split('&nbsp;')[0])
                elif t=='Read topics': pass
                elif t=='Favourite forums': pass
                else:
                    print # blank line; prevent overwrite
                    print "\tUnknown field %s, data %s"%(t,i)
            except ValueError,detail:
                print # blank line to prevent overwrite
                print "\tError:",detail
        memberslist[dat[1]]=dat[0]
        printline(statusline+"Processing")
        password=randpw()
        dat[17]=md5hex(password)
        #dat[20]=postgroup(dat[9]) # compute post group AFTER we've got the posts
        memberdata+=[dat]
        PM_data.write("%s|%s\n"%(dat[1],password))
        printline(statusline+"Completed! User Password: %s"%password)
        print # blank line for next member
    except Exception:
        do_except('Member ID %s'%memberid, statusline)
memberdata=[escape_vars(i) for i in memberdata]
for i in range(0,len(memberdata),members_max_group):
    out.write("INSERT INTO `"+table_prefix+"users` (user_id, username, user_email, user_website, user_from, user_posts, user_regdate, user_icq, user_aim, user_yim, user_msnm, user_lastvisit, user_password, user_avatar, user_level, user_occ, user_interests, user_sig, user_viewemail, user_style, user_attachsig, user_lang, user_actkey, user_newpasswd, user_avatar_type) VALUES ")
    out.write(',\n'.join(["(%i, '%s', '%s', '%s', '%s', %i, %i, '%s', '%s', '%s', '%s', %i, '%s', '%s', '%s', '%s', '%s', '', 0, NULL, 0, '', '', '', '2')"%(dat[0],dat[1],dat[3],dat[5],dat[8],dat[9],dat[11],dat[12],dat[13],dat[14],dat[15],dat[16],dat[17],dat[18],dat[19],dat[21],dat[22]) for dat in memberdata[i:i+members_max_group]]))
    out.write(";\n")
    out.write("INSERT INTO `"+table_prefix+"groups` (group_id, group_type, group_name, group_description, group_moderator, group_single_user) VALUES ")
    out.write(',\n'.join(["('%i', '1', '%s', 'Personal User', '0', '1')"%(dat[0]+1,'Admin'*dat[19]) for dat in memberdata[i:i+members_max_group]]))
    out.write(";\n")
    out.write("INSERT INTO `"+table_prefix+"user_group` (group_id, user_id, user_pending) VALUES ")
    out.write(',\n'.join(["('%i', '%i', '0')"%(dat[0]+1,dat[0]) for dat in memberdata[i:i+members_max_group]]))
    out.write(";\n")
PM_data.close()
out.close()

topics={} # topicid -> (forumid, topicviews)
SEEN=set()
print "Downloading Forum Structure..."
out=open("categories_forums_phpBB.sql","w")
out.write('TRUNCATE TABLE `'+table_prefix+'forums`; TRUNCATE TABLE `'+table_prefix+'categories`;\n')
try:
    statusline="Categories ... "
    progressline=statusline+"Downloading - "
    pagedata = download_page(URL+"index.php", progressline, COOKIEDATA)
    cats=re.findall(re_cats,pagedata)
    if not cats:
        print
        print "Failed to get any categories :("
        print "Please notify nneonneo."
        raw_input("Press <enter> to exit.")
        sys.exit(1)
    catnumber = 1
    forumnumber = 1
    def dl_cvt_subforum(catnumber, cid, fid, forumnumber, name, desc):
        ''' recursively download and convert subforums '''
        if (cid, fid) in SEEN:
            return forumnumber
        SEEN.add((cid, fid))
        nextfn=forumnumber
        if fid is None:
            out.write('INSERT INTO `'+table_prefix+'categories` (cat_id, cat_order, cat_title) VALUES (%s, %s, \'%s\');\n'%(catnumber, catnumber*10, escape_vars([name])[0]))
            statusline="Category %s ... "%cid
            u='index.php?c=%s'%cid
        else:
            out.write('INSERT INTO `'+table_prefix+'forums` (forum_id, cat_id, forum_order, forum_name, forum_desc) VALUES (%s, %s, %s, \'%s\', \'%s\');\n'%((forumnumber, catnumber, forumnumber*10)+tuple(escape_vars([name, desc]))))
            statusline="Forum %s ... "%fid
            nextfn += 1
            u='viewforum.php?f=%s'%fid

        progressline=statusline+"Downloading - "
        forumdata = download_page(URL+u, progressline, COOKIEDATA)
        pagedata=forumdata
        pages=re.findall(re_pages,pagedata)
        if pages and pages[0]!='1':
            np=int(pages[0])
            perpage=int(re.findall('(?:f=|,)%s(?:&amp;topicdays=0&amp;start=|-)(\\d+)/?">2</a>'%fid, pagedata)[0])
            for offset in range(1,np):
                progressline=statusline+"Downloading Extra Page %i of %i - "%(offset,np-1)
                pagedata+=download_page(URL+'viewforum.php?f=%s&start=%i'%(fid,offset*perpage),progressline,COOKIEDATA)
        for status,tid,v in re.findall(re_topicviews,pagedata):
            topics[int(tid)]=(forumnumber,int(v.replace(',','')),status)
        for sfid, sname, sdesc in re.findall(re_forums, forumdata):
            nextfn=dl_cvt_subforum(catnumber, cid, sfid, nextfn, sname, sdesc)
        return nextfn

    for catid, name, data in cats:
        forumnumber=dl_cvt_subforum(catnumber, catid, None, forumnumber, name, '')
        catnumber += 1
    out.close()
    printline(statusline+"Completed!")
    print
except Exception:
    do_except("Categories and Forums", statusline)

try:
    statusline="Smileys ... "
    progressline=statusline+"Downloading - "
    pagedata=download_page(URL+'posting.php?mode=smilies',progressline,COOKIEDATA)
    smilies=[(re.compile('<img src="%s" alt="[^"]*" border="0" />'%r[1]), r[0]) for r in re.findall(r"""<a href="javascript:emoticon\('([^']*)'\)"><img src="([^"]*)" """, pagedata)]
    re_bbcode = smilies+re_bbcode
    printline(statusline+"Completed!")
    print
except Exception:
    do_except("Smileys", statusline)

postid=1
topicdata,postdata={},[]
forum_stats={} # topics, posts, latest_post_id, latest_post_time; this will store forum stats so we can update the DB with that information.
for topicid in topics:
    try:
        forum,viewcount,status=topics[topicid]
        statusline="Topic ID %i ... "%topicid
        progressline=statusline+"Downloading - "
        pagedata=download_page(URL+'viewtopic.php?t=%s'%topicid,progressline,COOKIEDATA)
        pages=re.findall(re_pages,pagedata)
        if pages and pages[0]!='1':
            np=int(pages[0])
            perpage=int(re.findall('(?:amp;start=|-)(\\d+)(?:\.html)?">2</a>',pagedata)[0])
            for offset in range(1,np):
                progressline=statusline+"Downloading Extra Page %i of %i - "%(offset,np-1)
                pagedata+=download_page(URL+'viewtopic.php?t=%s&start=%i'%(topicid,offset*perpage),progressline,COOKIEDATA)
        processed_data=pagedata
        cn=0
        for search,repl in re_repstrings:
            cn+=1
            printline(statusline+"Processing Step %i of %i"%(cn,len(re_repstrings)))
#           file("%i_%i.txt"%(topicid,cn),"w").write(processed_data)
            processed_data=re.sub(search,repl,processed_data)
        printline(statusline+"Converting Topic")
        title=''
        posts=[] # will hold tuples of (time,id,userid,name,edittime,editname,data)
        '''   0      1         2         3           4           5      6      7           8           9             '''
        '''<^>POST<|>Post ID<|>User ID<|>User Name<|>Date/Time<|>Text<|>EDIT<|>Edit Name<|>Edit Time<|>Edit Count</^>'''
        ''' 0    1  2      3    4        5        6    7         8'''
        '''(time,id,userid,name,edittime,editname,data,editcount,subject)'''
        for line in processed_data.split('</^><^>'):
            ln=line.strip()
            if not ln: continue
            ln=ln.split('<|>')
            if ln[0]=='TITLE' and not title:
                title=cgi.escape(ln[1])
                continue
            elif ln[0]=='POST':
                post=[0,0,0,'',0,0,'',0,'']
                if len(ln)==10 and ln[6]=='EDIT':
                    post[4]=parsetime(ln[8])
                    post[5]=memberslist.get(ln[7],-1)
                    post[7]=int(ln[9])
                post[0]=parsetime(ln[4])
                post[1]=int(ln[1])
                post[2]=memberslist.get(ln[3],-1)
                #if ln[2]: post[2]=int(ln[2])+1
                post[3]=ln[3]
                post_text=ln[5].strip()
                for search,repl in re_bbcode:
                    post_text=re.sub(search,repl,post_text)
                post[6]=parsespans(post_text)
                post[8]=ln[2]
                posts+=[post]
        if not posts:
            printline(statusline+"Error: Topic is empty!")
            print # a blank line, for the next topic
            continue
        posts.sort(key=lambda x:x[0]) # sort by date code only
        # change this for a different forum
        if 'sticky' in status:
            topictype = 1
        elif 'announce' in status:
            topictype = 2
        else:
            topictype = 0
        topicdata[topicid]=[topicid,topictype,forum,posts[0][1],posts[-1][1],posts[0][2],posts[0][0],title,len(posts)-1,viewcount,int('lock' in status)]
        for post in posts:
            ''' 0    1  2      3    4        5        6    '''
            '''(time,id,userid,name,edittime,editname,data)'''
            # change this for a different forum
            bbcode_uid='%010x'%random.randint(0,0xFFFFFFFFFFL)
            post[6]=post[6].replace(":<UID>",":"+bbcode_uid).replace('\n',' ').replace('<br />','\n')
            post[6]=re.sub('[^\\S\\n]*\n[^\\S\\n]*','\n',post[6])
            postdata+=[[[post[1],topicid,forum,post[2],post[0],'00000000',post[3],post[4],bool(post[4])*1],
                         [post[1],bbcode_uid,post[8],post[6]]]]
        printline(statusline+"Completed: %i post%s"%(len(posts),int(len(posts)!=1)*'s'))
        print # blank line for next topic
    except KeyboardInterrupt: break
    except Exception:
        do_except("Topic ID %i"%topicid, statusline)
# POST ID RENUMBERING
# FORUM STATISTIC COUNTING
forum_stats={}
print "Renumbering Posts"
postdata.sort(key=lambda x:x[0][4]) # sort by date [5th value; index 4]
postid=1
postmap={}
for i,pd in enumerate(postdata): # i will be index, pd will be the data
    oldid=pd[0][0] # save old id
    postdata[i][0][0]=postid # set new posts: post_id
    postdata[i][1][0]=postid # set new posts_text: post_id
    if topicdata[pd[0][1]][3]==oldid: topicdata[pd[0][1]][3]=postid # check ID_FIRST_MSG
    if topicdata[pd[0][1]][4]==oldid: topicdata[pd[0][1]][4]=postid # check ID_LAST_MSG
    postmap['%i/%i'%(pd[0][1],oldid)]=postid
    if pd[0][2] not in forum_stats: forum_stats[pd[0][2]] = [0,0,0]
    forum_stats[pd[0][2]][1]+=1
    forum_stats[pd[0][2]][2]=postid
    postid+=1
for td in topicdata:
    forum_stats[topicdata[td][2]][0]+=1
# END RENUMBERING
out=open('topics_posts_phpBB.sql','w')
out.write('TRUNCATE TABLE `%stopics`;TRUNCATE TABLE `%sposts`;TRUNCATE TABLE `%sposts_text`;'%(table_prefix,table_prefix,table_prefix))
# change these two for a different forum
topicdata_vals=[escape_vars(i) for i in topicdata.values()]
postdata=[[escape_vars(c) for c in i] for i in postdata]
for i in range(0,len(topicdata_vals),topics_max_group):
    out.write("INSERT INTO `%stopics` (`topic_id`,`topic_type`,`forum_id`,`topic_first_post_id`,`topic_last_post_id`,`topic_poster`,`topic_time`,`topic_title`,`topic_replies`,`topic_views`,`topic_status`) VALUES "%table_prefix)
    out.write(',\n'.join(["(%i,%i,%i,%i,%i,%i,%i,'%s',%i,%i,%i)"%tuple(td) for td in topicdata_vals[i:i+topics_max_group]]))
    out.write(";\n")
for i in range(0,len(postdata),posts_max_group):
    out.write("INSERT INTO `%sposts` (`post_id`,`topic_id`,`forum_id`,`poster_id`,`post_time`,`poster_ip`,`post_username`,`post_edit_time`,`post_edit_count`) VALUES "%table_prefix)
    out.write(',\n'.join(["(%i,%i,%i,%i,%i,'%s','%s',%i,%i)"%tuple(pd[0]) for pd in postdata[i:i+posts_max_group]]))
    out.write(";\n")
for i in range(0,len(postdata),posts_max_group):
    out.write("INSERT INTO `%sposts_text` (`post_id`,`bbcode_uid`,`post_subject`,`post_text`) VALUES "%table_prefix)
    out.write(',\n'.join(["(%i,'%s','%s','%s')"%tuple(pd[1]) for pd in postdata[i:i+posts_max_group]]))
    out.write(";\n")
for fs in forum_stats: out.write('UPDATE `%sforums` SET forum_topics=%i,forum_posts=%i,forum_last_post_id=%i WHERE forum_id=%i;\n'%(table_prefix,forum_stats[fs][0],forum_stats[fs][1],forum_stats[fs][2],fs))
out.close()
print 'Elapsed Conversion Time %.02f seconds' % (time() - beg_time)
print 'Converted',len(postdata),'posts and',len(topicdata),'topics.'
raw_input("Complete! Press <enter> to exit.")
