#!/usr/bin/python
'''phpBB3 (crawler) to phpBB3 Converter by nneonneo
Version 0.3.7
Topics and Posts Part
Mar 22 2010
Updated Apr 1 2011'''
import os,re,sys,random,cgi,urllib2
from hashlib import md5
from time import strftime,strptime,mktime,time,localtime,sleep
try:
    from settings import *
    COOKIEDATA=get_cookie()
except Exception, detail:
    print "Error: Settings file has some error."
    print "Details of the error:"
    sys.excepthook(*sys.exc_info())
    raw_input("Press <enter> to quit.")
    sys.exit(1)
sys.path.append('..')
from common import *
if CONVERT_ATTACHMENTS:
    import mimetypes
    from urlparse import urljoin
    mimetypes.init()
    try:
        os.mkdir('files')
    except:
        pass

# Don't edit this file, unless you are SURE you know what you are doing.
topics_max_group = 500
posts_max_group = 200
members_max_group = 500
beg_time=time()

re_pages=re.compile('">Page <strong>1</strong> of <strong>(\\d+)</strong>') # page detection
re_forum_pages=re.compile('">Page <strong>1</strong> of <strong>(\\d+)</strong>') # page detection on forum pages
re_topicviews=re.compile(r'<dl class="icon" style="background-image: url\([^"]*?/([^/]*)\);[^"]*">\s*<dt[^>]*>.*<a[^>]*href="[^"]*t=?(\d+)[^"]*"[^>]*class="topictitle">[\w\W]*?<dd class="views">([\d,]+) <dfn>Views</dfn>')
# the massive grep list of doom!
# the grep list works by changing certain things to delimited, structured data. The delimiters are "<^>" at the start and "</^>" at the end of a record, and the fields are separated with "<|>".
# first one: detection of the exact forum we're in
repstrings=[
# detect the title of the topic
("""<h2><a [^>]*>(.+?)</a></h2>""","""<^>TITLE<|>\\1</^>"""),
# re hack: replace "unreg" with a registered user, id 0. RE doesn't work right :(
(""" /></a>by <strong>([^<]+?)</strong> &raquo;""",""" /></a>by <strong><a href="./memberlist.php?mode=viewprofile&amp;u=1">\\1</a></strong> &raquo;"""),
#'''   0      1         2         3           4           5      6      7           8           9            10             '''
#'''<^>POST<|>Post ID<|>User ID<|>User Name<|>Date/Time<|>Text<|>EDIT<|>Edit Name<|>Edit Time<|>Edit Count<|>Edit Reason</^>'''
# !!! the big one: get the entire post
("""<p class="author"><a href="[^"]*(?:p=|post)(\\d+)(?:\\.html)?#p\\1">.+? /></a>by <strong><a href="[^"]*(?:/memberlist.php\\?mode=viewprofile&amp;u=|/member/|-u)([^"]*?)(?:\\.html)?"[^>]*>(.+?)</a></strong> (?:&raquo;|on) (.+?) </p>[\\w\\W]*?<div class="content">([\\w\\W]*?)</div>\\r?\\n\\s*([\\w\\W]*?)<dl class="postprofile""","""<^>POST<|>\\1<|>\\2<|>\\3<|>\\4<|>\\5<^EDIT^>\\6</^>"""),
# attachment info
("""<\\^EDIT\\^><dl class="attachbox"[^>]*>\\s*<dt>Attachments</dt>\\s*([\\w\\W]*?\\s*</dl>)\\s*</dd>\\s*</dl>\\s*""", """<|>ATTACH<:>\\1<^EDIT^>"""),
# edit info
("""<\\^EDIT\\^></\\^>""","""</^>"""), # delete blank edit data
("""\\s*<br /><strong>Reason:</strong> <em>(.+?)</em>""","""\\1</^>"""), # clean up reason
("""<\\^EDIT\\^><div class="notice">Last edited by (?:<a[^>]*>)?(.*?)(?:</a>)? on (.*?), edited (\\d+) times? in total.(.*)[\\w\\W]*?</\\^>""","""<|>EDIT<:>\\1<:>\\2<:>\\3<:>\\4</^>"""), # convert recognizable edit data
("""<\\^EDIT\\^>[\\w\\W]*?</\\^>""", "</^>"), # delete any trailing edit data
# add a "<^>" tag to the end of the file - acts like the start of a tag
("""\\Z""","""<^>"""),
# and a "</^>" tag to the beginning - like the end of a tag
("""\\A""","""</^>"""),
# delete everything between the tags (blank space) leaving only the tags
("""</\\^>[\\w\\W]*?<\\^>""","""</^><^>"""),
# destroy any blank lines
("""^\\n""",""""""),
# and remove the blank line at the end.
("""\\n\\Z""","""""")]
# BBCode-only repstrings; these will be run exclusively on post text
bbcode_repstrings=[
# convert image links
("""<img src="([^"]+)" alt="Image" />""","[img:<UID>]\\1[/img:<UID>]"),
# convert smileys
("""<img src="[^"]+" alt="([^"]*)" title="[^"]+" />""","\\1"),
# code tags
("""<dl class="codebox"><dt>Code:(?: <a href="#"[^>]*>Select all</a>)?</dt><dd><code>""","[code:<UID>]"),
("""</code></dd></dl>""","""[/code:<UID>]"""),
# quotes: anything else (phpBB only supports author argument)
("""<blockquote><div><cite>(.+?) wrote:</cite>""","[quote=&quot;\\1&quot;:<UID>]"),
# quotes: no author
("""<blockquote class="uncited"><div>""","[quote:<UID>]"),
# quotes: closing
("""</div></blockquote>""","[/quote:<UID>]"),
# [s] tags, not supported by phpBB3
("<span><strike>|</strike></span>",""),
# emails (phpBB autoparses valid emails)
# ignore <!-- e --> type e-mails since they should be carried into the SQL (!)
("""(?<!<!-- e -->)<a href="mailto:([^"]+?)">(.+?)</a>""","""[email:<UID>]\\1[/email:<UID>]"""),
# convert local automatic links
("""<!-- l --><a class="postlink-local" href="%s([^"]*)">([^<]*)</a><!-- l -->"""%re.escape(URL), """<!-- l --><a class="postlink-local" href="%s\\1">\\2</a><!-- l -->"""%NEWURL),
# fix nested URLs
("""<a href=[^>]*><a href=([^>]*)>(.+?)</a></a>""", "<a href=\\1>\\2</a>"),
# convert URL links
("""(?<!<!-- [elmw] -->)<a href="([^"]+?)"[^>]*?>(?:<u>)?(.+?)(?:</u>)?</a>""","""[url=\\1:<UID>]\\2[/url:<UID>]"""),
# list tags
('<ol style="list-style-type: decimal">',"[list=1:<UID>]"),
('<ol style="list-style-type: lower-alpha">',"[list=a:<UID>]"),
('<ol style="list-style-type: upper-alpha">',"[list=A:<UID>]"),
("<ul>","[list:<UID>]"), # unordered
("</ol>","[/list:o:<UID>]"), # closing tag
("</ul>","[/list:u:<UID>]"), # closing tag
("<li/>(.+?)<","[*:<UID>]\\1[/*:m:<UID>]<"),
("<li>","[*:<UID>]"), # list item
("</li>","[/*:m:<UID>]"), # end tag not required
# flash
("""<object classid="clsid:D27CDB6E-AE6D-11CF-96B8-444553540000"[^>]*>.+?<embed src="([^"]+)"[^>]*width="([^"]+)" height="([^"]+)"[^>]*></embed></object>""","""[flash=\\2,\\3:<UID>]\\1[/flash:<UID>]"""),]

re_repstrings=[(re.compile(a),b) for a,b in repstrings]
re_bbcode=[(re.compile(a),b) for a,b in bbcode_repstrings]
re_ilattach=re.compile(r'<div class="inline-attachment">([\w\W]*?)\s*</div>')
re_attach=re.compile(r'<dl class="(?:file|thumbnail)"[^>]*>\s*([\w\W]*?)\s*</dl>')
re_attach_image=re.compile(r'<dt class="attach-image"[^>]*><img src="([^"]*)" alt="([^"]*)"[^>]*></dt>\s*(?:<dd><em>([^<]*)</em></dd>)?\s*<dd>.+ (?:Not viewed yet|Viewed (\d*) times?)</dd>')
re_attach_file=re.compile(r'<dt><img [^>]*>\s*<a class="postlink" href="([^"]*)">([^<]*)</a></dt>\s*(?:<dd><em>([^<]*)</em></dd>)?\s*<dd>.+ (?:Not downloaded yet|Downloaded (\d*) times?)</dd>')
re_attach_thumb=re.compile(r'<dt><a href="([^"]*)"><img src="([^"]*)" alt="([^"]*)" title=".+ (?:Not viewed yet|Viewed (\d*) times?)" /></a></dt>\s*(?:<dd> ([^<]*)</dd>)?')

# URL, ThumbURL, filename, comment, views
def get_attach(text):
    ret = None
    if not ret:
        ret = re.findall(re_attach_image, text)
        if ret:
            url, fn, comment, views = ret[0]
            thumb = None

    if not ret:
        ret = re.findall(re_attach_file, text)
        if ret:
            url, fn, comment, views = ret[0]
            thumb = None

    if not ret:
        ret = re.findall(re_attach_thumb, text)
        if ret:
            url, thumb, fn, views, comment = ret[0]

    if not ret:
        return None

    if not views: views = '0'
    return [url, thumb, fn, comment, views]

def sub_attach(post_text):
    n = len(re.findall(re_ilattach, post_text))
    ret = []
    def do_sub(m):
        d = len(ret)
        attach = get_attach(m.group(1))
        if attach is None:
            return ''
        ret.append(attach)
        fn = attach[2]
        return '[attachment=%(d)d:<UID>]<!-- ia%(d)d -->%(fn)s<!-- ia%(d)d -->[/attachment:<UID>]'%locals()
    return re.sub(re_ilattach, do_sub, post_text), ret

def dl_attach(url, progressline, userid, thumb=False):
    if thumb:
        physfn = 'thumb_'+thumb
    else:
        physfn = '%d_'%userid+md5hex('%s%s%s%s'%(url,progressline,userid,random.getrandbits(64)))
    f=open("files/"+physfn, 'wb')
    data = download_page(urljoin(URL,url.replace('&amp;','&')),progressline,COOKIEDATA)
    f.write(data)
    f.close()
    return len(data), physfn

def parsetime(tm,fmt=None): # glorious time parser, returns the UNIX time-since-epoch-in-seconds thing ;)
    try:
        return int(tm)
    except ValueError:
        if fmt is not None:
            return mktime(strptime(tm.replace("Sept","Sep"), fmt))

        for fmt in ('%Y-%m-%d, %H:%M', '%Y-%m-%d, %I:%M %p', '%a %b %d, %Y %I:%M %p'):
            try:
                return mktime(
                    strptime(
                        tm.replace("Sept","Sep").
                                       replace("<b>Today</b> at ",strftime('%Y-%m-%d, ')).
                                       replace("[b]Today[/b] at ",strftime('%Y-%m-%d, ')).
                                       replace("Today at ",strftime('%Y-%m-%d, ')).
                                       replace("Yesterday at ",strftime('%Y-%m-%d, ',localtime(time()-24*3600)))
                        ,fmt)
                    )
            except:
                pass
        raise ValueError("Couldn't parse time %s."%tm)

def parsespans(dat):
    # copied from Fora.pl converter
    sb="<span"
    se='</span>'
    begin_off=dat.find(sb)
    if begin_off==-1: return dat # no spans!
    out=dat[:begin_off] # data right up to the span
    rest=dat[begin_off+len(sb):] # the remainder, after the sb block
    lwrrest=rest.lower()
    if not lwrrest.startswith(' style="'):
        starttag=endtag=type=''
    elif lwrrest.startswith(' style="font-weight: bold"'):
        type='b'
        starttag='[b:<UID>]'
        endtag='[/b:<UID>]'
    elif lwrrest.startswith(' style="font-style: italic"'):
        type='i'
        starttag='[i:<UID>]'
        endtag='[/i:<UID>]'
    elif lwrrest.startswith(' style="text-decoration: underline"'):
        type='u'
        starttag='[u:<UID>]'
        endtag='[/u:<UID>]'
    elif lwrrest.startswith(' style="font-size: '):
        type='size'
        tagparams=rest[len(' style="font-size: '):].split(';')[0].rstrip('%')
        starttag='[size=%s:<UID>]'%tagparams
        endtag='[/size:<UID>]'
    elif lwrrest.startswith(' style="color: '):
        type="color"
        tagparams=rest[len(' style="color: '):].split('"')[0]
        starttag='[color=%s:<UID>]'%tagparams
        endtag='[/color:<UID>]'
    else:
        starttag=endtag=type=''
    spandata=starttag
    se_off=rest.find(">") # nearest span ending
    if se_off==-1:
        print "Warning: Invalid <span> found!!"
        return dat
    rest=rest[se_off+1:] # what's after the > ?
    text=rest
    nestlevel=1 # nesting level: we're inside one span
    while nestlevel:
        se_off=rest.find(se) # where's the </span>
        sb_off=rest.find(sb) # or another <span
        if se_off==-1: 
            print "Warning: No </span> found!!"
            return dat
        if sb_off==-1 or se_off<sb_off: # no new beginning (sb) before the se? good news!
            nestlevel-=1
            rest=rest[se_off+len(se):]
            continue
        elif sb_off!=-1 and sb_off<se_off: # a new beginning? darn. process it. new beginning must be before the end.
            rest=rest[sb_off+len(sb):] 
            nestlevel+=1 # increase nesting level, we won't actually process it, this just helps us find the exact block of this span
            continue
    spandata+=parsespans(text[:-(len(rest)+len(se))])+endtag # gotcha! the end of the span. Now, process the innards for nested spans.
    spandata+=parsespans(rest) # parse the rest
    return out+spandata

class ErrorIgnore(urllib2.HTTPDefaultErrorHandler):
    def http_error_default(self, req, fp, code, msg, hdrs):
        # Forumer gives 404 on nonexistent members
        # Getforum gives 500 on member pages
        if code in (404, 500):
            print
            print "HTTP Error ignored:", code, msg
            return fp
        return urllib2.HTTPDefaultErrorHandler.http_error_default(self, req, fp, code, msg, hdrs)

opener = urllib2.build_opener(ErrorIgnore)
urllib2.install_opener(opener)

''' This section will download each individual member page and process it, extracting
all the visible profile data. Members will then be renumbered according to join date
so that the member order matches the order obtained if they had signed up in phpBB.'''

print "Downloading Members..."
out=open('members_phpBB3.sql','w')
out.write('DELETE FROM '+table_prefix+'users;'+'DELETE FROM '+table_prefix+'user_group;'+'INSERT INTO '+table_prefix+'''users (user_id, user_type, group_id, username, username_clean, user_regdate, user_password, user_email, user_lang, user_style, user_rank, user_colour, user_posts, user_permissions, user_ip, user_birthday, user_lastpage, user_last_confirm_key, user_post_sortby_type, user_post_sortby_dir, user_topic_sortby_type, user_topic_sortby_dir, user_avatar, user_sig, user_sig_bbcode_uid, user_from, user_icq, user_aim, user_yim, user_msnm, user_jabber, user_website, user_occ, user_interests, user_actkey, user_newpasswd, user_allow_massemail) VALUES (1, 2, 1, 'Anonymous', 'anonymous', 0, '', '', 'en', 1, 0, '', 0, '', '', '', '', '', 't', 'a', 't', 'd', '', '', '', '', '', '', '', '', '', '', '', '', '', '', 0);INSERT INTO '''+table_prefix+'''user_group (group_id, user_id, user_pending) VALUES('1', '1', '0');''')
PM_data=open('pm_passwords.txt','w')
memberdata=[]
memberslist={}
admins = set()
for memberid in range(1,NUMUSERS+1):
    try:
        random.seed(RANDOMNUMBER+hash(memberid)) # creates static member passwords: they will never change.
        statusline="Member %s ... "%memberid
        userdata=download_page(URL+'memberlist.php?mode=viewprofile&u='+str(memberid),statusline+"Downloading - ",COOKIEDATA)
        if 'selected="selected">Bots</option>' in userdata:
            printline(statusline+"Skipping bot")
            print
            continue
        p=re.findall("""<dt>([^<>\\n]+?):</dt>\\s*<dd>([\\w\\W]*?)</dd>""", userdata) # locate all "quick info" lines
        if not p: # oops, no profile lines found
            printline(statusline+"Warning: Member doesn't exist!")
            print
            continue
        """
        Indices of "dat" mapped to phpBB phpbb_users columns
        0:user_id
        1:username
        2:[realName]
        3:user_email
        4:[websiteTitle]
        5:user_website
        6:user_birthday
        7:[gender]
        8:user_from
        9:user_posts
        10:[karmaGood] <-- warning, could be negative; I wonder how that's handled?
        11:user_regdate
        12:user_icq
        13:user_aim
        14:user_yim
        15:user_msnm
        16:user_lastvisit
        17:user_password
        18:user_avatar
        19:user_level
        20:[ID_POST_GROUP]
        21:user_occ
        22:user_interests
        23:user_jabber
        """
        dat=[memberid,'','','','','',' 0- 0-   0',0,'',0,0,0,'','','','',0,'','',0,0,'','','']
        av = re.findall('<img src="([^"]+?)" [^>]* alt="User avatar" />', userdata)
        if av:
            if av[0].startswith('./'):
                dat[18] = URL+av[0][2:]
            else:
                dat[18] = av[0]

        for t,i in p:
            try:
                t=t.strip(':')
                i=i.strip()
                if i in ['&nbsp;','&nbsp;-']: continue
                # Basic info
                if t=='Username':
                    assert i.startswith('<span')
                    dat[1]=dat[2]=re.findall('^<span[^>]*>(.+?)</span>', i)[0]
                elif t=='Rank': pass
                elif t=='Location': dat[8]=i
                elif t=='Age': pass
                elif t=='Occupation': dat[21]=i
                elif t=='Interests': dat[22]=i
                elif t=='Groups':
                    if 'selected="selected">Administrators</option>' in i:
                        dat[19]=3
                        admins.add(dat[0])
                # Contact
                elif t=='E-mail address':
                    j=re.findall('<a href="mailto:([^"]*)">', i)
                    if j: dat[3]=j[0]
                elif t=='Website':
                    dat[5]=re.findall("""<a href="([^"]+)\"""",i)[0]
                    dat[4]='Website'
                elif t=='PM': pass
                elif t=='MSNM/WLM':
                    pass
                elif t=='YIM': dat[14]=re.findall("""<a href="http://edit.yahoo.com/config/send_webmesg\\?.target=(.+?)&amp;.src=pg\"""",i)[0].replace('%40','@')
                elif t=='AIM': pass
                elif t=='ICQ': dat[12]=re.findall("""<a href="http://www.icq.com/people/webmsg.php\\?to=(.+?)\"""",i)[0]
                elif t=='Jabber': dat[23]=i
                # User statistics
                elif t=='Joined': dat[11]=parsetime(i)
                elif t=='Last visited':
                    if i not in ['Never', 'unknown', '-']:
                        dat[16]=parsetime(i)
                elif t=='Warnings': pass
                elif t=='Total posts': dat[9]=int((re.findall("^(\\d+)",i) or [i])[0])
                elif t=='Most active forum': pass
                elif t=='Most active topic': pass
                else:
                    print # blank line; prevent overwrite
                    print "\tUnknown field %s, data %s"%(t,i)
            except ValueError,detail:
                print # blank line to prevent overwrite
                print "\tError:",detail
        memberslist[dat[1]]=dat[0]
        printline(statusline+"Processing")
        password=randpw()
        dat[17]=md5hex(password) # phpBB uses md5 for password hashing
        #dat[20]=postgroup(dat[9]) # compute post group AFTER we've got the posts
        memberdata+=[dat]
        PM_data.write("%s|%s|%s\n"%(memberid,dat[1],password))
        printline(statusline+"Completed! User Password: %s"%password)
        print # blank line for next member
    except KeyboardInterrupt: break # abort processing, write out data now
    except Exception:
        do_except('Member ID %s'%memberid, statusline)
memberdata=[escape_vars(i) for i in memberdata]
for i in range(0,len(memberdata),members_max_group):
    # n.b. username _could_ be their display name, but then user sorting gets broken :'(
    out.write("INSERT INTO "+table_prefix+"users(user_id, user_type, group_id, username, username_clean, user_regdate, user_password, user_email, user_email_hash, user_lang, user_style, user_rank, user_colour, user_posts, user_permissions, user_ip, user_birthday, user_lastpage, user_last_confirm_key, user_post_sortby_type, user_post_sortby_dir, user_topic_sortby_type, user_topic_sortby_dir, user_avatar, user_sig, user_sig_bbcode_uid, user_from, user_icq, user_aim, user_yim, user_msnm, user_jabber, user_lastvisit, user_website, user_occ, user_interests, user_actkey, user_newpasswd, user_pass_convert, user_avatar_type) VALUES ")
    out.write(',\n'.join(["(%i, %i, %i, '%s', '%s', %i, '%s', '%s', '%s', 'en', 1, %i, '%s', %i, '', '', '%s', '', '', 't', 'a', 't', 'd', '%s', '', '', '%s', '%s', '%s', '%s', '%s', '%s', %i, '%s', '%s', '%s', '', '', 1, 2)" %(dat[0],dat[19],5 if dat[19] else 2,dat[1],phpbb3_username_clean(dat[1]),dat[11],dat[17],dat[3],phpbb3_email_hash(dat[3]),1 if dat[19] else 0,'AA0000' if dat[19] else '',dat[9],dat[6],dat[18],dat[8],dat[12],dat[13],dat[14],dat[15],dat[23],dat[16],dat[5],dat[21],dat[22])  for dat in memberdata[i:i+members_max_group]]))
    out.write(";\n")
    out.write("INSERT INTO "+table_prefix+"user_group (group_id, user_id, user_pending) VALUES ")
    out.write(',\n'.join(["('2', '%i', '0')"%dat[0] for dat in memberdata[i:i+members_max_group]]))
    out.write(";\n")
    for dat in memberdata[i:i+members_max_group]:
        if dat[19]==3: # admin
            out.write("INSERT INTO "+table_prefix+"user_group (group_id, user_id, user_pending, group_leader) VALUES (4, %i, 0, 0);\n"%dat[0])
            out.write("INSERT INTO "+table_prefix+"user_group (group_id, user_id, user_pending, group_leader) VALUES (5, %i, 0, 1);\n"%dat[0])
out.write(phpbb3_bots(table_prefix, max(dat[0] for dat in memberdata)+1))
PM_data.close()
out.close()


topics={}
SEEN=set()
print "Downloading Forum Structure..."
out=open("categories_forums_phpBB3.sql","w")
out.write('DELETE FROM '+table_prefix+'forums;\nDELETE FROM '+table_prefix+'acl_groups WHERE forum_id > 0;\n')
re_forumlink='<a href="[^"]*(?:f=(\\d+)|f(\\d+)\\.html)"'
re_forums='<li class="row">\\s*<dl.*?>\\s*<dt[^>]*>\\s*.*\\s*'+re_forumlink+' class="forumtitle">(.+?)</a><br />\\s*(.*)'
re_cats='<dt>'+re_forumlink+'>(.+?)</a>'

def dl_cvt_subforum(fid, left, parent, name, desc, iscat, depth=0):
    ''' recursively download and convert subforums '''
    global statusline
    if fid in SEEN:
        return left-1
    SEEN.add(fid)
    curleft=left+1
    if iscat:
        statusline = ' '*depth+"Category %s ... "%(fid or "index")
    else:
        statusline = ' '*depth+"Forum %s ... "%(fid or "index")
    progressline=statusline+"Downloading - "
    if fid==0:
        u='index.php?noportal=1'
    else:
        u='viewforum.php?f=%s'%fid
    nfid=int(fid)
    forumdata = download_page(URL+u, progressline, COOKIEDATA)
    if fid:
        pagedata=forumdata
        pages=re.findall(re_forum_pages,pagedata)
        if pages and pages[0]!='1':
            np=int(pages[0])
            perpage=re.findall('f=%s&amp;start=(\\d+)">2</a>'%fid,pagedata)
            if not perpage:
                perpage=re.findall('f%s-(\\d+)\\.html">2</a>'%fid,pagedata)
            perpage=int(perpage[0])
            for offset in range(1,np):
                progressline=statusline+"Downloading Extra Page %i of %i - "%(offset,np-1)
                pagedata+=download_page(URL+'viewforum.php?f=%s&start=%i'%(fid,offset*perpage),progressline,COOKIEDATA)
        ntopics = 0
        for status,tid,v in re.findall(re_topicviews,pagedata):
            if 'moved' in status: continue
            if int(tid) in topics: continue
            topics[int(tid)]=(nfid,int(v.replace(',','')),status)
            ntopics += 1
        if iscat and ntopics == 0:
            printline(statusline+"Completed")
        else:
            printline(statusline+"Completed: %d topic%s found"%(ntopics, int(ntopics!=1)*'s'))
        print
    else:
        printline(statusline+"Completed")
        print
    subcats = dict((k[0] or k[1], k[2]) for k in re.findall(re_cats, forumdata))
    subforums = dict((k[0] or k[1], k[2:]) for k in re.findall(re_forums, forumdata))
    sublinks = ((k[0] or k[1]) for k in re.findall(re_forumlink, forumdata))
    # Converting in the order of sublinks preserves the forum ordering.
    # Category links will precede the forum links they contain, and thus
    # by the time we get to the contained forum links, they will already have
    # been converted.
    for sfid in sublinks:
        if sfid in subcats:
            curleft=dl_cvt_subforum(sfid, curleft, nfid, subcats[sfid], '', True, depth+1)+1
        elif sfid in subforums:
            sname, sdesc = subforums[sfid]
            curleft=dl_cvt_subforum(sfid, curleft, nfid, sname, sdesc, False, depth+1)+1
    if fid:
        desc = desc.rstrip()
        if desc.endswith('</dt>'):
            desc = desc[:-len('</dt>')].rstrip()
        out.write('INSERT INTO '+table_prefix+'forums (forum_id, parent_id, left_id, right_id, forum_name, forum_desc, forum_type) VALUES (%i, %i, %i, %i, \'%s\', \'%s\', %i);\n'%((nfid, parent, left, curleft, escape_var(name), escape_var(desc), int(not iscat))))
        out.write(phpbb3_default_forum_acl(table_prefix, nfid))
    return curleft

try:
    dl_cvt_subforum(0, 1, 0, None, None, None)
    out.close()
    print "Forums: Completed: %d topic%s found"%(len(topics), int(len(topics)!=1)*'s')
except Exception:
    do_except("Categories and Forums", statusline)

topicdata,postdata=[],[]
forum_stats={} # topics, posts, latest_post_time, latest_post; this will store forum stats so we can update the DB with that information.
if CONVERT_ATTACHMENTS:
    attachments = []
for topicid in topics:
    try:
        statusline="Topic ID %i ... "%topicid
        progressline=statusline+"Downloading - "
        pagedata=download_page(URL+'viewtopic.php?t=%i'%topicid,progressline,COOKIEDATA)
        pages=re.findall(re_pages,pagedata)
        if pages and pages[0]!='1':
            np=int(pages[0])
            perpage=re.findall('t=%i&amp;start=(\\d+)">2</a>'%topicid,pagedata)
            if not perpage:
                perpage=re.findall('t%i-(\\d+)\\.html">2</a>'%topicid,pagedata)
            perpage=int(perpage[0])
            for offset in range(1,np):
                progressline=statusline+"Downloading Extra Page %i of %i - "%(offset,np-1)
                pagedata+=download_page(URL+'viewtopic.php?t=%i&start=%i'%(topicid,offset*perpage),progressline,COOKIEDATA)
        processed_data=pagedata
        cn=0
        for search,repl in re_repstrings:
            cn+=1
            printline(statusline+"Processing Step %i of %i"%(cn,len(re_repstrings)))
#           file("%i_%i.txt"%(topicid,cn),"w").write(processed_data)
            processed_data=re.sub(search,repl,processed_data)
        printline(statusline+"Converting Topic")
        forum, views, status = topics[topicid]
        title=''
        posts=[] # will hold tuples of (time,id,userid,name,edittime,editname,data)
        '''   0      1         2         3           4           5      6      7           8           9            10             '''
        '''<^>POST<|>Post ID<|>User ID<|>User Name<|>Date/Time<|>Text<|>EDIT<|>Edit Name<|>Edit Time<|>Edit Count<|>Edit Reason</^>'''
        ''' 0    1  2      3    4        5        6    7         8'''
        '''(time,id,userid,name,edittime,editname,data,editcount,editreason)'''
        for line in processed_data.split('</^><^>'):
            ln=line.strip()
            if not ln: continue
            ln=ln.split('<|>')
            if ln[0]=='TITLE' and not title:
                title=cgi.escape(ln[1])
                continue
            elif ln[0]=='POST':
                post=[0,0,1,'',0,0,'',0,'',0]
                postattach=[]
                for chunk in ln[6:]:
                    bits = chunk.split('<:>')
                    if bits[0] == 'EDIT':
                        post[4]=parsetime(bits[2])
                        post[5]=memberslist.get(bits[1],1)
                        post[7]=int(bits[3])
                        post[8]=bits[4]
                    elif bits[0] == 'ATTACH':
                        if not CONVERT_ATTACHMENTS: continue
                        post[9]=1
                        for bit in re.findall(re_attach, bits[1]):
                            attach = get_attach(bit)
                            if attach is not None:
                                postattach.append(get_attach(bit))
                post[0]=parsetime(ln[4])
                post[1]=int(ln[1])
                if ln[2]:
                    if ln[2].endswith('/'):
                        post[2] = memberslist.get(ln[2][:-1], 1)
                    else:
                        post[2] = int(ln[2])
                post[3]=ln[3]
                post_text=ln[5].strip()
                if CONVERT_ATTACHMENTS:
                    post_text, newattach = sub_attach(post_text)
                    if newattach:
                        postattach.extend(newattach[::-1])
                        post[9]=1
                for search,repl in re_bbcode:
                    post_text=re.sub(search,repl,post_text)
                post[6]=parsespans(post_text)
                posts+=[post]
                if not CONVERT_ATTACHMENTS: continue
                ''' (postid, topicid, posterid, 0, physfn, realfn, dlcount, comment, extension, mimetype, filesize, filetime, thumb) '''
                for aturl, atthumb, atfn, atcomment, atcount in postattach:
                    fsize, physfn = dl_attach(aturl, statusline+"Downloading attachment %s - "%atfn, post[2])
                    file_ext = atfn.rsplit('.',1)[1].lower()
                    if atthumb:
                        dl_attach(atthumb, statusline+"Downloading thumbnail %s - "%atfn, post[2], physfn)
                    attachments.append((post[1], topicid, post[2], 0, physfn, atfn, atcount, atcomment, file_ext, mimetypes.types_map.get('.'+file_ext, 'application/octet-stream'), fsize, post[0], (atthumb is not None)*1))
        if not posts:
            printline(statusline+"Error: Topic is empty!")
            print # a blank line, for the next topic
            continue
        posts.sort(key=lambda x:x[0]) # sort by date code only
        if forum not in forum_stats: forum_stats[forum]=[0,0,0,None]
        fs = forum_stats[forum]
        fs[0] += 1
        fs[1] += len(posts)
        lastpost = posts[-1]
        if lastpost[0] > fs[2]:
            fs[2] = lastpost[0]
            fs[3] = lastpost
        # change this for a different forum
        if 'sticky' in status:
            topictype = 1
        elif 'announce' in status:
            topictype = 2
        else:
            topictype = 0
        topicdata+=[(topicid,topictype,forum,posts[0][1],posts[0][3],posts[-1][1],posts[-1][2],posts[-1][3],title,posts[-1][0],posts[0][2],posts[0][0],title,len(posts)-1,len(posts)-1,views,int('locked' in status))]
        for post in posts:
            ''' 0    1  2      3    4        5        6    '''
            '''(time,id,userid,name,edittime,editname,data)'''
            # change this for a different forum
            bbcode_uid=''.join([random.choice('abcdefghijklmnopqrstuvwxyz0123456789') for __ in xrange(8)])
            bbcode_bitfield=phpbb3_makebitfield(post[6]).strip()
            post[6]=post[6].replace(":<UID>",":"+bbcode_uid).replace('<br />','\n')
            postdata+=[[post[1],topicid,forum,post[2],post[0],'',post[3],post[4],post[7],post[5],title,post[6],bbcode_uid,md5(post[6]).hexdigest(),bbcode_bitfield,post[8],post[9]]]
        printline(statusline+"Completed: %i post%s"%(len(posts),int(len(posts)!=1)*'s'))
        print # blank line for next topic
    except KeyboardInterrupt: break
    except Exception:
        do_except("Topic ID %i"%topicid, statusline)

out=open('topics_posts_phpBB3.sql','w')
out.write('DELETE FROM %stopics;DELETE FROM %stopics_posted;DELETE FROM %sposts;'%(table_prefix,table_prefix,table_prefix))
if CONVERT_ATTACHMENTS:
    out.write('DELETE FROM %sattachments;'%(table_prefix))
    for i in attachments:
        out.write("INSERT INTO %sattachments (post_msg_id,topic_id,poster_id,is_orphan,physical_filename,real_filename,download_count,attach_comment,extension,mimetype,filesize,filetime,thumbnail) VALUES "%table_prefix)
        out.write('('+','.join("'%s'"%escape_var(x) for x in i)+')')
        out.write(';\n')
# change these two for a different forum
topicdata_vals=[escape_vars(i) for i in topicdata]
postdata=[escape_vars(i) for i in postdata]
for i in range(0,len(topicdata_vals),topics_max_group):
    out.write("INSERT INTO %stopics (topic_id,topic_type,forum_id,topic_first_post_id,topic_first_poster_name,topic_last_post_id,topic_last_poster_id,topic_last_poster_name,topic_last_post_subject,topic_last_post_time,topic_poster,topic_time,topic_title,topic_replies,topic_replies_real,topic_views,topic_status) VALUES "%table_prefix)
    out.write(',\n'.join(["(%i,%i,%i,%i,'%s',%i,%i,'%s','%s',%i,%i,%i,'%s',%i,%i,%i,%i)"%tuple(td) for td in topicdata_vals[i:i+topics_max_group]]))
    out.write(";\n")
    out.write("INSERT INTO %stopics_posted (user_id, topic_id, topic_posted) VALUES "%table_prefix)
    out.write(',\n'.join(',\n'.join(["(%i, %i, 1)"%(k,td[0]) for k in set([p[3] for p in postdata if p[1]==td[0]])]) for td in topicdata_vals[i:i+topics_max_group]))
    out.write(";\n")
for i in range(0,len(postdata),posts_max_group):
    out.write("INSERT INTO %sposts (post_id,topic_id,forum_id,poster_id,post_time,poster_ip,post_username,post_edit_time,post_edit_count,post_edit_user,post_subject,post_text,bbcode_uid,post_checksum,bbcode_bitfield,post_edit_reason,post_attachment) VALUES "%table_prefix)
    out.write(',\n'.join(["(%i,%i,%i,%i,%i,'%s','%s',%i,%i,%i,'%s','%s','%s','%s','%s','%s',%d)"%tuple(pd) for pd in postdata[i:i+posts_max_group]]))
    out.write(";\n")
for fs in forum_stats:
    out.write('UPDATE `%sforums` SET forum_topics=%i,forum_topics_real=%i,forum_posts=%i WHERE forum_id=%i;\n'%(table_prefix,forum_stats[fs][0],forum_stats[fs][0],forum_stats[fs][1],fs))
    post = forum_stats[fs][3]
    if post is not None:
        '''(time,id,userid,name,edittime,editname,data,editcount,editreason)'''
        out.write("UPDATE `%sforums` SET forum_last_post_id=%i,forum_last_post_subject='%s',forum_last_post_time=%i,forum_last_poster_id=%i,forum_last_poster_name='%s',forum_last_poster_colour='%s' WHERE forum_id=%i;\n"%(table_prefix,post[1],escape_var(post[9]),post[0],post[2],escape_var(post[3]),"AA0000" if post[2] in admins else '',fs))
out.close()
print 'Elapsed Conversion Time %.02f seconds' % (time() - beg_time)
print 'Converted',len(postdata),'posts and',len(topicdata),'topics.'
raw_input("Complete! Press <enter> to exit.")
